SystemOrganization addCategory: #Nautilus!
SystemOrganization addCategory: #'Nautilus-MonticelloAnnouncements'!
SystemOrganization addCategory: #'Nautilus-MorphTreeWidget-Extension'!
SystemOrganization addCategory: #'Nautilus-Tests'!
SystemOrganization addCategory: #'Nautilus-Widgets'!

TestCase subclass: #AbstractNautilusUITest
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Tests'!

!AbstractNautilusUITest commentStamp: '<historical>' prior: 0!
An AbstractNautilusUITest is a test class for testing the behavior of AbstractNautilusUI!

!AbstractNautilusUITest methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 17:19'!
setUp
	"Setting up code for AbstractNautilusUITest"

	model := AbstractNautilusUI new.! !

!AbstractNautilusUITest methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 17:19'!
tearDown
	"Tearing down code for AbstractNautilusUITest"

! !

!AbstractNautilusUITest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 2/7/2012 17:17'!
testSortClassesInCachedHierarchyB! !

TestCase subclass: #NautilusTest
	instanceVariableNames: 'nautilus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Tests'!

!NautilusTest commentStamp: '<historical>' prior: 0!
NautilusTest is a set of test for Nautilus!

!NautilusTest methodsFor: 'running' stamp: 'BenjaminVanRyseghem 8/21/2011 12:23'!
setUp

	nautilus := Nautilus new.! !

!NautilusTest methodsFor: 'running' stamp: 'BenjaminVanRyseghem 8/21/2011 12:24'!
tearDown

	nautilus := nil.! !

!NautilusTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 2/7/2012 17:17'!
testCorrespondingMethods

	self assert: ((Dictionary>>#associations) == (DictionaryTest>>#testAssociations) correspondingMethods first).
	self assert: ((Dictionary>>#add:) == (DictionaryTest>>#testAdd) correspondingMethods first).
	self assert: ((Dictionary>>#at:put:) == (DictionaryTest>>#testAtPut) correspondingMethods first).! !

!NautilusTest methodsFor: 'tests' stamp: 'AlexandreBergel 8/21/2011 17:21'!
testCorrespondingTestClass
	self assert: (Behavior correspondingForTest == BehaviorTest).
	self assert: (TTCFont correspondingForTest == TTCFont).
	self assert: (BehaviorTest correspondingForTest == Behavior).! !

!NautilusTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/18/2012 16:15'!
testCorrespondingTestMethod

	self assert: ((Dictionary>>#associations) correspondingTestMethod == (DictionaryTest>>#testAssociations)).
	self assert: ((Dictionary>>#add:) correspondingTestMethod == (DictionaryTest>>#testAdd)).
	self assert: ((Dictionary>>#at:put:) correspondingTestMethod == (DictionaryTest>>#testAtPut)).! !

!NautilusTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 8/21/2011 13:32'!
testSelectedCategory

	self assert: nautilus selectedMethod isNil.
	nautilus selectedMethod: (Object>>#at:).
	nautilus selectedCategory: 'test'.
	self assert: (nautilus selectedCategory = 'test').
	self assert: (nautilus selectedMethod isNil)! !

!NautilusTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 8/21/2011 13:33'!
testSelectedClass

	self assert: nautilus selectedMethod isNil.
	nautilus selectedMethod: (Object>>#at:).
	nautilus selectedCategory: 'test'.
	self assert: (nautilus selectedCategory = 'test').
	self assert: (nautilus selectedMethod isNil).
	
	nautilus selectedClass: Morph.
	self assert: (nautilus selectedClass = Morph).
	self assert: (nautilus selectedCategory isNil).
	self assert: (nautilus selectedMethod isNil).! !

!NautilusTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 8/21/2011 12:46'!
testSelectedMethod

	self assert: nautilus selectedMethod isNil.
	nautilus selectedMethod: (Object>>#at:).
	self assert: (nautilus selectedMethod = (Object>>#at:))! !

TestCase subclass: #NautilusUITest
	instanceVariableNames: 'nautilusUI'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Tests'!

!NautilusUITest commentStamp: '<historical>' prior: 0!
A NautilusUITest is a test class for testing the behavior of NautilusUI!

!NautilusUITest methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/19/2012 17:08'!
setUp
	"Setting up code for NautilusUITest"


	nautilusUI := NautilusUI on: Nautilus new.! !

!NautilusUITest methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/19/2012 17:07'!
tearDown
	"Tearing down code for NautilusUITest"


	nautilusUI := nil.! !

!NautilusUITest methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 1/19/2012 17:09'!
testBuildTestSelectorFor

	| method selector |
	method := EventHandler >> #keyStroke:fromMorph:.
	selector := nautilusUI buildTestSelectorFor: method.
	self assert: (selector = 'testKeyStrokeFromMorph')! !

AbstractTool subclass: #AbstractNautilusUI
	instanceVariableNames: 'model window hierarchyClass cachedHierarchy sourceTextArea firstColumn secondColumn groupsSelection packagesSelection classesSelection list list2 sourceCodePanel commentTextArea currentDisplayChoice sourceTextAreaLimit sourceCodeContainer list2Elements listElements hierarchyButton'
	classVariableNames: 'ClassesIconsCache GroupsIconsCache Icon PackagesIconsCache'
	poolDictionaries: ''
	category: 'Nautilus'!

!AbstractNautilusUI commentStamp: '<historical>' prior: 0!
An AbstractNautilusUI is an abstraction of the UI handling packages and classes.

Instance Variables
	cachedHierarchy:		<Object>
	classesSelection:		<Object>
	commentButton:		<Object>
	commentTextArea:		<Object>
	currentDisplayChoice:		<Object>
	firstColumn:		<Object>
	groupsSelection:		<Object>
	hierarchyClass:		<Object>
	list:		<Object>
	list2:		<Object>
	model:		<Object>
	packagesSelection:		<Object>
	secondColumn:		<Object>
	sourceCodeContainer:		<Object>
	sourceCodePanel:		<Object>
	sourceTextArea:		<Object>
	sourceTextAreaLimit:		<Object>
	window:		<Object>!

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/20/2012 19:33'!
buildAnalyzingSubMenu: aBuilder target: target
	<nautilusClassMenu>

	target selectedClass ifNil: [^target].

	(aBuilder item: #'Inst var references...')
		action: [target browseInstVarRefs];
		parent: #Analyzing;
		order: 0.

	(aBuilder item: #'Inst var assignments...')
		action: [target browseInstVarDefs];
		parent: #Analyzing;
		order: 100.

	(aBuilder item: #'Create inst var accessors')
		action: [target createInstVarAccessors];
		parent: #Analyzing;
		enabledBlock: [ target selectedClass instVarNames isEmpty not ];
		order: 200;
		withSeparatorAfter.
	
	(aBuilder item: #'Create initializer with inst vars...')
		action: [ target createInitializerWithInstVars ];
		parent: #Analyzing;
		order: 300;
		enabledBlock: [ target showInstance ].
	
	(aBuilder item: #'Generate initialize method (I)')
		action: [ target generateInitialize ];
		parent: #Analyzing;
		order: 350.
		
	(aBuilder item: #'Force the generaton of the initialize method (K)')
		action: [ target forceGenerateInitialize ];
		parent: #Analyzing;
		order: 375;
		enabledBlock: [ target showInstance ];
		withSeparatorAfter.

	(aBuilder item: #'Class var refs...')
		action: [target browseClassVarRefs];
		parent: #Analyzing;
		order: 400.
		
	(aBuilder item: #'Class refs... (N)')
		action: [target browseClassRefs];
		parent: #Analyzing;
		order: 500.
		
	(aBuilder item: #'Browse comment versions... (v)')
		action: [ target browseCommentVersionsOf: {target selectedClass} ];
		parent: #Analyzing;
		order: 600;
		withSeparatorAfter.

	(target selectedClass inheritsFrom: SharedPool )
		ifTrue: [ 
			(aBuilder item: #'Shared Pool Users')
				action: [ target systemNavigation browseSharedPoolUsersOf: target selectedClass ];
				parent: #Analyzing;
				enabledBlock: [ target enableSingleClassSelection ];
				order: 700].
		
		
	(aBuilder item: #'Unsent methods...')
		action: [target browseUnusedMethods.];
		parent: #Analyzing;
		order: 800.
	
	(aBuilder item: #'Unreferenced inst vars...')
		action: [target showUnreferencedInstVars.];
		parent: #Analyzing;
		order: 900.
		
	(aBuilder item: #'Unreferenced class vars...')
		action: [target showUnreferencedClassVars.];
		parent: #Analyzing;
		order: 1000.! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/20/2012 20:30'!
buildClassShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #fullBrowse)
		category: #NautilusClassShortcuts
		default: $b command
		do: [ :target | target fullBrowse ].
		
	(aBuilder shortcut: #restrictedBrowseClass)
		category: #NautilusClassShortcuts
		default: $b command shift
		do: [ :target | target restrictedBrowseClass ].

	(aBuilder shortcut: #copyClass)
		category: #NautilusClassShortcuts
		default: $c command
		do: [ :target | target copyClass ].
	
	(aBuilder shortcut: #addClassInGroup)
		category: #NautilusClassShortcuts
		default: $e command
		do: [ :target | target addClassInGroup ].
	
	(aBuilder shortcut: #findMethod)
		category: #NautilusClassShortcuts
		default: $f command
		do: [ :target | target findMethod ].
		
	(aBuilder shortcut: #findClass)
		category: #NautilusClassShortcuts
		default: $f command shift
		do: [ :target | target findClass ].
		
	(aBuilder shortcut: #generateInitialize)
		category: #NautilusClassShortcuts
		default: $i command shift
		do: [ :target | target generateInitialize ].
		
	(aBuilder shortcut: #createTestForSelectedClass)
		category: #NautilusClassShortcuts
		default: $j command
		do: [ :target | target enableSingleClassSelection ifTrue: [ target createTestForSelectedClass ]].
		
	(aBuilder shortcut: #forceGenerateInitialize)
		category: #NautilusClassShortcuts
		default: $k command shift
		do: [ :target | target forceGenerateInitialize ].
		
	(aBuilder shortcut: #browseClassRefs)
		category: #NautilusClassShortcuts
		default: $n command shift
		do: [ :target | target browseClassRefs ].
	
	(aBuilder shortcut: #addClass)
		category: #NautilusClassShortcuts
		default: $n command
		do: [ :target | target addClass ].
		
	(aBuilder shortcut: #renameClass)
		category: #NautilusClassShortcuts
		default: $r command
		do: [ :target | target enableSingleClassSelection ifTrue: [ target renameClass ]].
		
	(aBuilder shortcut: #runClassTests)
		category: #NautilusClassShortcuts
		default: $t command
		do: [ :target | target runClassTests ].
		
	(aBuilder shortcut: #removeClasses)
		category: #NautilusClassShortcuts
		default: $x command
		do: [ :target | target removeClasses ].! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/21/2012 16:01'!
buildGroupShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #fullBrowse)
		category: #NautilusGroupShortcuts
		default: $b command
		do: [ :target | target fullBrowse ].
		
	(aBuilder shortcut: #restrictedBrowseGroup)
		category: #NautilusGroupShortcuts
		default: $b command shift
		do: [ :target | target  restrictedBrowseGroup: target selectedGroups ].
	
	(aBuilder shortcut: #findClass)
		category: #NautilusGroupShortcuts
		default: $f command
		do: [ :target | target findClass ].
	
	(aBuilder shortcut: #renameGroup)
		category: #NautilusGroupShortcuts
		default: $r command
		do: [ :target | target enableSingleMenuItems ifTrue:[ target renameGroup ]].
	
	(aBuilder shortcut: #runTestsOfGroups)
		category: #NautilusGroupShortcuts
		default: $t command
		do: [ :target | target runTestsOfGroups: target selectedGroup ].
		
	(aBuilder shortcut: #removeGroup)
		category: #NautilusGroupShortcuts
		default: $x command
		do: [ :target | target removeGroup ].! !

!AbstractNautilusUI class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 6/2/2011 17:05'!
buildIcon

	| bitmap |
	bitmap :=  (Bitmap new: 256) copyFromByteArray:   #[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 255 249 235 15 254 248 233 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 183 102 33 13 162 147 126 14 199 176 153 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 143 187 142 101 94 197 140 89 0 0 0 0 208 181 135 93 108 190 134 85 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 144 159 121 84 174 168 127 90 119 181 140 104 194 182 128 81 24 207 148 99 4 252 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 159 170 119 70 255 200 124 58 253 189 122 63 60 148 118 91 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 199 157 91 59 255 222 129 64 255 201 118 48 178 152 100 49 73 138 112 54 106 168 135 62 167 206 169 100 193 191 158 105 115 172 143 97 0 0 0 0 5 155 136 98 55 204 190 157 10 236 223 187 0 0 0 0 21 105 87 68 91 162 123 78 240 187 126 60 255 212 131 43 253 227 148 48 255 218 157 63 255 233 175 78 255 235 176 64 255 224 167 68 255 232 171 81 255 216 168 74 109 181 145 85 21 154 136 98 245 194 174 137 33 211 209 190 81 172 145 107 241 194 152 81 255 207 158 80 255 243 176 64 254 246 176 67 254 208 141 49 255 221 156 81 255 200 123 54 255 209 137 56 255 187 124 56 254 204 128 48 255 248 183 62 230 171 125 65 0 0 0 0 198 196 161 122 135 198 161 130 238 191 139 90 255 227 158 63 254 234 165 51 254 244 172 65 255 227 160 65 254 170 105 26 255 209 144 65 254 185 117 40 253 213 143 55 252 221 143 58 248 238 144 58 255 223 134 39 250 163 97 51 20 231 255 255 185 186 137 106 255 181 122 80 255 162 85 36 255 221 124 53 255 234 154 50 255 234 170 61 255 232 168 69 255 220 149 53 255 238 159 56 255 241 163 59 255 231 158 59 255 226 151 64 255 198 120 54 215 166 91 43 57 133 68 38 13 210 220 210 83 199 158 129 209 203 160 125 129 184 139 102 235 161 83 47 255 190 102 41 255 203 112 40 255 208 117 47 253 213 121 50 251 208 122 55 222 185 106 44 175 159 100 50 139 141 103 65 53 156 105 65 9 99 69 79 0 0 0 0 0 0 0 0 0 0 0 0 143 155 129 114 0 0 0 0 10 138 135 170 65 108 49 22 87 138 77 48 93 129 70 41 45 93 34 6 26 68 32 26 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 197 179 174 0 0 0 0 93 197 180 176 4 202 182 170 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 180 88 18 2 146 92 49 1 128 100 73 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0].
	^ Form extent: 16@16 depth: 32 bits: bitmap! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/20/2012 03:22'!
buildListShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #stackDown)
		category: #NautilusListShortcuts
		default: $b command
		do: [ :target | target fullBrowse ].! !

!AbstractNautilusUI class methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/20/2012 20:07'!
buildPackageShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #fullBrowse)
		category: #NautilusPackageShortcuts
		default: $b command
		do: [ :target | target fullBrowse ].

	(aBuilder shortcut: #restrictedBrowse)
		category: #NautilusPackageShortcuts
		default: $b command shift
		do: [ :target | target restrictedBrowsePackage ].
		
	(aBuilder shortcut: #addPackageInGroup)
		category: #NautilusPackageShortcuts
		default: $e command
		do: [ :target | target addPackageInGroup ].
		
	(aBuilder shortcut: #findClass)
		category: #NautilusPackageShortcuts
		default: $f command
		do: [ :target | target findClass ].
		
	(aBuilder shortcut: #findPackage)
		category: #NautilusPackageShortcuts
		default: $f command shift
		do: [ :target | target findPackage ].

	(aBuilder shortcut: #addPackageAsGroupsAndBrowse)
		category: #NautilusPackageShortcuts
		default: $g command
		do: [ :target | target addPackageAsGroupsAndBrowse ].
	
	(aBuilder shortcut: #addPackageAsGroups)
		category: #NautilusPackageShortcuts
		default: $g command shift
		do: [ :target | target addPackageAsGroups ].
	
	(aBuilder shortcut: #addMatchingPackagesInGroupsAndBrowse)
		category: #NautilusPackageShortcuts
		default: $m command
		do: [ :target | target addMatchingPackagesInGroupsAndBrowse ].
	
	(aBuilder shortcut: #addMatchingPackagesInGroups)
		category: #NautilusPackageShortcuts
		default: $m command shift
		do: [ :target | target addMatchingPackagesInGroups ].
		
	(aBuilder shortcut: #addPackage)
		category: #NautilusPackageShortcuts
		default: $n command 
		do: [ :target | target addPackage ].
	
	(aBuilder shortcut: #renamePackage)
		category: #NautilusPackageShortcuts
		default: $r command 
		do: [ :target | target enableSingleMenuItems ifTrue: [ target renamePackage ]].	
	
	(aBuilder shortcut: #runPackagesTests)
		category: #NautilusPackageShortcuts
		default: $t command 
		do: [ :target | target runPackagesTests ].
	
	(aBuilder shortcut: #removePackages)
		category: #NautilusPackageShortcuts
		default: $x command 
		do: [ :target | target removePackages ].! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/21/2012 16:00'!
classesFixMenu: aBuilder target: target
	<nautilusClassFixMenu>

	(aBuilder item: #'Find Method... (f)')
		action: [target findMethod];
		order: 0;
		help: 'Search for a method by selector'.
		
	(aBuilder item: #'Find Class... (F)')
		action: [ target findClass ];
		order: 100;
		help: 'Search for a method by selector';
		withSeparatorAfter.
	
	(aBuilder item: #'Add class... (n)')
		action: [ target addClass ];
		order: 200;
		help: 'Create a new class'.
	(aBuilder item: #'Add trait...')
		action: [ target addTrait ];
		order: 300;
		withSeparatorAfter.
		
	(aBuilder item: #'Browse full (b)')
		action: [target fullBrowse];
		order: 999;
		help: 'Open the same browser'.! !

!AbstractNautilusUI class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/23/2011 16:22'!
classesIconsCache: anObject
	
		ClassesIconsCache := anObject! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/20/2012 20:27'!
classesMenu: aBuilder target: target
	<nautilusClassMenu>

	target selectedClass ifNil: [^target].
		
	(aBuilder item: #'Browse restricted (B)')
		action: [target restrictedBrowseClass];
		order: 1000;
		help: 'Open a browser on a restricted view';
		withSeparatorAfter.
	
	(target selectedClasses allSatisfy: [:each | each inheritsFrom: TestCase ])
			ifTrue:[	
					(aBuilder item:#'Run tests (t)')
						action: [ target runClassTests ];
						order: 1100].
						
	(aBuilder item: #Analyzing)
		enabledBlock: [ target selectedClasses size <= 1 ];
		order: 1200.

	(aBuilder item: #'Jump to test class')
		action: [ target createTestForSelectedClass ];
		enabledBlock: [ target selectedClasses size <= 1 ];
		order: 1300.
		
		
	(aBuilder item: #'Move to package...')
		action: [ target moveInNewPackage ];
		order: 1400.	

	(aBuilder item: #'Rename... (r)')
		action: [ target renameClass ];
		enabledBlock: [ target selectedClasses size <= 1 ];
		order: 1500.	
			
	(aBuilder item: #'Copy... (c)')
		action: [ target copyClass ];
		order: 1600.	
			
	(aBuilder item: #'Remove... (x)')
		action: [ target removeClasses ];
		icon: (target iconClass iconNamed: #removeIcon);
		order: 1700;
		withSeparatorAfter.
			
	(aBuilder item: #'File Out')
		action: [ target fileOutClass ];
		withSeparatorAfter;
		order: 1800.	
			
	target showGroups
		ifTrue: [
			target selectedGroup isReadOnly 
				ifFalse: [
					(aBuilder item: #'Remove from Group (X)')
						action: [ target removeClassFromGroup ];
						order: 1900]].
				
	(aBuilder item: #'Add in Group... (e)')
				action: [ target addClassInGroup ];
				order: 2000! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/20/2012 18:56'!
debugMenu: aBuilder target: target

<nautilusMethodMenu>
<nautilusProtocolMenu>
<nautilusClassMenu>
<nautilusPackageMenu>
<nautilusGroupMenu>

(aBuilder item: #DebugMenu)
		order: 9999;
		label: 'DEBUG';
		help: 'Open a browser on a restricted view'.
		
(aBuilder item: #'Reset icons caches')
		order: 0;
		action: [ 
			AbstractNautilusUI resetIconCaches.
			AbstractMethodWidget resetMethodsIconsCache ];
		parent: #DebugMenu;
		help: 'Open a browser on a restricted view'.
		
(aBuilder item: #'Inspect me')
		order: 100;
		action: [ target inspect ];
		parent: #DebugMenu;
		help: 'Open a browser on a restricted view'.
		
(aBuilder item: #'Inspect my model ')
		order: 200;
		action: [ target model inspect];
		parent: #DebugMenu;
		help: 'Open a browser on a restricted view'.! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/20/2012 18:51'!
groupsFixMenu: aBuilder target: target
	<nautilusGroupFixMenu>

	(aBuilder item: #'Find Class... (f)')
		action: [target findClass];
		order: 0;
		help: 'Search for a class by name';
		withSeparatorAfter.
	
	(aBuilder item: #'Browse full (b)')
		action: [target fullBrowse];
		order: 999.! !

!AbstractNautilusUI class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/23/2011 16:22'!
groupsIconsCache

		^ GroupsIconsCache! !

!AbstractNautilusUI class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/23/2011 16:22'!
groupsIconsCache: anObject
	
		GroupsIconsCache := anObject! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/20/2012 18:51'!
groupsMenu: aBuilder target: target
	<nautilusGroupMenu>

	target selectedGroup ifNil: [ ^ target ].
		
	(aBuilder item: #'Browse restricted (B)')
		action: [ target restrictedBrowseGroup: target selectedGroups ];
		order: 1000;
		withSeparatorAfter.
		
	(aBuilder item: #'Run tests (t)')
		action: [ target runTestsOfGroups: target selectedGroups ];
		order: 1100.
				
	(aBuilder item: #'Merge groups')
		action: [target mergeGroups];
		enabledBlock: [ target selectedGroups size > 1];
		order: 1200.

	target selectedGroup isNil
		ifFalse: [
			target selectedGroup isReadOnly
				ifFalse: [
					(aBuilder item: #'Rename... (r)')
						action: [target renameGroup];
						enabledBlock: [ target selectedGroups size <= 1];
						order: 1300 ].
			target selectedGroup removable
				ifTrue: [
					(aBuilder item: #'Remove groups (x)')
						icon: (target iconClass iconNamed: #removeIcon);
						action: [target removeGroup];
						order: 1400 ]]! !

!AbstractNautilusUI class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/12/2011 18:10'!
icon

	^ Icon! !

!AbstractNautilusUI class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/12/2011 18:10'!
icon: anObject
	
	Icon := anObject! !

!AbstractNautilusUI class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 8/19/2011 16:07'!
iconClass

	^ NautilusIcons! !

!AbstractNautilusUI class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/8/2012 16:58'!
initialize

	" self initialize "
	super initialize.
	ClassesIconsCache := IdentityDictionary new.
	GroupsIconsCache := IdentityDictionary new.
	PackagesIconsCache := IdentityDictionary new.
	
	Icon := self buildIcon! !

!AbstractNautilusUI class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/2/2011 17:08'!
on: aNautilus

	^ self new model: aNautilus! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/20/2012 18:50'!
packagesFixMenu: aBuilder target: target
	<nautilusPackageFixMenu>

	(aBuilder item: #'Find Class... (f)')
		action: [target findClass];
		order: 0;
		help: 'Search for a class by name'.
		
	(aBuilder item: #'Find Package... (F)')
		action: [ target findPackage ];
		order: 100;
		help: 'Search for a package by name';
		withSeparatorAfter.
		
	(aBuilder item: #'Add package... (n)')
		action: [target addPackage];
		order: 200;
		help: 'Add a package';
		withSeparatorAfter.
		
	(aBuilder item: #'Browse full (b)')
		action: [target fullBrowse];
		order: 999;
		help: 'Open the same browser'.! !

!AbstractNautilusUI class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/23/2011 16:22'!
packagesIconsCache

		^ PackagesIconsCache! !

!AbstractNautilusUI class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/23/2011 16:22'!
packagesIconsCache: anObject
	
		PackagesIconsCache := anObject! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/21/2012 08:59'!
packagesMenu: aBuilder target: target
	<nautilusPackageMenu>

	target selectedPackage ifNil: [ ^ target ].
	
	(aBuilder item: #'Browse restricted (B)')
		action: [ target restrictedBrowsePackage ];
		order: 1000;
		help: 'Open a browser on a restricted view';
		withSeparatorAfter.
				
	(aBuilder item: #'Rename... (r)')
		action: [target renamePackage];
		order: 1100;
		help: 'Rename a package';
		enabledBlock: [ target selectedPackages size = 1 ].
		
	(aBuilder item: #'Remove... (x)')
		action: [target removePackages ];
		order: 1200;
		help: 'Remove a package';
		icon: (target iconClass iconNamed: #removeIcon).
		
	(aBuilder item: #'Run tests... (t)')
		action: [target runPackagesTests ];
		enabled: (target selectedPackage classes anySatisfy: [:e | e inheritsFrom: TestCase ]);
		order: 1250;
		help: 'Run tests';
		withSeparatorAfter.
		
	(aBuilder item: #'File Out')
		action: [target fileOutPackage];
		order: 1300;
		help: 'File out a package';
		withSeparatorAfter.
		
	
	
	target selectedPackages size > 1
		ifTrue: [
			(aBuilder item: #'Add as Groups & Browse (g)')
				action: [ target addPackageAsGroupsAndBrowse ];
				order: 1400;
				help: 'Create a group based on the current package and browse it'.
				
			(aBuilder item: #'Add as Group & Browse')
				action: [ target addPackageAsGroupAndBrowse ];
				order: 1500;
				help: 'Create a group based on the current package and browse it'.

			(aBuilder item: #'Add as Groups (G)')
				action: [ target addPackageAsGroups ];
				order: 1600;
				help: 'Create a group based on the current package'.

			(aBuilder item: #'Add as Group')
				action: [target addPackageAsGroup];
				order: 1700;
				help: 'Create a group based on the current package'.	
					]
		ifFalse: [
			(aBuilder item: #'Add as Group & Browse (g)')
				action: [ target addPackageAsGroupAndBrowse ];
				order: 1500;
				help: 'Create a group based on the current package and browse it'.
				
			(aBuilder item: #'Add as Group (G)')
				action: [target addPackageAsGroup];
				order: 1700;
				help: 'Create a group based on the current package'.	
	].			
			
		
	(aBuilder item: #'Add Matching Packages as Groups and Browse (m)')
		action: [ target addMatchingPackagesInGroupsAndBrowse ];
		order: 1800.
	
	(aBuilder item: #'Add in Group... (e)')
		action: [target addPackageInGroup];
		order: 1900;
		help: 'Add current package in a group'.! !

!AbstractNautilusUI class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 6/2/2011 17:08'!
resetIcon

	Icon := nil! !

!AbstractNautilusUI class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 2/8/2012 16:58'!
resetIconCaches

	ClassesIconsCache := IdentityDictionary new.
	GroupsIconsCache := IdentityDictionary new.
	PackagesIconsCache := IdentityDictionary new.! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/20/2012 18:53'!
shiftedSourceCodeMenu: aBuilder
	<nautilusSourceCodeMenu>
	| donorMenu items |
	items := OrderedCollection new.
	donorMenu := SmalltalkEditor shiftedYellowButtonMenu.
	donorMenu submorphs doWithIndex: [:each :order |
		(each isKindOf: MenuLineMorph)
			ifTrue: [ items last withSeparatorAfter ]
			ifFalse: [
				items add: ((aBuilder item: each contents asSymbol)
								selector: each selector;
								target: each target;
								parent: #'Extended search...';
								arguments: each arguments;
								order: order).
				each icon ifNotNil: [:ic | items last icon: ic ]]].
	(items last: 2) doWithIndex: [:e :i | e order: (9998 + i) ]! !

!AbstractNautilusUI class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/20/2012 18:53'!
sourceCodeMenu: aBuilder
	<nautilusSourceCodeMenu>
	
	| donorMenu items |
	items := OrderedCollection new.
	donorMenu := SmalltalkEditor yellowButtonMenu.
	donorMenu submorphs doWithIndex: [:each :order |
		(each isKindOf: MenuLineMorph)
			ifTrue: [ items last withSeparatorAfter ]
			ifFalse: [
				items add: ((aBuilder item: each contents asSymbol)
								selector: each selector;
								target: each target;
								arguments: each arguments;
								order: order).
				each icon ifNotNil: [:ic | items last icon: ic ]]].
	(items last: 2) doWithIndex: [:e :i | e order: (9998 + i) ]! !

!AbstractNautilusUI methodsFor: 'group announcements' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
aGroupHasBeenAdded: anAnnouncement
	 "(NautilusUI methodDict at: #aGroupHasBeenRegistered:) getSource"

	| group |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	group := anAnnouncement group.
	(self groupsManager includes: group)
		ifTrue: [ self updateGroupView ]! !

!AbstractNautilusUI methodsFor: 'group announcements' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
aGroupHasBeenRegistered: anAnnouncement
	 "(NautilusUI methodDict at: #aGroupHasBeenRegistered:) getSource"

	| group |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	group := anAnnouncement group.
	(self groupsManager includes: group)
		ifTrue: [ self updateGroupView ]! !

!AbstractNautilusUI methodsFor: 'group announcements' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
aGroupHasBeenRemoved: anAnnouncement
	 "(NautilusUI methodDict at: #aGroupHasBeenRegistered:) getSource"

	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	(self groupsManager =  anAnnouncement holder)
		ifTrue: [ 
			self selectedGroup = anAnnouncement group
				ifTrue: [ self selectedGroup: nil ].
			self updateGroupView.
			self update ]! !

!AbstractNautilusUI methodsFor: 'group announcements' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
aGroupHasBeenRenamed: anAnnouncement
	 "(NautilusUI methodDict at: #aGroupHasBeenRegistered:) getSource"

	| group |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	group := anAnnouncement group.
	(self groupsManager includes: group)
		ifTrue: [ self updateGroupView ]! !

!AbstractNautilusUI methodsFor: 'group announcements' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
aGroupHasBeenUnregistered: anAnnouncement

	| group |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [^ self ].
	self showGroups ifFalse: [ ^ self ].
	group := anAnnouncement group.
	(self groupsManager includes: group)
		ifTrue: [ self updateGroupView ]! !

!AbstractNautilusUI methodsFor: 'plugins announcements' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
aKeyHasBeenPressed: aKey

	self announcer announce: (NautilusKeyPressed key: aKey )! !

!AbstractNautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 6/5/2011 18:54'!
addAll: aWindow
	
	self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
addCategory
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
addClass

	self selectedPackage ifNotNil: [:package | self addClassIn: package ]
	
	" No need of update, announcements will do the job "! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 10/7/2011 13:42'!
addClassInGroup

	self selectedClasses ifNotNil: [:classes | self addClassInGroup: classes ].! !

!AbstractNautilusUI methodsFor: 'group' stamp: 'BenjaminVanRyseghem 10/7/2011 13:42'!
addClassInGroup: aCollection

	(DialogGroupAdder new
		groups:	self groupsManager;
		elementsToAdd: aCollection)
		open! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
addComment: aText notifying: aController

	self selectedClass
		ifNil: [
			self selectedPackage
				ifNotNil: [:package | 
					"commentTextArea update: #clearUserEdits.
					package comment: aText"]]
		ifNotNil: [:class |
			commentTextArea update: #clearUserEdits.
			class comment: aText ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'bvr 8/23/2011 11:50'!
addMatchingPackagesInGroups

	self selectedPackage
		ifNotNil: [:package || separatorIndex firstPartOfTheName packages |
			separatorIndex := package name indexOf: $- ifAbsent: [ package name size + 1].
			firstPartOfTheName := package name copyFrom: 1 to: (separatorIndex - 1) .
			packages := self model packages select: [:each | each name beginsWith: firstPartOfTheName ].
			^ self addPackagesAsGroups: packages ].
	^ nil! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'bvr 8/23/2011 11:50'!
addMatchingPackagesInGroupsAndBrowse

	( self addMatchingPackagesInGroups )
		ifNotNil: [:group | 
			self selectedGroup: group.
			self showGroups: true]! !

!AbstractNautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
addModelItemsToWindowMenu: aMenu
	"Add model-related items to the window menu"
	"super addModelItemsToWindowMenu: aMenu."
	SystemBrowser addRegistryMenuItemsTo: aMenu inAccountOf: self model.

	aMenu addLine;
		add: 'Nautilus Plugins Manager'
		target: NautilusPluginManager new
		action: #openInWorld.! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
addPackage

	| package |
	package := self addPackageBasedOn: self selectedPackage.
	package ifNotNil: [
			self selectedPackage: package.
			self updatePackageView ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 8/21/2011 10:53'!
addPackageAsGroup

	^ self addPackagesAsGroup: self selectedPackages! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 8/21/2011 17:29'!
addPackageAsGroupAndBrowse

	self addPackageAsGroup
		ifNotNil: [:group | 
			self selectedGroup: group.
			self showGroups: true]
		ifNil: [
			| group |
			group := self model class groupsManager groups detect: [:each | each name = self selectedPackage name] ifNone: [ nil ].
			group ifNotNil: [ 
				self selectedGroup: group.
				self showGroups: true ]]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 8/21/2011 11:01'!
addPackageAsGroups

	self addPackagesAsGroups: self selectedPackages! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 8/21/2011 11:00'!
addPackageAsGroupsAndBrowse

	(self addPackagesAsGroups: self selectedPackages)
		ifNotNil: [:group | 
			self selectedGroup: group.
			self showGroups: true]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
addPackageInGroup
	
	self addPackagesInGroup: self selectedPackages! !

!AbstractNautilusUI methodsFor: 'group' stamp: 'BenjaminVanRyseghem 5/31/2011 14:50'!
addPackagesInGroup: aCollection
	
	aCollection
		ifNotEmpty: [:packages || classes |
			classes := packages gather: [:package | package classes ].
			(DialogGroupAdder new
				groups:	self groupsManager;
				elementsToAdd: (self model classes intersection: classes))
				open]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 15:43'!
addSubclassesOf: aClass in: result withIndex: index

	| classes |
	classes := aClass subclasses "self selectedPackage
					ifNil: [ {} ]
					ifNotNil: [:p | aClass subclasses intersection: p classes ]".

	classes do: [:each |
		result at: each put: index.
		self addSubclassesOf: each theNonMetaClass in: result withIndex: index + 1 ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 15:25'!
addSubclassesOf: aClass in: result withIndex: index fromRestrictedCollection: aCollection

	| classes intersection |

	classes := aClass subclasses" intersection: self shownClasses".
	
	classes := classes intersection: aCollection.
	(classes sort: [:a :b| a name <= b name]) do: [:each |
		result at: each put: index.
		self addSubclassesOf: each in: result withIndex: index + 1 fromRestrictedCollection: aCollection ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
addTrait

	self selectedPackage ifNotNil: [:package | self addTraitIn: package ]
	
	" No need of update, announcements will do the job "! !

!AbstractNautilusUI methodsFor: 'annotation pane' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
annotationSeparator
	"Answer the separator to be used between annotations"

	^ '  '! !

!AbstractNautilusUI methodsFor: 'announcement registration' stamp: 'BenjaminVanRyseghem 9/28/2011 17:52'!
announce: anAnnouncement

	^ self model announce: anAnnouncement! !

!AbstractNautilusUI methodsFor: 'announcement registration' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
announcer

	^ self model announcer! !

!AbstractNautilusUI methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 9/28/2011 20:28'!
arrowDown: aMethod

	| methods methodsNames index |
	methods := aMethod methodClass allSubclasses gather: [:each | each methodDict values ].
	methods := methods select: [:each | each selector = aMethod selector ].
	methods size = 1
		 ifTrue: [ ^ self model class openOnMethod: methods first ].
	methodsNames := methods collect: [:each | each methodClass name, '>>#', each selector ].
	index := UIManager default chooseFrom: methodsNames.
	index = 0 ifTrue: [ ^ self ].
	^ self model class openOnMethod: (methods at: index)
	! !

!AbstractNautilusUI methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
arrowUp: aMethod

	| newMethod |
	newMethod := aMethod methodClass superclass lookupSelector: aMethod selector.
	self model class openOnMethod: newMethod! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
asYetUnclassifiedString

	^ ClassOrganizer default! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 10/10/2011 18:39'!
browseClassRefs
	
	self browseClassRefsOf: self selectedClass.! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
browseClassVarRefs

	self browseClassVarRefsOf: self selectedClass! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/21/2012 23:54'!
browseClassVars

	| cls |
	self selectedClass ifNil: [ 
		self changed: #isAClassSelected.
		^ self ].
	cls := self selectedClass theNonMetaClass.
	(cls notNil and: [cls isTrait not])
		ifTrue: [ self systemNavigation browseClassVarRefs: cls ].
		
	! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
browseInstVarDefs 

	self browseInstVarDefsOf: self selectedClass! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
browseInstVarRefs 

	self browseInstVarRefsOf: self selectedClass! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/21/2012 23:51'!
browseInstVars

	| cls |
	cls := self selectedClass.
	(cls notNil and: [cls isTrait not])
		ifTrue: [ 
			self systemNavigation browseInstVarRefs: cls ].
	self changed: #isAClassSelected! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 2/7/2012 09:24'!
browseMessages

	self browseMessagesFrom: self selectedMethod selector! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 2/7/2012 09:24'!
browseSendersOfMessages
	"Present a menu of the currently selected message, as well as all messages sent by it.  Open a message set browser of all senders of the selector chosen."

	self browseSendersOfMessagesFrom: self selectedMethod selector! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
browseUnusedMethods
	
	self browseUnusedMethodsOf: self selectedClass! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
browseVersions
	"Create and schedule a Versions Browser, showing all versions of the 
	currently selected message. Answer the browser or nil."

	self browseVersionsFrom: self selectedMethod! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
browsedEnvironment

	^ self model browsedEnvironment! !

!AbstractNautilusUI methodsFor: 'plugins display' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
buildBottomPlugins
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 1/21/2012 23:52'!
buildBrowseClassVarsButton

	^ ( PluggableThreePhaseButtonMorph on: self )
					actionSelector: #browseClassVars;
					stateSelector: #isAClassSelected ;
					onImage: (self iconClass iconNamed: #classVarsSelectedIcon);
					offImage: (self iconClass iconNamed: #classVarsUnselectedIcon);
					pressedImage: (self iconClass iconNamed: #classVarsPressedIcon);	
					extent: 24@24;
					helpText: 'Show class variables';
					yourself.! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 1/21/2012 23:50'!
buildBrowseInstVarsButton

	^ ( PluggableThreePhaseButtonMorph on: self )
					actionSelector: #browseInstVars;
					stateSelector: #isAClassSelected ;
					onImage: (self iconClass iconNamed: #instVarsSelectedIcon);
					offImage: (self iconClass iconNamed: #instVarsUnselectedIcon);
					pressedImage: (self iconClass iconNamed: #instVarsPressedIcon);	
					extent: 24@24;
					helpText: 'Show instance variables';
					yourself.! !

!AbstractNautilusUI methodsFor: 'code panel' stamp: 'BenjaminVanRyseghem 2/16/2012 01:36'!
buildCodePane
	| handler |

	sourceTextArea := self textMorphClass
				on: self
				text: #sourceCode
				accept: #compileSource:notifying:
				readSelection: #contentsSelection
				menu: #sourceCodeMenu:shifted:.

	handler := EventHandler new.
	handler on: #keyStroke send: #value:value: to: [:t1 :t2 | self keyStroke: t1 fromSourceCodeMorph: t2].			
				
	sourceTextArea
		askBeforeDiscardingEdits: true;
		vResizing: #spaceFill;
		hResizing: #spaceFill; 
		font: StandardFonts codeFont;
		spaceFillWeight: 3;
		eventHandler: handler;
		warningLimit: self warningLimit.
	sourceTextAreaLimit := sourceTextArea warningLimit.
	
	sourceTextArea warningLimit: -1.

	^ sourceTextArea! !

!AbstractNautilusUI methodsFor: 'code panel' stamp: 'BenjaminVanRyseghem 2/6/2012 16:42'!
buildCodePanelWithComment

	self model commentPosition == #right
		ifTrue: [ self buildCodePanelWithCommentOnRight ].
	self model commentPosition == #bottom
		ifTrue: [ self buildCodePanelWithCommentOnBottom ].
	self model commentPosition == #left
		ifTrue: [ self buildCodePanelWithCommentOnLeft ].
	self model commentPosition == #top
		ifTrue: [ self buildCodePanelWithCommentOnTop ].! !

!AbstractNautilusUI methodsFor: 'code panel' stamp: 'BenjaminVanRyseghem 2/6/2012 16:49'!
buildCodePanelWithCommentOnBottom
	| splitter delta |
	
	splitter := ProportionalSplitterMorph new beSplitsTopAndBottom.
	delta := 2.

	splitter addLeftOrTop: sourceTextArea.
	splitter addRightOrBottom: commentTextArea.

	sourceCodePanel
		addMorph: sourceTextArea
		fullFrame: (LayoutFrame 
						fractions: (0@0 corner: 1@0.5) 
						offsets: (0@0 corner: 0@(delta negated))).
	sourceCodePanel
		addMorph: splitter
		fullFrame: (LayoutFrame 
						fractions: (0@0.5 corner: 1@0.5) 
						offsets: (0@(delta negated) corner: 0@delta)).
	sourceCodePanel 
		addMorph: commentTextArea
		fullFrame: (LayoutFrame 
						fractions: (0@0.5 corner: 1@1) 
						offsets: (0@delta corner: 0@0)).! !

!AbstractNautilusUI methodsFor: 'code panel' stamp: 'BenjaminVanRyseghem 2/6/2012 16:51'!
buildCodePanelWithCommentOnLeft
	| splitter delta |
	
	splitter := ProportionalSplitterMorph new.
	delta := 2.

	splitter addLeftOrTop: commentTextArea.
	splitter addRightOrBottom: sourceTextArea.

	sourceCodePanel
		addMorph: commentTextArea
		fullFrame: (LayoutFrame 
						fractions: (0@0 corner: 0.5@1) 
						offsets: (0@0 corner: (delta negated)@0)).
	sourceCodePanel
		addMorph: splitter
		fullFrame: (LayoutFrame 
						fractions: (0.5@0 corner: 0.5@1) 
						offsets: ((delta negated)@0 corner: delta@0)).
	sourceCodePanel 
		addMorph: sourceTextArea
		fullFrame: (LayoutFrame 
						fractions: (0.5@0 corner: 1@1) 
						offsets: (delta@0 corner: 0@0)).! !

!AbstractNautilusUI methodsFor: 'code panel' stamp: 'BenjaminVanRyseghem 2/6/2012 16:52'!
buildCodePanelWithCommentOnRight
	| splitter delta |
	
	splitter := ProportionalSplitterMorph new.
	delta := 2.

	splitter addLeftOrTop: sourceTextArea.
	splitter addRightOrBottom: commentTextArea.

	sourceCodePanel
		addMorph: sourceTextArea
		fullFrame: (LayoutFrame 
						fractions: (0@0 corner: 0.5@1) 
						offsets: (0@0 corner: (delta negated)@0)).
	sourceCodePanel
		addMorph: splitter
		fullFrame: (LayoutFrame 
						fractions: (0.5@0 corner: 0.5@1) 
						offsets: ((delta negated)@0 corner: delta@0)).
	sourceCodePanel 
		addMorph: commentTextArea
		fullFrame: (LayoutFrame 
						fractions: (0.5@0 corner: 1@1) 
						offsets: (delta@0 corner: 0@0)).! !

!AbstractNautilusUI methodsFor: 'code panel' stamp: 'BenjaminVanRyseghem 2/6/2012 16:49'!
buildCodePanelWithCommentOnTop
	| splitter delta |
	
	splitter := ProportionalSplitterMorph new beSplitsTopAndBottom.
	delta := 2.

	splitter addLeftOrTop: commentTextArea.
	splitter addRightOrBottom: sourceTextArea.

	sourceCodePanel
		addMorph: commentTextArea
		fullFrame: (LayoutFrame 
						fractions: (0@0 corner: 1@0.5) 
						offsets: (0@0 corner: 0@(delta negated))).
	sourceCodePanel
		addMorph: splitter
		fullFrame: (LayoutFrame 
						fractions: (0@0.5 corner: 1@0.5) 
						offsets: (0@(delta negated) corner: 0@delta)).
	sourceCodePanel 
		addMorph: sourceTextArea
		fullFrame: (LayoutFrame 
						fractions: (0@0.5 corner: 1@1) 
						offsets: (0@delta corner: 0@0)).! !

!AbstractNautilusUI methodsFor: 'code panel' stamp: 'BenjaminVanRyseghem 2/6/2012 16:40'!
buildCodePanelWithoutComment

	sourceCodePanel 
				addMorph: sourceTextArea
				fullFrame: (LayoutFrame 
								fractions: (0@0 corner: 1@1) 
								offsets: (0@0 corner: 0@0))! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 11/12/2011 16:53'!
buildCommentButton

	^(PluggableButtonMorph
		on: self 
		getState: #commentButtonState
		action: #commentButtonAction
		label: #commentButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
buildCommentPane

	commentTextArea := PluggableTextMorph
							on: self
							text: #getComments
							accept: #addComment:notifying:
							readSelection: nil
							menu: #codePaneMenu:shifted:.
				
	commentTextArea color: Color white.
	commentTextArea
		askBeforeDiscardingEdits: true;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
		
	commentTextArea spaceFillWeight: 1.

	^ commentTextArea! !

!AbstractNautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 2/20/2012 03:19'!
buildFirstColumn: aWindow
		
	^ firstColumn := self newGroupBoxMorph
			addContentMorph: self buildList;
			addContentMorph: (aWindow newRow: {self buildToogleButton. self buildGroupsButton});
			label: self labelText;
			hResizing: #spaceFill;
			vResizing: #spaceFill
			! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/21/2012 23:08'!
buildGetterFor: aString

	^ aString withFirstCharacterDownshifted,'
	
	^ ', aString! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/10/2012 18:57'!
buildGroupHierarchyFor: aGroup

	| coll1 |
	aGroup ifNil: [ ^ IdentityDictionary new ].
	self browsedEnvironment isSystem
		ifTrue: [ coll1 := aGroup elements ]
		ifFalse:[ coll1 := aGroup elements intersection: self model classes ].
	
	^ self buildHierarchyForClasses: coll1! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
buildGroupsButton

	^ (PluggableButtonMorph
			on: self 
			getState: #groupsButtonState
			action: #groupsButtonAction
			label: #groupsButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/8/2012 17:02'!
buildHierarchyFor: aClass

	^ self buildHierarchyForClasses: aClass withAllSuperclasses, aClass allSubclasses! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/10/2012 19:07'!
buildHierarchyForClasses: aCollection

	| result classes |
	result := IdentityDictionary new.
	classes := aCollection asSet.
	classes do: [:class || level |
		level := OrderedCollection with: class.
		class allSuperclassesDo: [:superClass |
			(classes includes: superClass)
				ifTrue: [ level add: superClass beforeIndex: 1 ]].
		level addFirst: 'whatever you want here'.
		result at: class put: level ].
	^ result! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/10/2012 19:03'!
buildHierarchyForClasses: aCollection fromPackage: aPackage

	| result classes |
	result := IdentityDictionary new.
	classes := aCollection asSet.
	classes do: [:class || level |
		level := OrderedCollection with: class.
		class allSuperclassesDo: [:superClass |
			(classes includes: superClass)
				ifTrue: [ level add: superClass beforeIndex: 1 ]].
		(aPackage definedClasses includes: class)
			ifTrue: [ level addFirst: ' ']
			ifFalse: [ level addFirst: ''].
		result at: class put: level ].
	^ result! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 11/28/2011 18:14'!
buildInitializeCodeFor: aClass 
	
	^ String streamContents: [:str | str << 'initialize';cr.
		str tab << '"Initialization code for '<<aClass name<<'"';cr;cr.
		str tab << 'super initialize.';cr.
		aClass instVarNames sort do: [:name | str cr tab << name << ' := nil.' ]].
	! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/13/2011 14:45'!
buildInitializerFor: aVariableList

	^ String streamContents: [ :stream|
		aVariableList 
			do: [ :varName|	stream << varName << ': ' << varName]
			separatedBy: [ stream << ' ' ].
		stream cr cr tab << '^ self new'; cr.
		aVariableList do: [ :varName|
			stream tab tab << varName << ': ' << varName << ';'; cr].
		stream tab tab << 'yourself']! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
buildInstanceButton

	^ (PluggableButtonMorph
			on: self 
			getState: #instanceButtonState
			action: #instanceButtonAction
			label: #instanceButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!AbstractNautilusUI methodsFor: 'plugins display' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
buildLeftPlugins

	| left |
	left := self model plugins select: [:each | each position = #left ].! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 2/20/2012 21:39'!
buildList

	list := PluggableIconListMorph new
				keystrokeSelector: #keyPressedOnList:shifted:;
				getIconSelector: #listIcon:;
				getListSizeSelector: #listSize;
				getListElementSelector: #listElement:;
				resetListSelector: #resetListSelection;
				autoDeselect: true;
				dropEnabled: true;
				doubleClickSelector: #doubleClick;
				dropItemSelector: #dropInList:inARow:;
				dragEnabled: true;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				
				on: self 
				list: #getList 
				primarySelection: #selected
				changePrimarySelection: #selected:
				listSelection: #listSelectionAt:
				changeListSelection: #listSelectionAt:put:
				menu: #menu:shifted:
				keystroke: nil;
				
				wrapSelector: #listWrapper:.
	self showGroups
		ifTrue: [ self setGroupShorcutsTo: list ]
		ifFalse: [ self 
					ifPackages: [ self setPackageShorcutsTo: list ]
					ifClasses: [ self setClassShorcutsTo: list ]].
	^ list! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 2/20/2012 21:39'!
buildList2

	list2 := PluggableIconListMorph new
				keystrokeSelector: #keyPressedOnList2:shifted:;
				getIconSelector: #listIcon2:;
				getListSizeSelector: #listSize2;
				getListElementSelector: #listElement2:;
				resetListSelector: #resetListSelection2;
				autoDeselect: true;
				dropEnabled: true;
				dropItemSelector: #dropInList2:inARow:;
				doubleClickSelector: #doubleClick2;
				dragEnabled: true;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				
				on: self
				list: #getList2
				primarySelection: #selected2
				changePrimarySelection: #selected2:
				listSelection: #listSelection2At:
				changeListSelection: #listSelection2At:put:
				menu: #menu2:shifted:
				keystroke: nil;
				wrapSelector: #listWrapper2:.
						
	self 
		ifPackages: [ self setClassShorcutsTo: list2 ]
		ifClasses: [ self setPackageShorcutsTo: list2 ].					
						
	^ list2! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/10/2012 19:05'!
buildPackageHierarchyFor: aPackage

	^ self buildHierarchyForClasses: aPackage classes fromPackage: aPackage! !

!AbstractNautilusUI methodsFor: 'plugins display' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
buildRightPlugins

	| right |
	right := self model plugins select: [:each | each position = #right ].! !

!AbstractNautilusUI methodsFor: 'displaying' stamp: 'CamilloBruni 9/6/2011 20:33'!
buildSecondColumn: aWindow

	"^ (aWindow newColumn: {
		self buildLabelMorph2.
		self buildList2.
		aWindow newRow: {self buildInstanceButton. self buildCommentButton}}) 
		hResizing: #spaceFill; vResizing: #spaceFill"
		
	^ secondColumn := self newGroupBoxMorph
			addContentMorph: self buildList2;
			addContentMorph: (aWindow newRow: {self buildInstanceButton. self buildCommentButton});
			label: self labelText2;
			hResizing: #spaceFill;
			vResizing: #spaceFill! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 1/21/2012 23:56'!
buildSeparator

	^ Morph new height: 2; width: 0; color: Color transparent.
"	^ ImageMorph new newForm: (self iconClass iconNamed: #separatorIcon) "! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 1/19/2012 15:14'!
buildSetUpCodeFor: aClass 
	
	^ String streamContents: [:str | str << 'setUp';cr.
		str tab << '"Setting up code for '<<aClass name<<'"';cr;cr.
		aClass instVarNames sort do: [:name | str cr tab << name << ' := nil.' ]].
	! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/21/2012 23:09'!
buildSetterFor: aString

	^ aString withFirstCharacterDownshifted, ': anObject
	
	', aString, ' := anObject'! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 1/21/2012 23:30'!
buildSwitchToByteCodeButton

	^ ( PluggableThreePhaseButtonMorph on: self )
					actionSelector: # switchToByteCodeButton;
					stateSelector: #showByteCode ;
					onImage: (self iconClass iconNamed: #byteCodeSelectedIcon);
					offImage: (self iconClass iconNamed: #byteCodeUnselectedIcon);
					pressedImage: (self iconClass iconNamed: #byteCodePressedIcon);	
					extent: 24@24;
					helpText: 'Show byteCode';
					yourself.! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 1/21/2012 23:30'!
buildSwitchToDecompileButton

	^ ( PluggableThreePhaseButtonMorph on: self )
					actionSelector: # switchToDecompileButton;
					stateSelector: #showDecompile ;
					onImage: (self iconClass iconNamed: #decompileSelectedIcon);
					offImage: (self iconClass iconNamed: #decompileUnselectedIcon);
					pressedImage: (self iconClass iconNamed: #decompilePressedIcon);	
					extent: 24@24;
					helpText: 'Show decompiled method';
					yourself.! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 1/21/2012 23:37'!
buildSwitchToSourceCodeButton
	
	^ ( PluggableThreePhaseButtonMorph on: self )
					actionSelector: # switchToSourceCodeButton;
					stateSelector: #showSource ;
					onImage: (self iconClass iconNamed: #sourceSelectedIcon);
					offImage: (self iconClass iconNamed: #sourceUnselectedIcon);
					pressedImage: (self iconClass iconNamed: #sourcePressedIcon);	
					extent: 24@24;
					state: #on;
					helpText: 'Show source code';
					yourself.! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/10/2012 19:06'!
buildTabbedNameOf: anElement
			
	| tab result size |
	
	tab := '   '.
	size := cachedHierarchy 
						at: anElement 
						ifPresent: [:p | p size - 2 ]
						ifAbsent: [ 0 ].
	
	result := String new: (size * (tab size)) streamContents: [ :s|
		1 to: size do: [:i | s nextPutAll: tab ]].

	^ self selectedPackage 
		ifNil: [result, anElement name]
		ifNotNil: [:package | 
			( anElement package = package)
				ifTrue: [ (result, anElement name) asStringMorph ]
				ifFalse: [ (result , anElement name",' (', anElement package name,')'")asStringMorph color: self extensionColor;yourself]]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 1/19/2012 15:17'!
buildTearDownCodeFor: aClass 
	
	^ String streamContents: [:str | str << 'tearDown';cr.
		str tab << '"Tearing down code for '<<aClass name<<'"';cr;cr.
		aClass instVarNames sort do: [:name | str cr tab << name << ' := nil.' ]].
	! !

!AbstractNautilusUI methodsFor: 'test creation' stamp: 'BenjaminVanRyseghem 10/7/2011 15:56'!
buildTestClassDefinitionFrom: aClass

	^ 'TestCase subclass: ', (self buildTestClassNameFrom: aClass) printString, '
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''',(self buildTestPackageNameFrom:aClass),''''! !

!AbstractNautilusUI methodsFor: 'test creation' stamp: 'BenjaminVanRyseghem 10/7/2011 15:55'!
buildTestClassNameFrom: aClass
	
	^ (aClass name asString,'Test') asSymbol! !

!AbstractNautilusUI methodsFor: 'test creation' stamp: 'BenjaminVanRyseghem 1/19/2012 13:58'!
buildTestPackageNameFrom:aClass

	^ aClass package name asString, '-Tests' ! !

!AbstractNautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 1/21/2012 23:56'!
buildTextAreaButtonsColumn: aWindow

	| column |
	column := PanelMorph new.
	column 
		changeTableLayout;
		listDirection: #topToBottom.
		
		{	self buildSwitchToSourceCodeButton.
			self buildSwitchToByteCodeButton.
			self buildSwitchToDecompileButton.
			self buildSeparator.
			self buildBrowseInstVarsButton.
			self buildBrowseClassVarsButton} reverse do: [:each | column addMorph: each ].
	
	column 
		vResizing: #spaceFill;
		width: 24;
		hResizing: #rigid.
	
	^ column! !

!AbstractNautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 2/9/2012 17:18'!
buildToogleButton

	^ hierarchyButton := (PluggableButtonMorph
							on: self 
							getState: #toogleButtonState
							action: #toogleButtonAction
							label: #toogleButtonLabel)
							hResizing: #spaceFill;
							vResizing: #shrinkWrap;
							enabled: (self model selectedClass notNil);
							yourself! !

!AbstractNautilusUI methodsFor: 'plugins display' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
buildTopPlugins
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 8/21/2011 00:35'!
buildUpAndDownArrowIcon: aMethod

	| container up down |
	
	container := Morph new.
	container 
		extent: 12@12;
		color: Color transparent.
		
	up := IconicButton new 
				target: self;
				actionSelector: #arrowUp:;
				arguments: { aMethod };
				labelGraphic: (self iconClass iconNamed: #arrowDoubleUp);
				color: Color transparent;
				extent: 12 @ 6;
				helpText: 'Browse overriden message';
				borderWidth: 0.
				
	down :=  IconicButton new 
				target: self;
				actionSelector: #arrowDown:;
				arguments: { aMethod };
				labelGraphic: (self iconClass iconNamed: #arrowDoubleDown);
				color: Color transparent;
				extent: 12 @ 6;
				helpText: 'Browse overriding messages';
				borderWidth: 0.
				
	^ container
		changeTableLayout;
		listDirection: #topToBottom;
		addMorph: down;
		addMorph: up;
		yourself! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
byteCodeSymbol

	^ #ByteCode! !

!AbstractNautilusUI methodsFor: 'menus extensions' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
categoriesRefactoringMenu: aMenu shifted: b! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 1/19/2012 16:14'!
categorizeAllUncategorizedMethods
	"Categorize methods by looking in parent classes for a method category."
	| aClass organizer organizers |
	aClass := self selectedClass.
	
	self categorizeAllUncategorizedMethodsOf: aClass.
	
	organizer := aClass organization.
	(organizer listAtCategoryNamed: ClassOrganizer default) do: [:sel |
		(sel beginsWith: 'test')
			ifTrue: [ organizer classify: sel under: 'tests' ]].

	" no need to update, announcements do the job "! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
categorizeMethod
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
categoryMenuBuilder

	^ NautilusPragmaMenuBuilder withAllPragmaKeywords: {self commonPragma. self categoryPragma} model: self! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 5/24/2011 14:15'!
categoryPragma

	^'nautilusProtocolMenu'! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
changedLabels

	firstColumn label: self labelText.
	secondColumn label: self labelText2.! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 2/18/2012 21:13'!
classAdded: anAnnouncement
	
	| class |
	window ifNil: [^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	class := anAnnouncement item.
	((self showGroups 
	and: [ self selectedGroup ifNil: [ ^ self ] ifNotNil: [:gp | gp elements includes: class ]]) 
	or: [(self
			ifPackages: [ self selectedPackage = class package ]
			ifClasses: [ true ])])
				ifTrue: [
					self updateClassView.
					self removeFromPackagesIconsCache: class package ]! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 2/7/2012 18:21'!
classCommented: anAnnouncement
	" announcement handled when a class has been commented " 
	| aClass |

	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].

	aClass := anAnnouncement item.	
	(self getList2 includes: aClass)
		ifTrue: [ self removeFromClassesIconsCache: aClass ].
	
	((self selectedClass = aClass) and: [ self showComment ])
		ifTrue: [ self changed: #getComments ]! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 2/7/2012 18:20'!
classDefinitionModified: anAnnouncement 

	| class |
	window ifNil: [^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	class := anAnnouncement item.
	((self showGroups 
	and: [  self selectedGroup notNil
	and: [ self selectedGroup elements includes: class ]]) 
	or: [(self
			ifPackages: [ self getList2 includes: class ]
			ifClasses: [ self getList includes: class ])])
			ifTrue: [
			self updateClassView.
			self removeFromPackagesIconsCache: class package.
			sourceTextArea hasUnacceptedEdits 
				ifFalse: [ self changed: #sourceCode ]].! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 5/24/2011 14:15'!
classFixPragma

	^'nautilusClassFixMenu'! !

!AbstractNautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 2/21/2012 02:41'!
classIconFor: aClass

	ClassesIconsCache 
		at: aClass 
		ifPresent: [:icon | 
			
			 icon class == IconicButton ifFalse: [ ^ icon ].
			
			^ IconicButton new 
						target: icon target;
						actionSelector: icon actionSelector;
						arguments: icon arguments;
						labelGraphic: icon labelGraphic;
						color: icon color;
						helpText: icon helpText;
						extent: icon extent;
						borderWidth: icon borderWidth ].

	(aClass includesBehavior: TestCase)
		ifTrue: [ | icon button |
			icon :=  self iconClass iconNamed: #testNotRun.

			aClass hasPassedTest ifTrue: [ icon :=  self iconClass iconNamed: #testGreen ].
			aClass hasFailedTest ifTrue: [ icon :=  self iconClass iconNamed: #testYellow ].
			aClass hasErrorTest ifTrue: [ icon :=  self iconClass iconNamed: #testRed ].
					
			button := IconicButton new 
						target: self;
						actionSelector: #runTestsOfClass:;
						arguments: { aClass };
						labelGraphic: icon ;
						color: Color transparent;
						extent: 12 @ 12;
						helpText: 'Run the tests';
						borderWidth: 0.
			 ^ ClassesIconsCache at: aClass put: button ]
		ifFalse: [
			aClass theNonMetaClass organization classComment isEmpty
				ifTrue: [| button |
					button := IconicButton new 
								target: self;
								actionSelector: #openCommentEditor:;
								arguments: { aClass };
								labelGraphic: (self iconClass iconNamed: #uncommentedClass) ;
								color: Color transparent;
								extent: 12 @ 12;
								helpText:'Edit the comment';
								borderWidth: 0.
					 ^ ClassesIconsCache at: aClass put: button ]].
			
	(aClass includesBehavior: String)
		ifTrue: [ ^ ClassesIconsCache at: aClass put: (self iconClass iconNamed: #string) ].
	(aClass includesBehavior: Announcement)
		ifTrue: [ ^ ClassesIconsCache at: aClass put: (self iconClass iconNamed: #announcement) ].
	(aClass includesBehavior: Collection)
		ifTrue: [ ^ ClassesIconsCache at: aClass put: (self iconClass iconNamed: #collection) ].
	(aClass includesBehavior: Exception)
		ifTrue: [ ^ ClassesIconsCache at: aClass put: (self iconClass iconNamed: #exception) ].
	(aClass includesBehavior: Magnitude)
		ifTrue: [ ^ ClassesIconsCache at: aClass put: (self iconClass iconNamed: #magnitude) ].
	(aClass includesBehavior: Morph)
		ifTrue: [ ^ ClassesIconsCache at: aClass put: (self iconClass iconNamed: #morph) ].

	^ ClassesIconsCache at: aClass put: (self iconClass iconNamed: #blank)! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
classLabel

	^'Class'! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
classMenuBuilder

	^NautilusPragmaMenuBuilder withAllPragmaKeywords: {self classFixPragma. self classPragma} model: self! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 5/24/2011 14:15'!
classPragma

	^'nautilusClassMenu'! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 1/25/2012 16:18'!
classRecategorized: anAnnouncement
	
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	self selectedClass = anAnnouncement item
		ifTrue: [ self update ]! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 2/16/2012 17:49'!
classRemoved: anAnnouncement
	
	| class oldPackage |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	class := anAnnouncement item.
	((self showGroups 
	and: [ self selectedGroup ifNil: [ ^self ] ifNotNil: [:gp | gp elements includes: class ]]) 
	or: [(self
			ifPackages: [ self getList2 includes: class ]
			ifClasses: [ self getList includes: class ])])
			ifTrue: [
				self selectedClass = class
					ifTrue: [ self selectedClass: nil ].
				window isDisplayed ifFalse: [ ^ self ].
				oldPackage := RPackageOrganizer default packageNamed: (anAnnouncement event environmentAt: #category).
	self removeFromPackagesIconsCache: oldPackage.
				self updateBothView ].
	! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 2/7/2012 18:20'!
classRenamed: anAnnouncement
	
	| class |
	class := anAnnouncement item.
	window ifNil: [ ^ self].
	window isDisplayed ifFalse: [ ^ self ].
	((self showGroups 
	and: [ self selectedGroup elements includes: class ]) 
	or: [(self
			ifPackages: [ self getList2 includes: class ]
			ifClasses: [ self getList includes: class ])])
			ifTrue: [ self updateClassView ]! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 1/25/2012 16:18'!
classReorganized: anAnnouncement
	
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	anAnnouncement item = self selectedClass
		ifTrue: [	self update ].! !

!AbstractNautilusUI methodsFor: 'widget - class' stamp: 'BenjaminVanRyseghem 10/20/2011 14:12'!
classWidget

	^ list2! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
classesMenu: aMenu shifted: aBoolean 

	^ aMenu becomeForward: (self classMenuBuilder menu)! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
clearUserEditFlag
	
	self changed: #clearUserEdits! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
codePaneMenu: aMenu shifted: shifted 
	"Note that unless we override perform:orSendTo:, 
	PluggableTextController will respond to all menu items in a 
	text pane"
	| donorMenu |
	donorMenu := shifted
				ifTrue: [SmalltalkEditor shiftedYellowButtonMenu]
				ifFalse: [SmalltalkEditor yellowButtonMenu].
	^ aMenu addAllFrom: donorMenu! !

!AbstractNautilusUI methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 1/23/2012 20:15'!
codeTextMorph

	^ sourceTextArea! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
commentButtonAction

	self toogleShowComment.! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
commentButtonLabel

	^ self commentLabel! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
commentButtonState

	^ self showComment! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
commentLabel

	^ 'Comments'! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 2/19/2012 20:10'!
commonPragma

	^'nautilusCommonMenu'! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 1/25/2012 17:16'!
compileAClassFrom: aString notifying: aController

	sourceTextArea update: #clearUserEdits.
	( self compileANewClassFrom: aString notifying: aController startingFrom: self selectedClass )
		ifNil: [^ sourceTextArea hasUnacceptedEdits: true. ]
		ifNotNil: [:class | 
			self selectedPackage: class package.
			self selectedClass: class.
			self showHierarchy
						ifTrue: [ self hierarchyClass: class ].
			self showGroups
				ifTrue: [ self updateClassView ]
				ifFalse: [ self updateBothView ]]! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
compileAMethodFromCategory: aCategory withSource: aString notifying: aController
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
compileSource: aText notifying: aController
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
contentsSelection

	self selectedClass isNil
		ifFalse:[	
			self selectedMethod isNil
				ifTrue: [
					self selectedCategory notNil
						ifTrue: [^ (1 to: self defaultMethodSource size) ]]].
	^ (1 to: 0)! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/7/2011 11:30'!
copyCategory: anObject toTheClass: aClass
	
	| originClass methods |
	originClass := self selectedClass.
	methods := originClass methodsInProtocol: anObject.
	methods do: [:meth | self copyMethod: meth toTheClass: aClass ].! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 11/14/2011 17:47'!
copyClass
	
	| association |
	self okToChange ifFalse: [^ self].
	association := self copyClasses: (self selectedClasses collect: [:e | e theNonMetaClass ]).
	association key
		ifTrue: [
			self selectedClass: association value.
			self updateClassView]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/14/2012 17:38'!
copyMethod: aMethod toTheClass: aClass 
	| newMethod shouldBeInstall |
	
	aMethod realClass = aClass ifTrue: [ ^ self ].
	shouldBeInstall := aClass methodDict
						at: aMethod selector
						ifPresent: [:sel | 
							" here I have to fork to release the drag & drop "
							[ (self openDialogWouldYouInstall: sel into: aClass)
								ifTrue: [ 
									newMethod := aClass compile: aMethod sourceCode classified: aMethod category ]] fork.
							  ]
						ifAbsent: [ 
							newMethod := aClass compile: aMethod sourceCode classified: aMethod category]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 9/17/2011 15:18'!
createInitializerWithInstVars
	"Create a default initializer on the class side for a chosen list of instance variables"

	self createInitializerWithInstVarsOf: (self showInstance ifTrue: [ self selectedClass theNonMetaClass ] ifFalse: [ self selectedClass theMetaClass ])! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 1/21/2012 23:08'!
createInstVarAccessors

	self createInstVarAccessorsOf: self selectedClass! !

!AbstractNautilusUI methodsFor: 'test creation' stamp: 'BenjaminVanRyseghem 1/19/2012 17:13'!
createTestForClass: aClass

	| definition testClass className |

	aClass ifNil: [ ^ nil ].
	(aClass inheritsFrom: TestCase) ifTrue: [ ^ nil ].
	aClass isMeta ifTrue: [ ^ nil ].

	className := self buildTestClassNameFrom: aClass.
	testClass := self class environment 
		at: className
		ifPresent: [:class | class ]
		ifAbsent: [ 
			definition := self buildTestClassDefinitionFrom: aClass.
			self 
				compileANewClassFrom: definition
				notifying: nil
				startingFrom: self selectedClass.
			self class environment at: className ].
	testClass comment: (self generateCommentForTestClass: testClass from: aClass).
	self showGroups: false.
	self selectedPackage: testClass package.
	self selectedClass: testClass.
	self updateBothView.
	^ testClass! !

!AbstractNautilusUI methodsFor: 'test creation' stamp: 'BenjaminVanRyseghem 10/7/2011 15:23'!
createTestForSelectedClass

	self createTestForClass: self selectedClass! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
currentDisplayChoice

	^ currentDisplayChoice ifNil: [ currentDisplayChoice := self sourceCodeSymbol ]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
currentDisplayChoice: aSymbol

	currentDisplayChoice := aSymbol.
	
	self changed: #showSource.
	self changed: #showByteCode.
	self changed: #showDecompile.
	self changed: #sourceCode.! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
decompileSymbol

	^ #Decompile! !

!AbstractNautilusUI methodsFor: 'annotation pane' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
defaultAnnotationInfo
	"see annotationRequests comment"
	^ #(timeStamp messageCategory sendersCount implementorsCount allChangeSets)! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
defaultClassDescriptor

	| string |
	string := 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: '''.
	^ self selectedPackage
		ifNil: [string, '''' ]
		ifNotNil: [:package | string, package name, '''' ]! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
defaultMethodSource


	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!AbstractNautilusUI methodsFor: 'dispatch' stamp: 'BenjaminVanRyseghem 2/14/2012 21:09'!
dispatchRemoveClasses: aCollection

	^ self removeClasses: aCollection! !

!AbstractNautilusUI methodsFor: 'dispatch' stamp: 'BenjaminVanRyseghem 1/23/2012 17:47'!
dispatchRenameClass: aClass

	self renameClass: aClass! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
doItContext

	^ nil! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 9/12/2011 17:08'!
doItReceiver

	^ self selectedClass 
		ifNil: [ nil ]
		ifNotNil: [:class | class theNonMetaClass ]! !

!AbstractNautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
doubleClick

	self 
		ifGroups: [ self doubleClickOnGroup ]
		ifNot: [
			self ifPackages: [ self doubleClickOnPackage ] ifClasses: [ self doubleClickOnClass ]]! !

!AbstractNautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
doubleClick2

	self 
		ifPackages: [ self doubleClickOnClass ] 
		ifClasses: [ self doubleClickOnPackage ]! !

!AbstractNautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
doubleClickOnClass

	self selectedClass
		ifNil: [ ^ self ]
		ifNotNil: [:class |
			self showGroups
				ifTrue: [ self model class openOnClass: class onGroup: self selectedGroup ]
				ifFalse: [ self model class openOnClass: class ]]! !

!AbstractNautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
doubleClickOnGroup

	self selectedGroup 
		ifNil: [ ^self ]
		ifNotNil:[:group | self model class openOnGroup: group ]! !

!AbstractNautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
doubleClickOnPackage

	self selectedPackage
		ifNil: [ ^ self ]
		ifNotNil:[:package | self model class openOnPackage: package ]! !

!AbstractNautilusUI methodsFor: 'remove me' stamp: 'BenjaminVanRyseghem 10/7/2011 21:05'!
dragPassengerFor: item inMorph: dragSource 

	| transferType smn |

	(dragSource isKindOf: PluggableListMorph)
		ifFalse: [^nil].
	transferType := self dragTransferTypeForMorph: dragSource.
	transferType == #getCategories
		ifTrue: [ ^self selectedCategory ].
	
	(self
		ifPackages: [ transferType == #getList2 ]
		ifClasses: [ transferType == #getList ]) 
			ifTrue: [ ^self selectedClass ].

	transferType == #getMethods
			ifFalse: [ ^nil ].
			
	self selectedMethod ifNil: [ | method |
		method := item originalObject.
		^ (self getMethods includes: method)
			ifTrue: [ method ]
			ifFalse: [ nil ]].

	^ self selectedMethod! !

!AbstractNautilusUI methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 10/19/2011 17:14'!
dragPassengersFor: item inMorph: dragSource 

	| transferType object |

	object := item originalObject.

	(dragSource isKindOf: PluggableListMorph)
		ifFalse: [^ nil ].
	transferType := self dragTransferTypeForMorph: dragSource.
	transferType == #getCategories
		ifTrue: [ ^ self selectedCategories ifEmpty: [ { object } ] ].
	
	(self
		ifPackages: [ transferType == #getList2 ]
		ifClasses: [ transferType == #getList ]) 
			ifTrue: [ ^ self selectedClasses ifEmpty: [ { object } ]].

	transferType == #getMethods
			ifFalse: [ ^ nil ].

	^ self selectedMethods
		ifEmpty: [
			 (self getMethods includes: object)
				ifTrue: [ { object } ]
				ifFalse: [ "to test" self halt. ] ]! !

!AbstractNautilusUI methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 10/19/2011 06:33'!
dragTransferTypeForMorph: dragSource 

	^(dragSource isKindOf: PluggableListMorph)
		ifTrue: [dragSource getListSelector]! !

!AbstractNautilusUI methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 10/7/2011 22:00'!
dropInAClass: aCollection into: aClass

	aCollection do: [:anObject | 
		(anObject isBehavior)
			ifFalse: [
				(anObject isString or: [ anObject isSymbol ])
					ifTrue: ["category"
						ActiveHand shiftPressed
							ifTrue: [ self copyCategory: anObject toTheClass: aClass ]
							ifFalse: [ self moveCategory: anObject toTheClass: aClass ]]
					ifFalse: [
						"a method"
						ActiveHand shiftPressed
							ifTrue: [ self copyMethod: anObject toTheClass: aClass ]
							ifFalse: [ self moveMethod: anObject toTheClass: aClass autoRemove: false ]]]]! !

!AbstractNautilusUI methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 10/7/2011 22:00'!
dropInAPackage: aCollection into: aPackage 

	aCollection do:[:aClass |
		aClass category: aPackage name.
		ActiveHand shiftPressed
			ifTrue: [ 
				self selectedClass: nil.
				self updateClassView ]
			ifFalse:[
				self selectedPackage: aPackage.
				self selectedClass: aClass.
				self updateBothView ]]! !

!AbstractNautilusUI methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 2/14/2012 17:37'!
dropInList2: aCollection inARow: aRow
	| receiver |

	receiver := self getList2 at: aRow.
	self selectedClass isMeta
		ifTrue: [ receiver := receiver theMetaClass ]
		ifFalse: [ receiver := receiver theNonMetaClass ].
	self	
		ifPackages: [ self dropInAClass: aCollection into: receiver ]
		ifClasses: [ self dropInAPackage: aCollection into: receiver ]! !

!AbstractNautilusUI methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 2/16/2012 00:50'!
dropInList: aCollection inARow: aRow
	| receiver |
	
	(aRow = 0) ifTrue: [ ^ self ].
	receiver := self getList at: aRow.
	( receiver isKindOf: Class )
		ifTrue: [ self selectedClass isMeta
					ifTrue: [ receiver := receiver theMetaClass ]
					ifFalse: [ receiver := receiver theNonMetaClass ]].
	self	
		ifPackages: [ self dropInAPackage: aCollection into: receiver ]
		ifClasses: [ self dropInAClass: aCollection into: receiver ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/31/2011 16:59'!
enableSingleClassSelection

	^ self selectedClasses size <= 1! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
enableSingleMenuItems

	^ self selectedItems size <= 1! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/19/2012 14:16'!
extensionColor

	^ Color gray darker! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
fileOutClass
	"Print a description of the selected class onto a file whose name is the 
	category name followed by .st."

	self fileOutClasses: self selectedClasses! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
fileOutMethods
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/31/2011 15:05'!
fileOutPackage

	self fileOutPackages: self selectedPackages! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 9/17/2011 07:03'!
findClass
	"Search for a class from a pattern or from the recent list"
	| aClass recentList |
	self okToChange ifFalse: [^ self flashPackage ].
	aClass := ClassSearch chooseFromOwner: self window .
	aClass ifNil: [^ self flashPackage].
	self showGroups: false.
	self selectedPackage: aClass package.
	self selectedClass: aClass.
	self updateBothView! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
findMethod
	"Search for a method in the lookup of the selected class"

	| foundMethod class |
	self okToChange ifFalse: [^ self flashPackage ].

	foundMethod := self findMethodIn: self selectedClass.
	foundMethod ifNil: [^ self ].
	class := foundMethod methodClass.
	self showGroupsSilently: false.
 	self model package: class package class: class category: foundMethod protocol method: foundMethod.
	self showPackages ifFalse: [
		classesSelection removeAll.
		classesSelection at: class put: true ].
	self updateBothView.
	self update.
	self changed: #sourceCode! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 2/18/2012 16:57'!
findPackage

	"Search for a package from a pattern or from the recent list"
	| foundPackage packagesList |
	self okToChange ifFalse: [^ self ].
	packagesList := (self model recentClasses elements collect: [:each | each package name]) asSet asArray sort.

	foundPackage := self findPackageIn: packagesList.
	foundPackage ifNil: [ ^ self ].
	self selectedPackage = foundPackage ifTrue: [ ^ self ].
	
	self selectedPackage: foundPackage.
	self updatePackageView.
! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/18/2012 16:57'!
flashPackage

	^ nil! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 1/19/2012 15:23'!
forceGenerateInitialize

	self selectedClass ifNotNil: [:class || code index |
		(class isMeta not and: [class inheritsFrom: TestCase])
			ifTrue: [
				index := 34.
				code := self buildSetUpCodeFor: class.
				class compile: code classified: 'initialization'.
				code := self buildTearDownCodeFor: class.
				class compile: code classified: 'initialization'.
				self selectedMethod: (class>>#setUp) ]
			ifFalse: [
				index := 62.
				code := self buildInitializeCodeFor: class.
				class compile: code classified: 'initialization' .
				self selectedMethod: (class>>#initialize) ].
		self update.
		self giveFocusTo: sourceTextArea.
		sourceTextArea selectFrom: index+class name size to: index-1+class name size ].! !

!AbstractNautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 10/20/2011 14:21'!
forceSelectedMethod: aMethod

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/12/2011 12:37'!
forceSelection: anObject! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
fullBrowse
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'test creation' stamp: 'BenjaminVanRyseghem 1/19/2012 14:04'!
generateCommentForTestClass: testClass from: aClass

	^ String streamContents: [:stream || name |
			name := testClass name. 
			name first isVowel
				ifTrue: [ stream << 'An ']
				ifFalse:[ stream <<'A '].
			stream << name << ' is a test class for testing the behavior of '<< aClass name ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 1/19/2012 15:19'!
generateInitialize

	self selectedClass ifNotNil: [:class || code index |
		(class isMeta not and: [class inheritsFrom: TestCase])
			ifTrue: [
				index := 34.
				(class methodDict keys includes: #setUp) 
					ifFalse: [
						code := self buildSetUpCodeFor: class.
						class compile: code classified: 'initialization'].
				(class methodDict keys includes: #tearDown) 
					ifFalse: [
						code := self buildTearDownCodeFor: class.
						class compile: code classified: 'initialization'].
				self selectedMethod: (class>>#setUp) 
				]
			ifFalse: [
				index := 62.
				(class methodDict keys includes: #initialize) 
					ifFalse: [
						code := self buildInitializeCodeFor: class.
						class compile: code classified: 'initialization' ].
				self selectedMethod: (class>>#initialize) ].
		self update.
		self giveFocusTo: sourceTextArea.
		sourceTextArea selectFrom: index+class name size to: index-1+class name size ].! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 17:02'!
getClassHierarchy

	self hierarchyClass
		ifNil: [^self getClassesList].

	^ cachedHierarchy keys sort: [:a :b | self sortClassesInCachedHierarchy: a b: b].! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 17:15'!
getClassHierarchy2

	^ self selectedPackage
		ifNil: [{}]
		ifNotNil:[:package |
			cachedHierarchy := self buildPackageHierarchyFor: package.
			cachedHierarchy keys sort: [:a :b | self sortClassesInCachedHierarchy: a b: b]]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/28/2011 17:59'!
getClassesList

	^ self model classes! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/28/2011 18:35'!
getClassesList2

	^ self model packagesUsedByTheSelectedClass! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
getComments

	^ self selectedClass
		ifNil: [
			self selectedPackage
				ifNil: [ '' ]
				ifNotNil: [:package | '' "package comment" ]]
		ifNotNil: [:class | class comment ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/10/2012 19:01'!
getGroupHierarchy

	^ self selectedGroup 
		ifNil: [^ {}]
		ifNotNil: [:group |
			cachedHierarchy := self buildGroupHierarchyFor: group.
			cachedHierarchy keys sort: [:a :b | self sortClassesInCachedHierarchy: a b: b]]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/2/2011 16:43'!
getGroupsKeyList

	^ self groupsManager groups! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
getGroupsValuesList

	^ self selectedGroup 
		ifNil: [{}]
		ifNotNil: [:group | group elements ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 15:46'!
getList

	^ listElements ifNil: [ listElements := self loadList ].! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 15:45'!
getList2

	^ list2Elements ifNil: [ list2Elements := self loadList2 ].! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 18:23'!
getPackagesList
	^ self model packages sort: [:a :b | a name <= b name ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
getPackagesList2

	^ self model classesInTheSelectedPackage! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/22/2012 00:12'!
giveFocusTo: aMorph

	self hasFocus ifTrue: [aMorph takeKeyboardFocus]! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 5/24/2011 14:15'!
groupFixPragma

	^'nautilusGroupFixMenu'! !

!AbstractNautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 2/7/2012 20:11'!
groupIconFor: aGroup

	GroupsIconsCache 
		at: aGroup 
		ifPresent: [:icon | 
			
			 icon class == IconicButton ifFalse: [ ^ icon ].
			
			^ IconicButton new 
						target: icon target;
						actionSelector: icon actionSelector;
						arguments: icon arguments;
						labelGraphic: icon labelGraphic;
						color: icon color;
						helpText: icon helpText;
						extent: icon extent;
						borderWidth: icon borderWidth
			
			 ].
	
	^ GroupsIconsCache
		at: aGroup
		put: (IconicButton new 
				target: self;
				actionSelector: #restrictedBrowseGroup:;
				arguments: {{aGroup}};
				labelGraphic: (self iconClass iconNamed: #groupIcon);
				color: Color transparent;
				extent: 15 @ 16;
				helpText: 'Browse restricted environment';
				borderWidth: 0)! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
groupMenuBuilder

	^NautilusPragmaMenuBuilder withAllPragmaKeywords: {self groupFixPragma. self groupPragma} model: self! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 5/24/2011 14:15'!
groupPragma

	^'nautilusGroupMenu'! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
groupsButtonAction

	self toogleShowGroups! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
groupsButtonLabel

	^ 
		self showGroups
			ifTrue: [ self packageLabel ]
			ifFalse: [ self groupsLabel ]! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/31/2011 15:02'!
groupsButtonState

	^ false! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
groupsLabel

	^ 'Groups'! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
groupsManager

	^ self model groupsManager! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
groupsMenu: aMenu shifted: aBoolean 
	" Morphic's menus are filled up when pragma's one are returned from a method, so I have to substitute the morphic menu by the pragma one "
	
	^ aMenu becomeForward: (self groupMenuBuilder menu)! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
hierarchyClass

	^ hierarchyClass! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/10/2012 18:53'!
hierarchyClass: aClass

	hierarchyClass := aClass.
	self setCachedHierarchyClass: aClass! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/26/2011 16:05'!
historyChanged

	self setWindowTitle.
	self changed: #nextButtonEnablementState.
	self changed: #previousButtonEnablementState! !

!AbstractNautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 8/19/2011 16:07'!
iconClass

	^ self class iconClass! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
ifGroups: aBlock ifNot: anotherBlock

	^self showGroups
			ifTrue: aBlock
			ifFalse: anotherBlock! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
ifPackages: pBlock ifClasses: cBlock

	^ self showPackages
		ifTrue: pBlock
		ifFalse: cBlock! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 13:25'!
initialize

	super initialize.
	cachedHierarchy := IdentityDictionary new.
	groupsSelection := Dictionary new.
	packagesSelection := Dictionary new.
	classesSelection := Dictionary new.
	
	self registerToAnnouncements! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
instanceButtonAction

	self toogleShowInstance! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
instanceButtonLabel

	^ self showInstance
		ifTrue: [ self classLabel ]
		ifFalse: [ self instanceLabel ]! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
instanceButtonState

	^ false! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
instanceLabel

	^'Instance'! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
isAClassSelected

	^ self selectedClass notNil! !

!AbstractNautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
keyPressedOnCategory: anEvent
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 10/20/2011 14:16'!
keyPressedOnElement: anEvent

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'source text events' stamp: 'BenjaminVanRyseghem 1/19/2012 20:37'!
keyStroke: anEvent fromSourceCodeMorph: aMorph
	
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
labelText

	^ self showGroups
		ifTrue: [ 'Groups:']
		ifFalse: [self ifPackages: ['Packages:'] ifClasses: ['Classes:']]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
labelText2

	^ self ifPackages: ['Classes:'] ifClasses: ['Packages:']! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 15:34'!
listElement2: anIndex

	^ self getList2 at: anIndex! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 14:31'!
listElement: anIndex

	^ self getList at: anIndex! !

!AbstractNautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
listIcon2: anItem

	^ self 
		ifPackages: [ self classIconFor: anItem ]
		ifClasses: [ self packageIconFor: anItem ]! !

!AbstractNautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
listIcon: anItem
	" I return the icon corresponding to anItem in the leftmost list "


	^ self showGroups
		ifTrue: [ self groupIconFor: anItem ]
		ifFalse: [
			" if I do not show groups, I have to know if I show packages or classes "
			self 
				ifPackages: [ self packageIconFor: anItem ]
				ifClasses: [ self classIconFor: anItem ]]! !

!AbstractNautilusUI methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
listSelection

	^ self showGroups
		ifTrue: [ groupsSelection ]
		ifFalse: [
			self
				ifPackages: [ packagesSelection ]
				ifClasses: [ classesSelection  ]]! !

!AbstractNautilusUI methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
listSelection2

	^ self
		ifPackages: [ classesSelection ]
		ifClasses: [ packagesSelection ]! !

!AbstractNautilusUI methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 2/7/2012 18:21'!
listSelection2At: anIndex

	| elt |
	elt := self getList2 at: anIndex ifAbsent: [ ^false ].
	^ self listSelection2 at: elt ifAbsent: [ false ]! !

!AbstractNautilusUI methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 2/18/2012 17:08'!
listSelection2At: anIndex put: aBoolean

	| elt |
	aBoolean ifNil: [ ^ self ].
	elt := self getList2 at: anIndex ifAbsent: [ ^ self ].
	self listSelection2 at: elt put: aBoolean.
	self changed: #hasSelectedSelections! !

!AbstractNautilusUI methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 2/7/2012 18:21'!
listSelectionAt: anIndex

	| elt |
	elt := self getList at: anIndex ifAbsent: [ ^ false ].
	^ self listSelection at: elt ifAbsent: [ false ]! !

!AbstractNautilusUI methodsFor: 'list selections' stamp: 'BenjaminVanRyseghem 2/18/2012 17:05'!
listSelectionAt: anIndex put: aBoolean

	| elt |
	elt := self getList at: anIndex ifAbsent: [ ^ self ].
	self listSelection at: elt put: aBoolean.
	self changed: #hasSelectedSelections! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 15:47'!
listSize

	^ self getList size.! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 15:29'!
listSize2

	^ self getList2 size.! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/8/2012 16:44'!
listWrapper2: anElement

	^ self 
		ifPackages:	[
			"anElement is a Class"
			self showHierarchy
				ifTrue: [ self buildTabbedNameOf: anElement ]
				ifFalse: [
					 self selectedPackage 
							ifNil: [anElement name]
							ifNotNil: [:package | 
								( anElement package = package)
									ifTrue: [ anElement name asStringMorph ]
									ifFalse: [ anElement name asStringMorph color: self extensionColor;yourself]]]]
		ifClasses: [
			"anElement is a RPackage"
			(self selectedClass package == anElement)
				ifTrue: [anElement name]
				ifFalse: ['*', anElement name]]! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
listWrapper: anElement

	anElement = 0 ifTrue: [^''].
	^ self 
		ifGroups: [ anElement name ]
		ifNot: [ self 
				ifPackages: [ anElement name  ] 
				ifClasses: [ self buildTabbedNameOf: anElement ]]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 17:15'!
loadList
	
	^ self 
		ifGroups: [ self getGroupsKeyList ]
		ifNot: [
			self 
				ifPackages: [ self getPackagesList ] 
				ifClasses: [
					cachedHierarchy
						ifNil: [ self getClassHierarchy ]
						ifNotNil: [:col | col keys sort: [:a :b | self sortClassesInCachedHierarchy: a b: b]]]]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 15:45'!
loadList2

	^ self 
		ifGroups: [
			self showHierarchy
				ifTrue: [ self getGroupHierarchy ]
				ifFalse: [ self getGroupsValuesList ]]
		ifNot: [
			 self 
				ifPackages: [
					self showHierarchy
						ifTrue: [ self getClassHierarchy2 ]
						ifFalse: [ self getPackagesList2 ]]
				ifClasses: [self getClassesList2 ]]! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
mcPackageModified: anAnnouncement
	" handled when a package become dirty "
	
	| rpackage |
	window ifNil: [^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	rpackage := anAnnouncement package correspondingRPackage.
	(self model packages includes: rpackage )
		ifTrue: [ self updatePackageView ]! !

!AbstractNautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
menu2: aMenu shifted: aBoolean 
	self
		ifPackages: [self classesMenu: aMenu shifted: aBoolean]
		ifClasses: [
			self showGroups
				ifTrue: [self groupsMenu: aMenu shifted: aBoolean]
				ifFalse: [self packagesMenu: aMenu shifted: aBoolean]].
	^ aMenu! !

!AbstractNautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
menu: aMenu shifted: aBoolean 
	self
		ifPackages: [
			self showGroups
				ifTrue: [self groupsMenu: aMenu shifted: aBoolean]
				ifFalse: [self packagesMenu: aMenu shifted: aBoolean]]
		ifClasses: [self classesMenu: aMenu shifted: aBoolean].
	^ aMenu! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
mergeGroups

	| group |
	group := self mergeGroups: self selectedGroups.
	group
		ifNotNil: [ 
			self groupsManager addAGroup: group.
			self selectedGroup: group.
			self updateBothView]
! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 2/20/2012 17:04'!
methodAdded: anAnnouncement

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
methodHierarchy
	"Create and schedule a method browser on the hierarchy of implementors."

	self methodHierarchyFrom: self selectedMethod! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
methodMenuBuilder

	^ NautilusPragmaMenuBuilder withAllPragmaKeywords: {self commonPragma. self methodPragma} model: self! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 2/20/2012 17:07'!
methodModified: anAnnouncement 
	
	^ self subclassResponsibility ! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 5/24/2011 14:15'!
methodPragma

	^'nautilusMethodMenu'! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 2/20/2012 17:05'!
methodRecategorized: anAnnouncement
	
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 2/20/2012 17:05'!
methodRemoved: anAnnouncement

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/18/2012 15:29'!
methodsForCategories: aCollection

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
methodsForCategory: aCategory
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'icon caches' stamp: 'BenjaminVanRyseghem 10/19/2011 18:14'!
methodsIconsCache

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
model

	^ model! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
model: anObject

	model := anObject.
	model when: #historyChanged send: #historyChanged to: self.! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/7/2011 11:17'!
moveCategory: anObject toTheClass: aClass
	
	| originClass methods |
	originClass := self selectedClass.
	methods := originClass methodsInProtocol: anObject.
	methods do: [:meth | self moveMethod: meth toTheClass: aClass autoRemove: true ].
	
	(originClass methodsInProtocol: anObject)
		ifEmpty: [ 
			originClass removeCategory: anObject.
			self selectedCategory: nil ].! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 11/14/2011 17:51'!
moveInNewPackage

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| item |
	self okToChange ifFalse: [^ self].

	item := self moveInNewPackage: (self selectedClasses collect: [:e | e theNonMetaClass ]).

	item ifNotNil: [ self selectedPackage: item ].
	self updateBothView! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/7/2011 11:23'!
moveMethod: aMethod toTheClass: aClass autoRemove: autoRemove
	
	| newMethod shouldBeInstall |
	aMethod realClass = aClass ifTrue: [ ^ self ].
	shouldBeInstall := aClass methodDict
						at: aMethod selector
						ifPresent: [:sel | 
							" here I have to fork to release the drag & drop "
							[ (self openDialogWouldYouInstall: sel into: aClass)
								ifTrue: [ | originClass oldCategory |
									oldCategory := aMethod category.
									originClass := aMethod realClass.
									newMethod := aClass compile: aMethod sourceCode classified: oldCategory.
									self selectedMethod: nil.
									
									originClass removeSelector: aMethod selector.
									autoRemove
										ifTrue: [	( originClass methodsInProtocol:oldCategory )
												ifEmpty: [ originClass removeCategory: oldCategory ]]]] fork]
						ifAbsent: [ 
							 | originClass oldCategory |
							oldCategory := aMethod category.
							originClass := aMethod realClass.
							newMethod := aClass compile: aMethod sourceCode classified: oldCategory.
							self selectedMethod: nil.
							originClass removeSelector: aMethod selector.
							autoRemove
								ifTrue: [
									( originClass methodsInProtocol: oldCategory )
										ifEmpty: [ originClass removeCategory: oldCategory ]]]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
moveMethodToPackage
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'displaying' stamp: 'CamilloBruni 9/6/2011 20:37'!
newGroupBoxMorph
	| morph |
 	morph := GroupboxMorph new.
	morph contentMorph
		layoutInset: (0@0 corner: 0@0);
		cellInset: 0.
	^ morph! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 5/26/2011 17:15'!
newMCVersion: anAnnouncement

	| rpackage |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	rpackage := anAnnouncement version package correspondingRPackage.
	rpackage ifNil: [ ^ self ].
	( self model packages includes: rpackage )
		ifTrue: [ 
			self removeFromPackagesIconsCache: rpackage.
			self updatePackageView ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
noMethodsString

	^ ClassOrganizer nullCategory! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 10/7/2011 19:57'!
okToChange

	self canDiscardEdits ifTrue: [^ true].
	self changed: #wantToChange.  "Solicit cancel from view"
	^ self canDiscardEdits
! !

!AbstractNautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 9/16/2011 18:08'!
open

	window := NautilusWindow new model: self.
	self addAll: window.
	window openInWorld.
	self changed:#sourceCode.
	self setWindowTitle.
	
	

	self model announce: (NautilusOpenedAnnouncement window: window)! !

!AbstractNautilusUI methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 11/12/2011 16:51'!
openCommentEditor: aClass
	| newComment |

	newComment :=UITheme current 
						textEditorIn: window
						text: 'Enter a comment for the class ', aClass theNonMetaClass name,':'
						title: 'Comment Editor'
						entryText: aClass theNonMetaClass comment
						entryHeight: 300.
	newComment
		ifNotNil: [ aClass theNonMetaClass comment: newComment asString ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/7/2011 10:52'!
openDialogWouldYouInstall: aMethod into: aClass

	"open a dialog to ask user if he wants to override the existing method or not"
	^ UIManager default confirm: 'Are you sure you want to override the method ', aMethod selector, ' in ', aClass name label: 'Override'! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
packageChanged: anAnnouncement

	window isDisplayed ifFalse: [ ^ self ].

	self showGroups not
		ifTrue: [ self updatePackageView ]! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
packageCreated: anAnnouncement

	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	self showGroups not
		ifTrue: [ self updatePackageView ]! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 5/24/2011 14:15'!
packageFixPragma

	^ 'nautilusPackageFixMenu'! !

!AbstractNautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 2/21/2012 02:38'!
packageIconFor: aPackage

	PackagesIconsCache
		at: aPackage
		ifPresent: [:icon | 
			
			 icon class == IconicButton ifFalse: [ ^ icon ].
			
			^ IconicButton new 
						target: icon target;
						actionSelector: icon actionSelector;
						arguments: icon arguments;
						labelGraphic: icon labelGraphic;
						color: icon color;
						helpText: icon helpText;
						extent: icon extent;
						borderWidth: icon borderWidth
			
			 ].

	aPackage classes isEmpty ifTrue: [^ PackagesIconsCache at: aPackage put: (self iconClass iconNamed: #emptyPackageIcon) ].
	
	aPackage isDirty
		ifTrue: [ ^ PackagesIconsCache at: aPackage put: ( IconicButton new 
															target: self;
															actionSelector: #saveDirtyPackages:;
															arguments: {{ aPackage }};
															labelGraphic: (aPackage definedClasses
																				ifEmpty: [ (self iconClass iconNamed: #dirtyMonticelloPackageIcon) ]
																				ifNotEmpty: [ (self iconClass iconNamed: #dirtyPackageIcon) ]);
															color: Color transparent;
															extent: 15 @ 16;
															helpText: 'Save the package';
															borderWidth: 0) ].

	((MCPackage allInstances anySatisfy: [:e | e name = aPackage name ]) and: [ aPackage definedClasses isEmpty])
		ifTrue: [ ^ PackagesIconsCache at: aPackage put: (self iconClass iconNamed: #monticelloPackage) ].

	^ PackagesIconsCache at: aPackage put: (self iconClass iconNamed: #packageIcon)! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
packageLabel

	^'Packages'! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 2/20/2012 17:58'!
packageMenuBuilder

	^ NautilusPragmaMenuBuilder withAllPragmaKeywords: {"self packageFixPragma. "self packagePragma} model: self! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 5/24/2011 14:15'!
packagePragma

	^ 'nautilusPackageMenu'! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
packageRenamed: anAnnouncement

	window isDisplayed ifFalse: [ ^ self ].
	self showGroups not
		ifTrue: [ self updatePackageView ]! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
packageUnregistred: anAnnouncement

	self showGroups not
		ifTrue: [ | package |
			package := anAnnouncement package.
			self selectedPackage = package
				ifTrue: [ self selectedPackage: nil ].
			packagesSelection at: package put: false.
			window isDisplayed ifFalse: [ ^ self ].
			self updatePackageView ]! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
packagesMenu: aMenu shifted: aBoolean 

	^ aMenu becomeForward: (self packageMenuBuilder menu)! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/27/2011 15:15'!
popUpTestsResult: aClass! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
putSourceTextAreaLimit

	sourceTextArea ifNotNil: [ sourceTextArea warningLimit: sourceTextAreaLimit ]! !

!AbstractNautilusUI methodsFor: 'announcement registration' stamp: 'BenjaminVanRyseghem 1/29/2012 23:34'!
registerToAnnouncements

	SystemAnnouncer announcer weak
		on: RPackageCreated send: #packageCreated: to: self;"
		on: RPackageUnregistred send: #packageUnregistred: to: self;"
		on: RPackageRenamed send: #packageRenamed: to: self;
	
		on: ClassAdded send: #classAdded: to: self;
		on: ClassCommented send: #classCommented: to: self;
		on: ClassRecategorized send: #classRecategorized: to: self;
		on: ClassModifiedClassDefinition send: #classDefinitionModified: to: self;
		on: ClassRemoved send: #classRemoved: to: self;
		on: ClassRenamed send: #classRenamed: to: self;
		on: ClassReorganized send: #classReorganized: to: self;
		
		on: MethodAdded send: #methodAdded: to: self;
		on: MethodModified send: #methodModified: to: self;
		on: MethodRecategorized send: #methodRecategorized: to: self;
		on: MethodRemoved send: #methodRemoved: to: self;
		
		on: ProtocolAdded send: #classRecategorized: to: self;
		on: ProtocolRemoved send: #classRecategorized: to: self.

	TestAnnouncer announcer weak
		on: TestSuiteEnded send: #testRunned: to: self.
		
	MonticelloAnnouncer announcer weak	
		on: AMCVersionHasBeenCreated send: #newMCVersion: to: self;
		on: AMCPackageHasBeenModified send: #mcPackageModified: to: self.
		
	GroupAnnouncer announcer weak
		on: AGroupHasBeenRegistered send: #aGroupHasBeenRegistered: to: self;
		on: AGroupHasBeenUnregistered send: #aGroupHasBeenUnregistered to: self;
		on: AGroupHasBeenAdded send: #aGroupHasBeenAdded: to: self;
		on: AGroupHasBeenRemoved send: #aGroupHasBeenRemoved: to: self;
		on: AGroupHasBeenRenamed send: #aGroupHasBeenRenamed: to: self! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
removeClassFromGroup

	self groupsManager remove: self selectedClass from: self selectedGroup.
	self updateClassView.! !

!AbstractNautilusUI methodsFor: 'icon caches' stamp: 'BenjaminVanRyseghem 2/7/2012 14:58'!
removeClassFromMethodsIconsCache: aClass

	self methodsIconsCache keys do: [:method | 
		" for overrides "
		method methodClass = aClass
			ifTrue: [ 
				self removeFromClassesIconsCache: aClass.
				self methodsIconsCache removeKey: method ifAbsent: [ ]]].! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 2/14/2012 20:46'!
removeClasses
	"Remove the selected class from the system, at interactive user request.  Make certain the user really wants to do this, since it is not reversible.  Answer true if removal actually happened."

	| result scroll |
	self okToChange ifFalse: [^ false].
	scroll := self
				ifPackages: [ list2 scrollValue y ]
				ifClasses: [ list scrollValue y ].
				
	result := self dispatchRemoveClasses: (self selectedClasses collect: [:e | e theNonMetaClass ]).

	result
		ifTrue: [	
			classesSelection removeAll.
			self selectedClass: nil ].
	self
		ifPackages: [ list2 vScrollValue: scroll ]
		ifClasses: [ list vScrollValue: scroll ].
	^ result! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
removeEmptyCategories

	self okToChange ifFalse: [^ self].
	(self methodsForCategory: self selectedCategory) 
		ifEmpty: [ self selectedCategory: nil ].
		
	self removeEmptyCategoriesFrom: self selectedClass.
	
	self update.! !

!AbstractNautilusUI methodsFor: 'icon caches' stamp: 'BenjaminVanRyseghem 8/21/2011 11:34'!
removeFromClassesIconsCache: aClass
	" not used since the class's icons are always the same "
	
	ClassesIconsCache removeKey: aClass ifAbsent: [].
	self updateClassView.! !

!AbstractNautilusUI methodsFor: 'icon caches' stamp: 'BenjaminVanRyseghem 5/26/2011 17:29'!
removeFromGroupsIconsCache: aClass
	" not used since the groups's icons are always the same "


	GroupsIconsCache removeKey: aClass ifAbsent: [].! !

!AbstractNautilusUI methodsFor: 'icon caches' stamp: 'BenjaminVanRyseghem 10/12/2011 15:56'!
removeFromMethodsIconsCache: aMethod
	" if a test method has changed, we should reset the correspondng method "
	
	| corresponding |
	corresponding := aMethod correspondingMethods.
	corresponding do: [:each | self methodsIconsCache removeKey: each ifAbsent: []].
	self removeFromClassesIconsCache: aMethod methodClass.
	self methodsIconsCache removeKey: aMethod ifAbsent: [ ].! !

!AbstractNautilusUI methodsFor: 'icon caches' stamp: 'BenjaminVanRyseghem 5/26/2011 17:16'!
removeFromPackagesIconsCache: aPackage

	PackagesIconsCache removeKey: aPackage ifAbsent: [].! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 6/2/2011 17:02'!
removeGroup

	self okToChange ifFalse: [ ^ self ].
	self selectedGroups
		ifNotEmpty:[:groups |
			groupsSelection removeAll.
			groups do: [:group | self groupsManager removeAGroupSilently: group ].
			self selectedGroup: nil].
		! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 10/19/2011 06:16'!
removeMethod: aMethod inClass: aClass
	"If a message is selected, create a Confirmer so the user can verify that  
	the currently selected message should be removed from the system. If 
	so, remove it. "
	
	self okToChange ifFalse: [^ false].
	^ super removeMethod: aMethod inClass: aClass! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
removeNonLocalSelector: aSymbol

	self selectedClass ifNotNil: [:class | self removeNonLocalSelector: aSymbol from: class ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 1/19/2012 22:46'!
removePackages

	| names |
	self selectedPackages 
		ifNotEmpty: [:packages |
			names := packages collect: [:package | package name ].
			names := names joinUsing: String cr.
			(UIManager default confirm: ('Are you sure you want to delete the package(s) named ', String cr, names, ' ?'))
				ifTrue: [| scroll |
					packages do: [:package |
						self browsedEnvironment packageOrganizer unregisterPackage: package].
					scroll := self
								ifPackages: [ list scrollValue y ]
								ifClasses: [ list2 scrollValue y ].
					self selectedPackage: nil.
					self updatePackageView.
					self
						ifPackages: [ list vScrollValue: scroll ]
						ifClasses: [ list2 vScrollValue: scroll ]]]! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
removeSourceTextAreaLimit

	sourceTextArea ifNotNil: [ sourceTextArea warningLimit: -1 ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
renameCategory
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 1/23/2012 17:47'!
renameClass

	self okToChange ifFalse: [ ^ self ].

	self dispatchRenameClass: self selectedClass theNonMetaClass.

	self changed: #sourceCode.! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
renameGroup

	| newName |
	self groupsManager renameAGroup: self selectedGroup.
	self updateBothView! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 1/19/2012 19:47'!
renamePackage

	self renamePackages: self selectedPackages.
	cachedHierarchy := self buildPackageHierarchyFor: self selectedPackage.
	self updatePackageView.
	! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
resetListSelection

	self listSelection removeAll.! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
resetListSelection2

	self listSelection2 removeAll.! !

!AbstractNautilusUI methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/12/2011 12:38'!
resetSelections! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
restrictedBrowseClass

	self selectedClass
		ifNil: [ ^ self ]
		ifNotNil:[:class || newEnvironment |
			newEnvironment := self browsedEnvironment forClasses: {class}.
			 self model class openOnClass: class inEnvironment: newEnvironment ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 2/1/2012 13:05'!
restrictedBrowseGroup: aCollection

	aCollection
		ifNotEmpty: [:groups || elements newEnvironment |
			elements := groups gather: [:group | group elements].
			newEnvironment := self browsedEnvironment forClasses: (elements collect: #theNonMetaClass).
			self model class openOnGroup: groups first inEnvironment: newEnvironment ]! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 8/3/2011 02:33'!
restrictedBrowsePackage

	self selectedPackages
		ifEmpty: [ ^ self ]
		ifNotEmpty: [:packages || newEnvironment |
			newEnvironment := self browsedEnvironment forPackages: packages.
			 self model class openOnPackage: self selectedPackage inEnvironment: newEnvironment ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/1/2011 14:15'!
rootsOf: aPackage

	| tmpList |
	 tmpList := aPackage definedClasses.
	self browsedEnvironment isSystem
		ifFalse: [ tmpList := self model classes intersection: tmpList ].
		
	^ tmpList select: [:each |
		(tmpList includes: (each superclass)) not]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/1/2011 14:16'!
rootsOfGroup: aGroup

	| classes |
	self browsedEnvironment isSystem
		ifTrue: [ classes := aGroup elements ]
		ifFalse: [ classes := aGroup elements intersection: self model classes ].

	^ classes select: [:each |
		(classes includes: each superclass) not]! !

!AbstractNautilusUI methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 10/7/2011 15:13'!
runClassTests

	self runClassTests: self selectedClasses! !

!AbstractNautilusUI methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 10/7/2011 15:13'!
runClassTests: aCollection

	aCollection
		ifNotEmpty:[:classes | 
			classes do: [:class | self runTestsOfClass: class ]]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 10/7/2011 15:13'!
runPackagesTests

	self selectedPackages
		ifNotNil: [:packages || classes |
			classes := packages gather: [:package | package definedClasses ].
			classes := classes select: [:class | class inheritsFrom: TestCase ].
			self runClassTests: classes ].! !

!AbstractNautilusUI methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 9/28/2011 19:28'!
runTestFor: aCollection

	aCollection do: [:each | 
		each isTestMethod
			ifTrue: [ self runTestForAMethod: each ]]! !

!AbstractNautilusUI methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 2/21/2012 02:50'!
runTestForAMethod: aMethod

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'icons behavior' stamp: 'AlexandreBergel 8/21/2011 17:18'!
runTestsOfClass: aClass 
	
	aClass methodDict do: [:method | 
		method isTestMethod
			ifTrue: [ self runTestForAMethod: method ]].
	self popUpTestsResult: aClass correspondingForTest ! !

!AbstractNautilusUI methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 10/7/2011 15:20'!
runTestsOfGroups: aCollection 
	
	| classes |
	
	classes := aCollection gather:[:each | each elements ].
	" Maybe to slow ... I keep this version because I do not know waht to do here "
	"classes do: [:class || testClass |
		(testClass := class correspondingForTest) = class 
			ifFalse: [ self runTestsOfClass: testClass ]]."
		
	classes := classes select: [:class | class inheritsFrom: TestCase ].
	self runClassTests: classes! !

!AbstractNautilusUI methodsFor: 'icons behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
saveDirtyPackages: aCollection 
	
	
	aCollection isEmptyOrNil ifTrue: [ ^ self ].
	aCollection do: [:package || workCopy browser wrap index |
		
		workCopy := MCWorkingCopy forPackage: (MCPackage named: package name).
		browser :=MCWorkingCopyBrowser new.
		browser
			show;
			workingCopy: workCopy.
		"wrap := MCDependentsWrapper with: workCopy model: browser.
		self halt.
		index := browser workingCopySelectionWrapper: wrap.
		browser workingCopyTreeMorph selectionIndex: index"]
	! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
selected

	| item |
	item :=  self 
				ifGroups: [ self selectedGroup ]
				ifNot: [ self ifPackages: [ self selectedPackage ] ifClasses: [ self selectedClass ]].
				
	^self getList indexOf: item.! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/7/2012 18:21'!
selected2

	| item |
	item :=  self 
		ifPackages: [ | tmp |
			tmp := self selectedClass.
			self showInstance ifFalse: [ tmp ifNotNil: [tmp := tmp theNonMetaClass]].
			tmp ] 
		ifClasses: [ self selectedPackage ].
	.
	^self getList2 indexOf: item.! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/7/2012 18:21'!
selected2: anInteger

	| selection |
	selection := self getList2 at: anInteger ifAbsent: [nil].
	self 
		ifPackages: [ 
			self showInstance ifFalse: [selection ifNotNil: [selection := selection theMetaClass]].
			self selectedClassWithoutChangingSelection: selection ] 
		ifClasses: [	self selectedPackageWithoutChangingSelection: selection ].
	self changed: #selected2.! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/7/2012 15:32'!
selected: anInteger

	| selection |
	list2Elements := nil.
	selection := self getList at: anInteger ifAbsent: [nil].
	self 
		ifGroups: [ self selectedGroupWithoutChangingSelection: selection ]
		ifNot: [ 
			self 
				ifPackages: [ self selectedPackageWithoutChangingSelection: selection] 
				ifClasses: [ 
					self showInstance ifFalse: [selection ifNotNil: [selection := selection class]].
					self selectedClassWithoutChangingSelection: selection] ].
	
	self changed: #selected.! !

!AbstractNautilusUI methodsFor: 'SmalltalkEditor compatibility' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
selectedBehavior

	^ self selectedClass! !

!AbstractNautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 10/20/2011 14:22'!
selectedCategory

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 10/20/2011 14:22'!
selectedCategory: anObject

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'bvr 8/30/2011 22:15'!
selectedClass

	| class |
	class := self model selectedClass.
	(self model selectedCategory isNil and: [ self model selectedMethod isNil ])
		ifTrue: [ self setStylerClass: nil ]
		ifFalse: [ self setStylerClass: class ].
	^ class! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/23/2011 21:14'!
selectedClass: aClass 

	self okToChange
		ifTrue: [
			classesSelection removeAll.				
			classesSelection at: aClass put: true.
			aClass ifNotNil: [ 
				self 
					ifPackages: [ self giveFocusTo: list2 ]
					ifClasses: [ self giveFocusTo: list ]].	
			self selectedClassWithoutChangingSelection: aClass ]! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
selectedClassComments

	^ self selectedClass
		ifNil: ['']
		ifNotNil: [:class| class comment]! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 9/1/2011 14:16'!
selectedClassDescription

	^ self selectedClass definition! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
selectedClassWithoutChangingSelection: aClass 
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
selectedClasses

	| associations |
	associations := classesSelection associations select: [:assoc | assoc value ].
	associations := associations collect: [:assoc | assoc key ].
	^ associations select: [:each | each notNil ]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
selectedGroup
	
	^ self model selectedGroup! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/23/2011 20:30'!
selectedGroup: anObject

	self okToChange
		ifTrue: [
			groupsSelection removeAll.
			anObject ifNotNil: [ self giveFocusTo: list ].
			groupsSelection at: anObject put: true.
			self selectedGroupWithoutChangingSelection: anObject ]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/10/2012 19:00'!
selectedGroupWithoutChangingSelection: anObject

	self okToChange
		ifTrue: [
			anObject ifNil: [ groupsSelection removeAll ].
			self model selectedGroup: anObject.
			groupsSelection at: anObject put: true.
			self selectedClass: nil.
			self updateClassView ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
selectedGroups

	| associations |
	associations := groupsSelection associations select: [:assoc | assoc value ].
	associations := associations collect: [:assoc | assoc key ].
	^ associations select: [:each | each notNil ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
selectedItems

	| associations |
	associations := self listSelection associations select: [:assoc | assoc value ].
	^ associations collect: [:assoc | assoc key ].! !

!AbstractNautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 10/20/2011 14:23'!
selectedMethod

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 10/20/2011 14:23'!
selectedMethod: aMethod

	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
selectedMethodComments

	^ self selectedMethod comment! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 9/5/2011 11:05'!
selectedMethodSource

	self selectedMethod
		ifNil: [ ^ '' ]
		ifNotNil: [:method |
			self showSource
				ifTrue: [	^ method sourceCode ].
			self showByteCode
				ifTrue: [	^ method symbolic asText].
			self showDecompile
				ifTrue: [	^  method decompileWithTemps decompileString asText makeSelectorBoldIn: method methodClass ].
			^ 'error']			! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
selectedPackage

	^ self model selectedPackage! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/23/2011 21:14'!
selectedPackage: aPackage
" Force package selection, not used by the lists "

	self okToChange
		ifTrue: [
			packagesSelection removeAll.
			packagesSelection at: aPackage put: true.
				
			aPackage ifNotNil: [ 
				self 
					ifPackages: [ self giveFocusTo: list ]
					ifClasses: [ self giveFocusTo: list2 ]].	
				
			self selectedPackageWithoutChangingSelection: aPackage]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/23/2011 13:58'!
selectedPackageWithoutChangingSelection: aPackage

	self okToChange
		ifTrue: [| class |
			class := self selectedClass.
			(self showPackages and: [class notNil and: [class package ~= aPackage]])
				ifTrue: [ self selectedClass: nil ].
			self model package: aPackage class: self selectedClass category: nil method: nil.
			packagesSelection at: aPackage put: true.
			self updateClassView.
			self update.
			self changed: #getComments.
			self changed: #sourceCode]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/23/2011 21:09'!
selectedPackageWithoutChangingSelectionInternally: aPackage

	self okToChange
		ifTrue: [| class |
			class := self selectedClass.
			(self showPackages and: [class notNil and: [class package ~= aPackage]])
				ifTrue: [ self selectedClass: nil ].
			packagesSelection at: aPackage put: true.
			
			aPackage ifNotNil: [ 
				self 
					ifPackages: [ self giveFocusTo: list ]
					ifClasses: [ self giveFocusTo: list2 ]].
			
			self updateClassView.
			self update.
			self changed: #getComments.
			self changed: #sourceCode]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
selectedPackages

	| associations |
	associations := packagesSelection associations select: [:assoc | assoc value ].
	associations := associations collect: [:assoc | assoc key ].
	^ associations select: [:each | each notNil ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 16:22'!
setCachedHierarchyClass: aClass

	cachedHierarchy := self buildHierarchyFor: aClass.! !

!AbstractNautilusUI methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/20/2012 20:55'!
setClassShorcutsTo: aList

	aList attachKeymapCategory: #NautilusClassShortcuts targetting: self! !

!AbstractNautilusUI methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/20/2012 20:55'!
setGroupShorcutsTo: aList

	aList attachKeymapCategory: #NautilusGroupShortcuts targetting: self! !

!AbstractNautilusUI methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/20/2012 20:55'!
setPackageShorcutsTo: aList

	aList attachKeymapCategory: #NautilusPackageShortcuts targetting: self! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'bvr 8/30/2011 22:14'!
setStylerClass: aClass

	sourceTextArea
		ifNotNil: [ sourceTextArea classOrMetaClass: aClass ]! !

!AbstractNautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 2/18/2012 17:11'!
setWindowTitle

	| title |
	title := self selectedClass 
				ifNil: [ self selectedPackage
							ifNil: [ self title ]
							ifNotNil: [: p | p name ]]
				ifNotNil: [:class |
					self selectedMethod
						ifNil: [ class name asString ]
						ifNotNil: [:method |
							method methodClass name asString, '>>#', method selector ]].
	window title: title.! !

!AbstractNautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 2/18/2012 17:04'!
shiftedSourceCodeMenu: aBuilder
	<nautilusSourceCodeMenu>
	| donorMenu items |
	items := OrderedCollection new.
	donorMenu := SmalltalkEditor shiftedYellowButtonMenu.
	donorMenu submorphs doWithIndex: [:each :order |
		(each isKindOf: MenuLineMorph)
			ifTrue: [ items last withSeparatorAfter ]
			ifFalse: [
				items add: ((aBuilder item: each contents asSymbol)
								selector: each selector;
								target: each target;
								parent: #'Extended search...';
								arguments: each arguments;
								order: order).
				each icon ifNotNil: [:ic | items last icon: ic ]]].
	(items last: 2) doWithIndex: [:e :i | e order: (9998 + i) ]! !

!AbstractNautilusUI methodsFor: 'Shout' stamp: 'BenjaminVanRyseghem 9/20/2011 15:14'!
shoutAboutToStyle: aPluggableShoutMorphOrView 

	^ aPluggableShoutMorphOrView == sourceTextArea! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
showByteCode

	^ self currentDisplayChoice = self byteCodeSymbol! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
showComment

	^ self model showComment! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/6/2012 16:40'!
showComment: aBoolean

	self model showComment: aBoolean.
	
	commentTextArea
		ifNil: [ self buildCommentPane ].
		
	sourceCodePanel removeAllMorphs.	
	aBoolean
		ifTrue: [ self buildCodePanelWithComment ]
		ifFalse: [ self buildCodePanelWithoutComment ]! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
showDecompile

	^ self currentDisplayChoice = self decompileSymbol! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
showGroups

	^ self model showGroups! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/20/2012 21:14'!
showGroups: aBoolean

	self okToChange
		ifTrue: [
			listElements := nil.
			self showPackages 
				ifFalse: [ self showPackagesSilently: true ].
			self selectedGroup
				ifNil: [ self selectedClass: nil ]
				ifNotNil: [:group |
					(group elements includes: self selectedClass)
						ifFalse: [ 
							list2Elements := nil.
							self selectedClass: nil ].
			list detachAllKeymapCategories.
			list2 detachAllKeymapCategories.
			aBoolean 
				ifTrue: [ 
					self setGroupShorcutsTo: list.
					groupsSelection at: group put: true ]
				ifFalse: [ 
					self setPackageShorcutsTo: list.
					self setClassShorcutsTo: list2.
					packagesSelection at: self selectedPackage put: true ]].
			self model showGroups: aBoolean.
			self changed: #groupsButtonLabel.
			self changedLabels.
			self updateBothView ]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
showGroupsSilently: aBoolean

	self model showGroups: aBoolean! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/8/2012 16:31'!
showHierarchy

	^ self model showHierarchy! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/7/2012 15:48'!
showHierarchy: aBoolean

	self model showHierarchy: aBoolean.
	listElements := nil.
	list2Elements := nil.
	aBoolean 
		ifTrue: [ self hierarchyClass: self selectedClass ]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
showInstance

	^ self model showInstance! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/1/2011 10:13'!
showInstance: aBoolean

	self model showInstance: aBoolean.
	classesSelection removeAll.
	self selectedClass 
		ifNotNil: [:class | 
			aBoolean 
				ifTrue: [self selectedClass: class theNonMetaClass ]
				ifFalse: [self selectedClass: class theMetaClass ]].
	self update.
	self changed: #instanceButtonLabel! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/22/2012 14:24'!
showPackages

	^  self model showPackages! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/21/2012 15:37'!
showPackages: aBoolean

	self okToChange
		ifTrue: [
			listElements := nil.
			list2Elements := nil.
			list detachAllKeymapCategories.
			list2 detachAllKeymapCategories.
			aBoolean
				ifTrue: [ 
					self setPackageShorcutsTo: list.
					self setClassShorcutsTo: list2.]
				ifFalse: [| class |
					class := self selectedClass theNonMetaClass.
					classesSelection at: class put: true.
					self hierarchyClass: class .
					listElements := nil.
					list2Elements := nil.
					self showGroups
						ifTrue: [self showGroupsSilently: false].
					self setPackageShorcutsTo: list2.	
					self setClassShorcutsTo: list ].
			listElements := nil.
			list2Elements := nil.
			self model showPackages: aBoolean.
			self changed: #groupsButtonLabel.
			self updateBothView.
			self changed: #toogleButtonState.
			self changedLabels ]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
showPackagesSilently: aBoolean

	self model showPackages: aBoolean.! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
showSource

	^ self currentDisplayChoice = self sourceCodeSymbol! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
showUnreferencedClassVars
	"Search for all class variables known to the selected class, and put up a 
	list of those that have no references anywhere in the system. The 
	search includes superclasses, so that you don't need to navigate your 
	way to the class that defines each class variable in order to determine 
	whether it is unreferenced"
	self showUnreferencedClassVarsOf: self selectedClass.! !

!AbstractNautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
showUnreferencedInstVars
	"Search for all instance variables known to the selected class, and put up a list of those that have no references anywhere in the system.  The search includes superclasses, so that you don't need to navigate your way to the class that defines each inst variable in order to determine whether it is unreferenced"

	self showUnreferencedInstVarsOf: self selectedClass! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 17:47'!
sortClassesInCachedHierarchy: a b: b
	"Bullshitty name, Thanks Camillo"
	| index aa bb minSize|
	aa := cachedHierarchy at: a.
	bb := cachedHierarchy at: b.
	
	minSize := aa size min: bb size.
	
	1 to: minSize do: [ :i | |compare|
		compare := (aa at: i) name compare: (bb at: i) name.
		compare ~~ 2
			ifTrue: [  ^ compare == 1 ]].
	^  aa size < bb size! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'bvr 8/30/2011 22:07'!
sourceCode

	self removeSourceTextAreaLimit.
	^self selectedClass isNil
		ifTrue: [ self defaultClassDescriptor]
		ifFalse:[ self selectedMethod isNil
				ifTrue: [ self selectedCategory notNil
						ifTrue: [ 
							self putSourceTextAreaLimit.
							self defaultMethodSource]
						ifFalse: [ self selectedClassDescription]]
				ifFalse: [ 
					self putSourceTextAreaLimit.
					self selectedMethodSource]].
		! !

!AbstractNautilusUI methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 1/24/2012 20:42'!
sourceCode: aText 

	self okToChange
		ifTrue: [ 
			sourceTextArea setText: aText.
			sourceTextArea takeKeyboardFocus ]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/21/2011 16:19'!
sourceCodeContainer

	^ sourceCodeContainer! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 2/15/2012 01:13'!
sourceCodeMenu: aMenu shifted: shifted
	" Morphic's menus are filled up when pragma's one are returned from a method, so I have to substitute the morphic menu by the pragma one "
	
	^ aMenu becomeForward: (self sourceCodeMenuBuilder menu)! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 2/15/2012 01:14'!
sourceCodeMenuBuilder

	^ NautilusPragmaMenuBuilder pragmaKeyword: self sourceCodePragma model: self! !

!AbstractNautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
sourceCodeOkToChange

	sourceTextArea canDiscardEdits ifTrue: [^ true].
	sourceTextArea update: #wantToChange.  "Solicit cancel from view"
	^ sourceTextArea canDiscardEdits
! !

!AbstractNautilusUI methodsFor: 'menu pragmas' stamp: 'BenjaminVanRyseghem 2/15/2012 01:15'!
sourceCodePragma

	^ 'nautilusSourceCodeMenu'! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
sourceCodeSymbol

	^ #SourceCode! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 10/20/2011 14:13'!
sourceTextArea

	^ sourceTextArea! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
switchToByteCodeButton

	self sourceCodeOkToChange ifTrue: [ self currentDisplayChoice: self byteCodeSymbol ]! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
switchToDecompileButton

	self sourceCodeOkToChange ifTrue: [ self currentDisplayChoice: self decompileSymbol ]! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 1/21/2012 23:11'!
switchToSourceCodeButton

	self sourceCodeOkToChange ifTrue: [ self currentDisplayChoice: self sourceCodeSymbol ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
systemNavigation

	^ SystemNavigation new 
			browsedEnvironment: self browsedEnvironment;
			yourself! !

!AbstractNautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
taskbarIcon

	^ self class icon! !

!AbstractNautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 2/7/2012 18:21'!
testRunned: anAnnouncement

	| collection class correspondingClass |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	class := anAnnouncement testResult.
	correspondingClass := anAnnouncement testResult correspondingClass.
	collection := self 
		ifPackages: [ self getList2 ]
		ifClasses: [ self getList ].
	
	
	(collection includesAnyOf: {class. correspondingClass})
		ifTrue: [ 
			self removeClassFromMethodsIconsCache: class.
			self removeClassFromMethodsIconsCache: correspondingClass.
			self updateClassView.
			self update ].! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
textMorphClass

	^ PluggableTextMorphWithLimits! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
title

	^'Nautilus'! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
toogleButtonAction

	self selectedClass ifNil: [^self].
	self toogleShowPackages! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
toogleButtonLabel

	^ 'Hierarchy'! !

!AbstractNautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
toogleButtonState

	^ self showPackages not! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
toogleShowComment

	self showComment: self showComment not! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
toogleShowGroups

	self showGroups: self showGroups not.! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
toogleShowHierarchy

	self showHierarchy: self showHierarchy not.
	self updateBothView
! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
toogleShowInstance
	^ self subclassResponsibility! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
toogleShowPackages

	self showPackages: self showPackages not.! !

!AbstractNautilusUI methodsFor: 'announcement registration' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
unregisterAPlugin: aPlugin

	self announcer unsubscribe: aPlugin! !

!AbstractNautilusUI methodsFor: 'announcement registration' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
unregisterAllPlugins

	self announcer subscriptions reset! !

!AbstractNautilusUI methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/16/2011 15:53'!
update! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 19:22'!
updateBothView

	listElements := nil.
	list2Elements := nil.
	self changed: #getList.
	self changed: #getList2! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 19:22'!
updateClassView

	self	
		ifPackages:  [ 
			list2Elements := nil.
			self changed: #getList2 ]
		ifClasses: [ 
			listElements := nil.
			self changed: #getList ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 19:22'!
updateGroupView

	listElements := nil.
	self changed: #getList! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 19:22'!
updatePackageView

	self	
		ifPackages: [ 
			listElements := nil.
			self changed: #getList ]
		ifClasses: [ 
			list2Elements := nil.
			self changed: #getList2 ]! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 19:23'!
updatePackageViewContent

	| vScrollValue |
	self	
		ifPackages: [ 
			vScrollValue := list scrollValue y.
			listElements := nil.
			self changed: #getList.
			list vScrollValue: vScrollValue ]
		ifClasses: [ 
			vScrollValue := list2 scrollValue y.
			list2Elements := nil.
			self changed: #getList2.
			list2 vScrollValue: vScrollValue ]! !

!AbstractNautilusUI methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 10/19/2011 06:34'!
wantsDroppedMorph: transferMorph event: anEvent inMorph: destinationLM 
	"We are only interested in TransferMorphs as wrappers for             
	informations. If their content is really interesting for us, will             
	determined later in >>acceptDroppingMorph:event:."

	| srcType dstType |

	"only want drops on lists (not, for example, on pluggable texts)"
	(destinationLM isKindOf: PluggableListMorph) ifFalse: [^ false].

	srcType := transferMorph dragTransferType.
	dstType := destinationLM getListSelector.

	srcType == #getMethods
		ifTrue: [
			^ (dstType == #getCategories or: [
				self 
					ifPackages: [ dstType == #getList2 ]
					ifClasses:[ dstType == #getList ]])].

	srcType == #getCategories
		ifTrue: [
			^ self 
				ifPackages: [ dstType == #getList2 ]
				ifClasses:[ dstType == #getList ]].
	
	self 
		ifPackages: [ 
			
			(srcType == #getList2 and: [ dstType = #getList ]) 
						ifTrue: [ 
							(destinationLM potentialDropItem isKindOf: PluggableListMorph)
								ifTrue: [ ^ true ].
							self showGroups
								ifTrue: [ | receiver |
									receiver := destinationLM potentialDropItem originalObject.
									^ receiver isFillable ]
								ifFalse: [ ^ true ]]
						ifFalse:[ ^ false ]]
		ifClasses: [	(srcType == #getList and: [ dstType = #getList2 ]) ifTrue: [
					| receiver |
							receiver := destinationLM potentialDropItem originalObject.
							^ receiver isFillable ]].

	^ false! !

!AbstractNautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/27/2011 15:42'!
warningLimit
	
	^ self model 
		ifNil: [ 350 ]
		ifNotNil: [:mod | model warningLimit ]! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
window

	^ window! !

!AbstractNautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/24/2011 14:11'!
window: anObject

	window := anObject! !

AbstractNautilusUI subclass: #NautilusUI
	instanceVariableNames: 'methodWidget categoryWidget methods categories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus'!

!NautilusUI commentStamp: '<historical>' prior: 0!
A UI for an instance of Nautilus!

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 2/6/2012 16:28'!
addAll: aWindow
			
	| column navigationRow topHeight middleHeight bottomMorph bottomHeight delta |
	delta := 0.
	bottomHeight := 0.
	middleHeight := 0.
	topHeight := 0.

	" reverse order in column ..."
	"column vResizing: #rigid."
	self buildTopPlugins ifNotNil: [:top |
		topHeight := top height.
		aWindow 
			addMorph: top
			fullFrame: (LayoutFrame 
							fractions: (0 @ 0 corner: 1 @ 0)
							offsets: (0 @ 0 corner: 0 @ topHeight)).
		delta := 4.
		topHeight := topHeight + delta.
		top color: Color transparent].
	
	"navigationRow := self buildNavigationRow: aWindow height: topHeight."

	self buildColumns: aWindow height: topHeight"+navigationRow".
	
	
	self buildMiddlePlugins ifNotNil: [:middle |
		middleHeight := middle height+4.
		aWindow 
			addMorph: middle
			fullFrame: (LayoutFrame 
							fractions: (0 @ 0.5 corner: 1 @ 0.5)
							offsets: (0 @ 0 corner: 0 @ middleHeight)).
		middle color: Color transparent].
	
	sourceCodePanel := PanelMorph new.
	sourceCodePanel changeProportionalLayout.
		
	sourceCodePanel 
		addMorph: self buildCodePane
		fullFrame: (LayoutFrame 
						fractions: (0@0 corner: 1@1) 
						offsets: (0@0 corner: 0@0)).
	"self buildCommentPane."
	sourceCodePanel 
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	sourceCodeContainer := PanelMorph new.
	sourceCodeContainer 
		changeTableLayout;
		listDirection: #leftToRight.

	{	sourceCodePanel.
		self buildTextAreaButtonsColumn: aWindow} reverse do: [:each | sourceCodeContainer addMorph: each].
	
	bottomMorph := self buildBottomPlugins.
	bottomMorph ifNotNil: [:bottom | bottomHeight := bottom height + 8].
	aWindow
		addMorph: sourceCodeContainer
		fullFrame: (LayoutFrame 
						fractions: (0 @ 0.5 corner: 1 @ 1)
						offsets: (0 @ middleHeight corner: 0 @ bottomHeight negated)).
						
	bottomMorph ifNotNil: [:bottom |					
		aWindow				
			addMorph: bottom
			fullFrame: (LayoutFrame 
							fractions: (0 @ 1 corner: 1 @ 1)
							offsets: (0 @ bottomHeight negated corner: 0 @ 0)).
		bottom color: Color transparent]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 2/20/2012 21:46'!
addCategory

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| newName |
	self okToChange ifFalse: [^ self].
	self selectedClass ifNil: [^ self].

	newName := self addCategoryIn: self selectedClass before: self selectedCategory.
	self resetCategoriesListSelection.
	categoryWidget selectProtocol: newName.
	self selectedCategory: newName.
	newName ifNil: [ ^ self ].
	self update.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/5/2011 12:41'!
allLabel

	^ '--- all ---'! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/25/2011 09:25'!
announce: anAnnouncement

	self model announce: anAnnouncement! !

!NautilusUI methodsFor: 'plugins display' stamp: 'BenjaminVanRyseghem 5/10/2011 17:44'!
buildBottomPlugins

	| bottom container |
	bottom := self model plugins select: [:each | each position = #bottom ].
	bottom ifEmpty: [ ^ nil ].
	bottom size = 1 ifTrue: [ ^ bottom first display ].
	container := Morph new.
	container 
		color: Color transparent;
		changeTableLayout;
		cellInset: 8;
		listDirection: #topToBottom;
		cellPositioning: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	bottom reverse do: [:each |
		each display ifNotNil: [:morph | container addMorph: morph ]].
	^ container! !

!NautilusUI methodsFor: 'widget - category' stamp: 'BenjaminVanRyseghem 10/19/2011 17:45'!
buildCategoryWidget
	
	categoryWidget := CategoryWidget model: self.
	^ categoryWidget buildCategoriesList! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 5/12/2011 12:13'!
buildColumns: aWindow height: height
			
	aWindow 
		addMorph: (self buildFirstColumn: aWindow)
		fullFrame: (LayoutFrame 
						fractions: (0 @ 0 corner: 0.25 @ 0.5)
						offsets: (0 @ height corner: 0 @ 0)).
						
	aWindow 
		addMorph: (self buildSecondColumn: aWindow)
		fullFrame: (LayoutFrame 
						fractions: (0.25 @ 0 corner: 0.5 @ 0.5)
						offsets: (0 @ height corner: 0 @ 0)).
						
	aWindow 
		addMorph: (self buildThirdColumn: aWindow)
		fullFrame: (LayoutFrame 
						fractions: (0.5 @ 0 corner: 0.75 @ 0.5)
						offsets: (0 @ height corner: 0 @ 0)).
						
	aWindow 
		addMorph: (self buildFourthColumn: aWindow)
		fullFrame: (LayoutFrame 
						fractions: (0.75 @ 0 corner: 1 @ 0.5)
						offsets: (0 @ height corner: 0 @ 0)).
		! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 10/19/2011 17:44'!
buildFourthColumn: aWindow

	"^ (aWindow newColumn: {
		self buildLabelMorph.
		self buildList.
		aWindow newRow: {self buildToogleButton. self buildGroupsButton}}) 
		hResizing: #spaceFill; vResizing: #spaceFill"
		
	^ aWindow newColumn: {self buildMethodWidget.self buildNextButton. }
			! !

!NautilusUI methodsFor: 'widget - method' stamp: 'BenjaminVanRyseghem 10/19/2011 17:44'!
buildMethodWidget
	
	methodWidget := MethodWidget model: self.
	^ methodWidget buildMethodsList! !

!NautilusUI methodsFor: 'plugins display' stamp: 'BenjaminVanRyseghem 5/10/2011 17:57'!
buildMiddlePlugins

	| middle container |
	middle := self model plugins select: [:each | each position = #middle ].
	middle ifEmpty: [ ^ nil ].
	middle size = 1 ifTrue: [ ^ middle first display ].
	container := Morph new.
	container 
		color: Color transparent;
		changeTableLayout;
		cellInset: 8;
		listDirection: #topToBottom;
		cellPositioning: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	middle reverse do: [:each |
		each display ifNotNil: [:morph | container addMorph: morph ]].
	^ container! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/12/2011 13:10'!
buildNextButton

	^ (PluggableButtonMorph
			on: self 
			getState: #nextButtonState
			action: #nextButtonAction
			label: #nextButtonLabel) 
			hResizing: #spaceFill;
			vResizing: #shrinkWrap;
			getEnabledSelector: #nextButtonEnablementState;
			yourself! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/12/2011 13:10'!
buildPreviousButton

	^ (PluggableButtonMorph
			on: self 
			getState: #previousButtonState
			action: #previousButtonAction
			label: #previousButtonLabel)
			hResizing: #spaceFill;
			vResizing: #shrinkWrap;
			getEnabledSelector: #previousButtonEnablementState;
			yourself! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/19/2012 17:10'!
buildTestSelectorFor: aMethod

	^ String streamContents: [:s || capitalize |
		capitalize := true.
		s << 'test'.
		aMethod selector do: [:c |
			c = $:
				ifTrue: [ capitalize := true ]
				ifFalse: [ capitalize
							ifTrue: [ 
								capitalize := false.
								s << c asUppercase. ]
							ifFalse:[ s << c ]]]]
			! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 10/19/2011 17:45'!
buildThirdColumn: aWindow

	"^ (aWindow newColumn: {
		self buildLabelMorph.
		self buildList.
		aWindow newRow: {self buildToogleButton. self buildGroupsButton}}) 
		hResizing: #spaceFill; vResizing: #spaceFill"
		
	^ aWindow newColumn: {self buildCategoryWidget.self buildPreviousButton. }
			! !

!NautilusUI methodsFor: 'plugins display' stamp: 'BenjaminVanRyseghem 5/10/2011 16:55'!
buildTopPlugins

	| top container |
	top := self model plugins select: [:each | each position = #top ].
	top ifEmpty: [ ^ nil ].
	top size = 1 ifTrue: [ ^ top first display ].
	container := Morph new.
	container 
		color: Color transparent;
		changeTableLayout;
		cellInset: 8;
		listDirection: #topToBottom;
		cellPositioning: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	top reverse do: [:each |
		each display ifNotNil: [:morph | container addMorph: morph ]].
	^ container! !

!NautilusUI methodsFor: 'widget - category' stamp: 'BenjaminVanRyseghem 10/20/2011 14:27'!
categoriesLabel

	^ categoryWidget categoriesLabel! !

!NautilusUI methodsFor: 'widget - category' stamp: 'BenjaminVanRyseghem 10/20/2011 14:20'!
categoriesMenu: aMenu shifted: b

	^ aMenu becomeForward: (self categoryMenuBuilder menu)! !

!NautilusUI methodsFor: 'widget - category' stamp: 'BenjaminVanRyseghem 10/19/2011 17:56'!
categoriesSelection

	^ categoryWidget categoriesSelection! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/5/2011 14:59'!
categorizeMethod

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| aCollection aClass |
	self okToChange ifFalse: [^ self].
	(aCollection := self selectedMethods) ifEmpty: [^ self].
	(aClass := self selectedClass) ifNil: [^self].	

	self categorizeMethods: aCollection of: aClass from: self selectedCategory.

	self update.! !

!NautilusUI methodsFor: 'widget - category' stamp: 'BenjaminVanRyseghem 2/18/2012 15:48'!
categorySelectionChanged

	methodWidget resetMethodCache.
	self changed: #getMethods.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 10/20/2011 14:10'!
categoryWidget

	^ categoryWidget! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 1/25/2012 18:52'!
compileAMethodFromCategory: aCategory withSource: aString notifying: aController

	| category selector |
	category := aCategory.
	self selectedClass
		ifNil: ["should never happened" self error ]
		ifNotNil: [:class || scroll |
			scroll := sourceTextArea scrollValue y.
			(category = self noMethodsString or: [ category = self allLabel ])
				ifTrue: [ category := self asYetUnclassifiedString ].
			"sourceTextArea update: #clearUserEdits."
			selector := self compileANewMethodInClass: class categorized: category from: aString notifyng: aController.
			
			selector
				ifNil: [^ sourceTextArea hasUnacceptedEdits: true. ]
				ifNotNil: [| method |
					sourceTextArea update: #clearUserEdits.
					sourceTextArea vScrollValue: scroll.
					method := (class methodNamed: selector).
					"self selectedCategory: cat."
					"methodsTree setSelectedNodeItem: method."
					( self selectedMethod notNil and: [(self selectedClass = class) and: [ self selectedMethod selector = selector]])
						ifFalse: [
							self selectedMethod: method.
							self update.
							sourceTextArea vScrollValue: scroll.]]]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 1/25/2012 17:53'!
compileSource: aText notifying: aController

	| source category method |
	source := aText asString.
	category := self selectedCategory.
	method := self selectedMethod.
	category ifNil: [ method ifNotNil: [ category := method protocol ]].
	(category isNil and: [ method isNil ])
		ifTrue: [ self compileAClassFrom: source notifying: aController ]
		ifFalse: [ | cat |
			((category = self allLabel) and: [ self selectedMethod notNil ])
				ifTrue: [ cat := self selectedMethod protocol ]
				ifFalse: [ cat := category ].
			self compileAMethodFromCategory: cat withSource: source notifying: aController ]! !

!NautilusUI methodsFor: 'shortcuts from text morph' stamp: 'BenjaminVanRyseghem 11/1/2011 10:44'!
decrementMethodsListIndex

	| index |
	methodWidget resetMethodsListSelection.
	index :=(methodWidget selectedMethodIndex - 1).
	index < 1 ifTrue: [ index := methodWidget getMethods size ]. 
	methodWidget selectedMethodIndex: index.
	sourceTextArea takeKeyboardFocus! !

!NautilusUI methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 10/7/2011 21:47'!
dropMethod: aCollectionOfMethods inARow: aRow

	| newProtocol |
	
	newProtocol := self getCategories at: aRow.
	aCollectionOfMethods do: [:aMethod | self move: aMethod from: aMethod category to: newProtocol isCopy: false ].
	self selectedMethod: nil! !

!NautilusUI methodsFor: 'widget - method' stamp: 'BenjaminVanRyseghem 10/20/2011 14:20'!
elementsMenu: aMenu shifted: b

	^ aMenu becomeForward: (self methodMenuBuilder menu)! !

!NautilusUI methodsFor: 'widget - category' stamp: 'BenjaminVanRyseghem 5/5/2011 14:25'!
enableCategorySingleSelection

	^ self selectedCategories size <= 1! !

!NautilusUI methodsFor: 'widget - method' stamp: 'BenjaminVanRyseghem 5/5/2011 14:24'!
enableMethodSingleSelection

	^ self selectedMethods size <= 1! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 2/18/2012 15:23'!
fileOutCategories

	self fileOutCategories: self selectedCategories from: self selectedClass! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/5/2011 14:59'!
fileOutMethods

	self fileOutMethods: self selectedMethods! !

!NautilusUI methodsFor: 'category-method methods' stamp: 'BenjaminVanRyseghem 5/5/2011 14:42'!
forceSelectedMethod: aMethod 
	
	self model package: self selectedPackage class: self selectedClass category: self selectedCategory method: aMethod.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/9/2011 16:46'!
forceSelection: aNode
! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/5/2011 14:44'!
fullBrowse

	self model class 
		openOnPackage: self selectedPackage
		class: self selectedClass
		category: self selectedCategory
		method: self selectedMethod
		group: self selectedGroup
		showGroups: self showGroups
		showHierarchy: self showHierarchy
		showPackages: self showPackages
		showComment: self showComment 
		showInstance: self showInstance 
		showCategories: true
! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/19/2012 17:04'!
generateSourceCodeForTestFrom: aMethod

	^ self buildTestSelectorFor: aMethod.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/19/2012 17:14'!
generateTestMethodFor: aMethod

	"generate a test method for aMethod and return the generated method"
	| class |

	class := self model classes detect: [:e | e name = (aMethod methodClass name,'Test')] ifNone: [ self createTestForClass: aMethod methodClass ].
	class
		ifNotNil:[ 
			class compile: (self generateSourceCodeForTestFrom: aMethod) classified: 'tests'.
			^ class >> (self buildTestSelectorFor: aMethod) asSymbol ].
	^ nil! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 1/19/2012 17:18'!
generateTestMethodsAndFocus: aBoolean

	"generate testing methods for the selected methods in the test class"
	"I assume the test class is named #{MyClassName}Test"
	| focus |
	self selectedMethods ifEmpty: [^ self].
	self selectedMethods reverse do: [:method | focus := self generateTestMethodFor: method ].
	focus ifNil: [ ^ self ].
	(aBoolean and: [ self okToChange ])
		ifTrue: [
			self showGroups: false.
			self selectedPackage: focus methodClass package.
			self selectedClass: focus methodClass.
			self selectedCategory: 'tests'.
			self selectedMethod: focus.
			self updateBothView ]! !

!NautilusUI methodsFor: 'widget - category' stamp: 'BenjaminVanRyseghem 2/7/2012 19:01'!
getCategories

	^ categoryWidget getCategories! !

!NautilusUI methodsFor: 'widget - method' stamp: 'BenjaminVanRyseghem 2/7/2012 19:05'!
getMethods

	^ methodWidget getMethods! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/22/2012 00:13'!
hasFocus

	^ window hasKeyboardFocus or: 
		[ list hasKeyboardFocus or:
		[ list2 hasKeyboardFocus or: 
		[ categoryWidget hasFocus or:
		[ methodWidget hasFocus or:
		[ sourceTextArea hasKeyboardFocus ]]]]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 19:05'!
highlightCategory: aMethod.
		methodWidget resetMethodCache.
		aMethod 
			ifNil: [ categoryWidget searchedElement: categoryWidget selectedCategoryIndex ]
			ifNotNil: [ | category index |
				category := aMethod protocol.
				index := self getCategories indexOf: ( category ).
				categoryWidget searchedElement: index ]! !

!NautilusUI methodsFor: 'shortcuts from text morph' stamp: 'BenjaminVanRyseghem 11/1/2011 10:45'!
incrementMethodsListIndex

	| index |
	methodWidget resetMethodsListSelection.
	index := (methodWidget selectedMethodIndex + 1).
	index > methodWidget getMethods size ifTrue: [ index := 1 ].
	methodWidget selectedMethodIndex: index.
	sourceTextArea takeKeyboardFocus ! !

!NautilusUI methodsFor: 'widget - category' stamp: 'BenjaminVanRyseghem 10/20/2011 14:14'!
keyPressedOnCategory: anEvent
	| aCharacter |

	aCharacter := anEvent keyCharacter.

	aCharacter == Character arrowRight ifTrue: [ ^ self giveFocusTo: methodWidget ].
	aCharacter == Character arrowLeft ifTrue: [ ^ self giveFocusTo: list2 ].
		
	anEvent commandKeyPressed ifFalse: [ ^ self ].
	
	aCharacter == $b ifTrue: [ ^ self fullBrowse ].
	aCharacter == $f ifTrue: [ ^ self findMethod ].	
	aCharacter == $n ifTrue: [ ^ self addCategory ].
	(aCharacter == $r and:[ self enableCategorySingleSelection ]) ifTrue: [ ^ self renameCategory ].
	aCharacter == $x ifTrue: [ ^ self removeCategories ].! !

!NautilusUI methodsFor: 'widget - method' stamp: 'BenjaminVanRyseghem 10/20/2011 14:13'!
keyPressedOnElement: anEvent

		^ self methodWidget keyPressedOnElement: anEvent! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 2/20/2012 21:37'!
keyPressedOnList2: anEvent shifted: aBoolean
	| aCharacter |

	aCharacter := anEvent keyCharacter.

	aCharacter == Character arrowRight ifTrue: [ ^ self giveFocusTo: categoryWidget ].
	aCharacter == Character arrowLeft ifTrue: [ ^ self giveFocusTo: list ].! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 2/20/2012 21:37'!
keyPressedOnList: anEvent shifted: aBoolean
	| aCharacter |

	aCharacter := anEvent keyCharacter.

	aCharacter == Character arrowRight ifTrue: [ ^ self giveFocusTo: list2 ].
	aCharacter == Character arrowLeft ifTrue: [ ^ self giveFocusTo: sourceTextArea ].! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 1/19/2012 20:37'!
keyStroke: anEvent fromSourceCodeMorph: aMorph
	"Here I received each key stroke in the source code text morph"

	| aChar |
	aChar := anEvent keyCharacter.

	anEvent keyString = '<Ctrl-Cmd-right>'
		ifTrue: [ self giveFocusTo: list ].
	
	anEvent keyString = '<Ctrl-Cmd-left>'
		ifTrue: [ self giveFocusTo: methodWidget ].
	
	anEvent keyString =  '<Cmd-Shift-up>'
		ifTrue: [ self decrementMethodsListIndex ].
	
	anEvent keyString =  '<Cmd-Shift-down>'
		ifTrue: [ self incrementMethodsListIndex ].
		
	self aKeyHasBeenPressed: anEvent keyCharacter.
	! !

!NautilusUI methodsFor: 'widget - category' stamp: 'BenjaminVanRyseghem 2/7/2012 18:26'!
loadCategories
	
	^ self model selectedClass
		ifNil: [ {} ]
		ifNotNil: [:class | class protocols asOrderedCollection sort addFirst: self allLabel; yourself ]! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 5/26/2011 17:51'!
methodAdded: anAnnouncement
	
	| method |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	method := anAnnouncement item.
	(method methodClass = self selectedClass)
		ifTrue: [ 
			self resetMethodsListSelection.
			self removeAllFromMethodsIconsCache: method.
			self update ]! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 2/20/2012 17:04'!
methodModified: anAnnouncement 
	| collection |

	window isNil ifTrue: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
	
	collection := self 
					ifPackages: [ self getList2 ]
					ifClasses: [ self getList ].
	(collection includes: anAnnouncement itemClass)
		ifTrue: [
			| method |
			method := anAnnouncement item.	
			self removeFromMethodsIconsCache: method.
			self updateClassView.
			self selectedMethod = anAnnouncement oldItem
				ifTrue: [
					sourceTextArea hasUnacceptedEdits
						ifTrue: [ | sourceCode |
							sourceCode := sourceTextArea text.
							self forceSelectedMethod: method.
							self update.
							self highlightCategory: method.
							sourceTextArea setText: sourceCode.
							sourceTextArea hasEditingConflicts: true.
							sourceTextArea update: #codeChangedElsewhere ]
						ifFalse: [
							self selectedMethod: method.
							self update ]]]! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 2/20/2012 17:04'!
methodRecategorized: anAnnouncement
	
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
		
	(anAnnouncement item methodClass = self selectedClass)
		ifTrue: [ self update ]! !

!NautilusUI methodsFor: 'system announcements' stamp: 'BenjaminVanRyseghem 5/26/2011 17:51'!
methodRemoved: anAnnouncement
	
	| method |
	window ifNil: [ ^ self ].
	window isDisplayed ifFalse: [ ^ self ].
		
	method := anAnnouncement item.
	(method methodClass = self selectedClass)
		ifTrue: [ 
			self selectedMethod = anAnnouncement item
				ifTrue: [ self selectedMethod: nil ].
			self resetMethodsListSelection.
			self removeAllFromMethodsIconsCache: method.
			self update ]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 10/20/2011 14:10'!
methodWidget

	^ methodWidget! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/18/2012 15:31'!
methodsForCategories: aCollection

	| mthds |
	mthds := aCollection gather: [:e | self methodsForCategory: e ].
	^ mthds sort: [:a :b | a selector < b selector ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/1/2011 14:46'!
methodsForCategory: aCategory

	self selectedClass ifNil: [ ^ {} ].
	aCategory = self allLabel
		ifTrue: [ ^ (self selectedClass methods asOrderedCollection sort: [:a :b | a selector <= b selector]) collect: [:each | each ]].
	
	^ (self selectedClass methodsInProtocol: aCategory) asOrderedCollection! !

!NautilusUI methodsFor: 'widget - method' stamp: 'BenjaminVanRyseghem 10/12/2011 15:58'!
methodsIconsCache
	
	^ methodWidget methodsIconsCache! !

!NautilusUI methodsFor: 'widget - method' stamp: 'BenjaminVanRyseghem 10/20/2011 14:27'!
methodsLabel

	^ methodWidget methodsLabel! !

!NautilusUI methodsFor: 'widget - method' stamp: 'BenjaminVanRyseghem 10/12/2011 17:59'!
methodsSelection

	^ methodWidget methodsSelection! !

!NautilusUI methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 1/19/2012 19:12'!
move: item from: oldCategory to: newCategory isCopy: isCopy

	| category |
	category := newCategory.
	category = self allLabel
		ifTrue: [ category := self asYetUnclassifiedString ].
	isCopy
		ifFalse: [
			item methodClass organization
				classify: item selector
				under: category 
				suppressIfDefault: false.
			self selectedMethod: item ] ! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 5/5/2011 14:59'!
moveMethodToPackage
	"Search for a package from a pattern or from the recent list"	
	
	| packagesList  |	
	self okToChange ifFalse: [^ self flashPackage ].
	packagesList := self model packages collect: [:each | each name ].
	
	self moveMethodsToPackage: self selectedMethods in: packagesList  from: self selectedPackage.

	self update.
		
! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/23/2011 20:14'!
nextButtonAction

	self model next.
	self update.
	self changed: #sourceCode! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/12/2011 13:08'!
nextButtonEnablementState

	^ self model hasNext! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/12/2011 11:53'!
nextButtonLabel

	^ '>'! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/12/2011 11:54'!
nextButtonState

	^ false! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 1/22/2012 00:01'!
open

	super open.
	window takeKeyboardFocus.
	self selectedPackage ifNotNil: [ self ifPackages: [ self giveFocusTo: list ] ifClasses: [ self giveFocusTo: list2 ]].
	self selectedClass ifNotNil: [ self ifPackages: [ self giveFocusTo: list2 ] ifClasses: [ self giveFocusTo: list ]].
	self selectedCategory ifNotNil: [ self giveFocusTo: categoryWidget ].
	self selectedMethod ifNotNil: [ self giveFocusTo: methodWidget ].! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 8/23/2011 20:14'!
previousButtonAction

	self model previous.
	self update.
	self changed: #sourceCode! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/12/2011 13:09'!
previousButtonEnablementState

	^ self model hasPrevious! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/12/2011 11:54'!
previousButtonLabel

	^ '<'! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/12/2011 11:54'!
previousButtonState

	^ false! !

!NautilusUI methodsFor: 'widget - method' stamp: 'BenjaminVanRyseghem 10/19/2011 18:13'!
removeAllFromMethodsIconsCache: aMethod

	methodWidget removeAllFromMethodsIconsCache: aMethod! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 1/19/2012 20:05'!
removeCategories

	self selectedClass 
		ifNotNil: [:class |
			self selectedCategories
				ifNotEmpty: [:items || removeACategory scroll |
					scroll := categoryWidget vScrollValue.
					removeACategory := false.
					items do: [:item || needToUpdate |
						needToUpdate := self removeCategory: item inClass: class.
						(needToUpdate and: [ removeACategory not ]) ifTrue: [ removeACategory := true].
						needToUpdate ifTrue: [ self update ]].

					removeACategory ifTrue: [ self selectedCategory: nil ].
					self update.
					categoryWidget vScrollValue: scroll. ]]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 1/19/2012 20:12'!
removeMethods

	self selectedClass 
		ifNotNil: [:class |
			self selectedMethods
				ifNotEmpty: [:items || removeAMethod scroll |
					scroll := methodWidget vScrollValue.
					removeAMethod := false.
					items do: [:item || b needToUpdate |
					needToUpdate := self removeMethod: item inClass: class.
					(needToUpdate and: [ removeAMethod not ]) ifTrue: [ removeAMethod := true].
					needToUpdate.
					needToUpdate ifTrue: [ 
						self resetMethodsListSelection.
						self changed: #getMethods.  ]].
					
					removeAMethod ifTrue: [ self selectedMethod: nil ].
					self resetMethodsListSelection.
					self changed: #getMethods.
					methodWidget vScrollValue: scroll. ]]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 2/20/2012 17:34'!
renameCategory
	"Prompt for a new category name and add it before the
	current selection, or at the end if no current selection"

	| category newName vScroll |
	self okToChange ifFalse: [^ self].
	category := self selectedCategory.
	vScroll := categoryWidget vScrollValue.
	newName := self renameCategory: category from: self selectedClass.
	newName ifNil: [ ^ self ].
	categoryWidget deselectProtocol: category.
	self selectedCategory: newName.
	categoryWidget selectProtocol: newName.
	self update.
	categoryWidget vScrollValue: vScroll! !

!NautilusUI methodsFor: 'widget - category' stamp: 'BenjaminVanRyseghem 10/19/2011 17:56'!
resetCategoriesListSelection

	categoryWidget resetCategoriesListSelection! !

!NautilusUI methodsFor: 'widget - method' stamp: 'BenjaminVanRyseghem 10/19/2011 06:28'!
resetMethodsListSelection

	methodWidget resetMethodsListSelection! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/12/2011 12:42'!
resetSelections

	self resetListSelection.
	self resetListSelection2.
	self resetCategoriesListSelection.
	self resetMethodsListSelection.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 2/21/2012 02:50'!
runTestForAMethod: aMethod

	| vScroll testMethod testClass testResult |
	vScroll := methodWidget vScrollValue.
	testMethod := aMethod correspondingTestMethod.
	testMethod ifNil: [ ^ self ].
	testClass := testMethod methodClass.
	testResult := testClass run: testMethod selector.
	testResult updateResultsInHistory.
		
	(testResult failures isEmpty not or: [ testResult errors isEmpty not ])
		ifTrue: [ 
			testClass debug: testMethod selector ].
	methodWidget vScrollValue: vScroll! !

!NautilusUI methodsFor: 'widget - category' stamp: 'BenjaminVanRyseghem 10/19/2011 18:04'!
selectedCategories

	^ categoryWidget selectedCategories! !

!NautilusUI methodsFor: 'widget - category' stamp: 'BenjaminVanRyseghem 10/20/2011 14:22'!
selectedCategory

	^ self model selectedCategory! !

!NautilusUI methodsFor: 'category-method methods' stamp: 'BenjaminVanRyseghem 2/7/2012 19:05'!
selectedCategory: anObject

	self okToChange
		ifTrue: [
			methodWidget resetMethodCache.
			self model package: self selectedPackage class: self selectedClass category: anObject method: nil.
			self resetMethodsListSelection.
			anObject ifNotNil: [ self giveFocusTo: categoryWidget ].
			self changed: #sourceCode.
			^ true].
	^ false! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 10/19/2011 17:54'!
selectedCategoryInternally: anObject

	self okToChange
		ifTrue: [
			self resetMethodsListSelection.
			anObject ifNotNil: [ self giveFocusTo: categoryWidget ].
			self changed: #sourceCode.
			^ true].
	^ false! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/8/2012 16:30'!
selectedClassWithoutChangingSelection: aClass 
	categoryWidget resetCategoryCache.
	self okToChange
		ifTrue: [| package packageChanged |
			package := self selectedPackage.
			(self showPackages not or: [self showGroups ])
				ifTrue: [ aClass ifNotNil: [ package := aClass package ]].
			hierarchyButton enabled: (aClass ~~ nil).
			aClass 
				ifNil: [ classesSelection removeAll ].
			packageChanged := (package ~= self selectedPackage).
			self model package: package class: aClass category: nil method: nil.
			classesSelection at: aClass put: true.
			self setWindowTitle.
			
			packageChanged ifTrue: [
				packagesSelection removeAll.
				packagesSelection at: package put: true.
				self showGroups
					ifTrue: [ self updateClassView ]
					ifFalse: [ self updateBothView ]].

			self resetCategoriesListSelection.
			self resetMethodsListSelection.
			self update.
			self changed: #isAClassSelected.
			self changed: #getComments.
			self changed: #sourceCode]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/23/2011 21:11'!
selectedClassWithoutChangingSelectionInternally: aClass 

	self okToChange
		ifTrue: [| package packageChanged |
			package := self selectedPackage.
			(self showPackages not or: [self showGroups ])
				ifTrue: [ aClass ifNotNil: [ package := aClass package ]].
			aClass 
				ifNil: [ classesSelection removeAll ].

			aClass ifNotNil: [ 
				self 
					ifPackages: [ self giveFocusTo: list2 ]
					ifClasses: [ self giveFocusTo: list ]].	
				
			packageChanged := (package ~= self selectedPackage).
			classesSelection at: aClass put: true.
			self setWindowTitle.
			
			packageChanged ifTrue: [
				packagesSelection removeAll.
				packagesSelection at: package put: true.
				self showGroups
					ifTrue: [ self updateClassView ]
					ifFalse: [ self updateBothView ]].
				
			self resetCategoriesListSelection.
			self resetMethodsListSelection.
			self update.
			self changed: #isAClassSelected.
			self changed: #getComments.
			self changed: #sourceCode]! !

!NautilusUI methodsFor: 'widget - method' stamp: 'BenjaminVanRyseghem 10/20/2011 14:23'!
selectedMethod

	^ self model selectedMethod ! !

!NautilusUI methodsFor: 'category-method methods' stamp: 'BenjaminVanRyseghem 10/12/2011 17:52'!
selectedMethod: aMethod 

	self okToChange
		ifTrue: [
			self forceSelectedMethod: aMethod.
			self setWindowTitle.
			self highlightCategory: aMethod.
			aMethod ifNotNil: [ self giveFocusTo: methodWidget ].
			self changed: #sourceCode.
			^ true].
	^false ! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 10/12/2011 18:05'!
selectedMethodInternally: aMethod 

	self okToChange
		ifTrue: [
			self setWindowTitle.			
			aMethod ifNotNil: [ 
				self highlightCategory: aMethod.
				self giveFocusTo: methodWidget ].
			
			aMethod ifNotNil: [ self giveFocusTo: methodWidget ].
			
			self methodsSelection at: aMethod put: true.
			self changed: #sourceCode.
			^ true].
	^false ! !

!NautilusUI methodsFor: 'widget - method' stamp: 'BenjaminVanRyseghem 10/19/2011 17:20'!
selectedMethods

	^ methodWidget selectedMethods! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 2/19/2012 20:02'!
toggleBreakPoint
	
	self selectedMethod 
		ifNotNil: [:meth | self toggleBreakOnEntryIn: meth ]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 10/19/2011 18:04'!
toogleShowInstance

	self showInstance: self showInstance not.
	categoryWidget label: self categoriesLabel.
	methodWidget label: self methodsLabel.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 19:03'!
update

	categoryWidget resetCategoryCache.
	methodWidget resetMethodCache.
	self changed: #getCategories.
	self changed: #getMethods.! !

!RPackage methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 8/21/2011 00:29'!
<= aRPackage 

	^ self name <= aRPackage name! !

!RPackage methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 9/1/2011 13:54'!
classesOfExtensionMethods

	^ self extendedClasses! !

!RPackage methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 8/21/2011 00:29'!
fileOut

	self error: 'I should be implemented somehow'! !

!RPackage methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 11/8/2011 14:48'!
orderedClasses

	| tmp |
	tmp := self definedClasses asArray sort: [:a :b | a name <= b name].
	tmp := tmp, (self extendedClasses asArray sort: [:a :b | a name <= b name]).
	^tmp collect: [:e | e theNonMetaClass ]
! !

!RPackageOrganizer methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 8/24/2011 14:54'!
createPackageNamed: aString

	| instance |
	(packages includesKey: (Symbol readFromString:  '#''', aString,'''' ))
		ifTrue: [ 
			self openAlreadyExistingError.
			^ nil ].
	
	instance := RPackage named: aString.
	self registerPackage: instance.
	^ instance! !

!RPackageOrganizer methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 8/21/2011 10:26'!
openAlreadyExistingError

	StandardWindow new alert: 'A package with this name already exists' title: 'Already exists'! !

!RPackageOrganizer methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 1/19/2012 19:53'!
renamePackage: aPackage in: aString

	| classes |
	(packages includesKey: aString asSymbol)
		ifTrue: [ ^ self openAlreadyExistingError ].

	classes := aPackage definedClasses.
	classes do: [:class |
		class category: aString ].	
	self unregisterPackage: aPackage.
	aPackage name: aString.
	self registerPackage: aPackage.
	classes do: [:class |
		class category: aString ].
	
	^ aPackage! !

MorphTreeListManager subclass: #IdentityMorphTreeListManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-MorphTreeWidget-Extension'!

!IdentityMorphTreeListManager commentStamp: '<historical>' prior: 0!
An IdentityMorphTreeListManager is a MorphTreeListManager which always check for identity between items
!

!IdentityMorphTreeListManager methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/8/2012 17:28'!
nodeMorphsWithAllNodeItems: aNodeItemList

	^ self allNodeMorphs select: [:m | aNodeItemList identityIncludes: m complexContents withoutListWrapper]! !

MorphTreeMorph subclass: #IdentityMorphTreeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-MorphTreeWidget-Extension'!

!IdentityMorphTreeMorph commentStamp: '<historical>' prior: 0!
An IdentityMorphTreeMorph is a MorphTreeMorph which always check for identity between items
!

!IdentityMorphTreeMorph methodsFor: 'expanding-collapsing' stamp: 'BenjaminVanRyseghem 3/20/2011 00:17'!
expandedFormForMorph: aMorph
	"Answer the form to use for expanded items."
	
	^ ((self selectedMorphList identityIncludes: aMorph) and: [self theme selectionColor luminance < 0.6])
		ifTrue: [self theme whiteTreeExpandedForm]
		ifFalse: [self theme treeExpandedForm]! !

!IdentityMorphTreeMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/8/2012 17:29'!
listManager: aManager

	listManager := aManager! !

!IdentityMorphTreeMorph methodsFor: 'expanding-collapsing' stamp: 'BenjaminVanRyseghem 3/20/2011 00:17'!
notExpandedFormForMorph: aMorph

	^ ((self selectedMorphList identityIncludes: aMorph) and: [self theme selectionColor luminance < 0.6])
		ifTrue: [self theme whiteTreeUnexpandedForm]
		ifFalse: [self theme treeUnexpandedForm]! !

!IconicButton methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 2/7/2012 20:06'!
graphicalMorph

		^ graphicalMorph! !

!IconicButton methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 2/7/2012 20:15'!
graphicalMorph: aMorph
	self addMorph: aMorph.
	aMorph lock.! !

!IconicButton methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 2/7/2012 20:07'!
labelGraphic

		^ graphicalMorph image! !

Announcement subclass: #AMCPackageHasBeenModified
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-MonticelloAnnouncements'!

!AMCPackageHasBeenModified commentStamp: '<historical>' prior: 0!
An AMCPackageHasBeenModified is raised when a MCPackage is modified!

!AMCPackageHasBeenModified class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/14/2011 13:52'!
package: aMCPackage

	^ self new package: aMCPackage! !

!AMCPackageHasBeenModified methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 13:49'!
package

		^ package! !

!AMCPackageHasBeenModified methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 13:49'!
package: anObject
	
		package := anObject! !

Announcement subclass: #AMCVersionHasBeenCreated
	instanceVariableNames: 'name nameString version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-MonticelloAnnouncements'!

!AMCVersionHasBeenCreated commentStamp: '<historical>' prior: 0!
An AMCVersionHasBeenCreated is raised when a MCVersion is created
!

!AMCVersionHasBeenCreated class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/24/2011 14:57'!
name: aName message: aString version: aMCVersion

	^ self new
			name: aName;
			nameString: aString;
			version: aMCVersion;
			yourself! !

!AMCVersionHasBeenCreated class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/14/2011 13:56'!
name: aName nameString: aString version: aMCVersion

	^ self new
			name: aName;
			nameString: aString;
			version: aMCVersion;
			yourself! !

!AMCVersionHasBeenCreated methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 13:56'!
name: anObject
	
		name := anObject! !

!AMCVersionHasBeenCreated methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 13:56'!
nameString

		^ nameString! !

!AMCVersionHasBeenCreated methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 13:56'!
nameString: anObject
	
		nameString := anObject! !

!AMCVersionHasBeenCreated methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 13:56'!
version

		^ version! !

!AMCVersionHasBeenCreated methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/14/2011 13:56'!
version: anObject
	
		version := anObject! !

SystemAnnouncer subclass: #MonticelloAnnouncer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-MonticelloAnnouncements'!

!MonticelloAnnouncer commentStamp: '<historical>' prior: 0!
A MonticelloAnnouncer is an Announcer dedicated to Monticello Announcements!

Object subclass: #AbstractWidget
	instanceVariableNames: 'model iconClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!AbstractWidget commentStamp: '<historical>' prior: 0!
AbstractWidget is an abstraction for the different widget which could be used to compose the Nautilus UI!

AbstractWidget subclass: #AbstractCategoryWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!AbstractCategoryWidget commentStamp: '<historical>' prior: 0!
AbstractCategoryWidget is an abstraction describing a widget used to manage categories!

!AbstractCategoryWidget methodsFor: 'item creation' stamp: 'BenjaminVanRyseghem 10/19/2011 17:13'!
buildCategoriesList

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/19/2011 18:16'!
categoriesMenu: aMenuMorph shifted: aBoolean 
	
	^ self model categoriesMenu: aMenuMorph shifted: aBoolean ! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/19/2011 18:02'!
categoriesSelection

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 10/20/2011 14:04'!
dragPassengersFor: item inMorph: dragSource 

	| transferType object |
	
	(dragSource isKindOf: PluggableListMorph) ifFalse: [^ nil ].
	transferType := self dragTransferTypeForMorph: dragSource.
	object := item originalObject.
	transferType == #getCategories ifTrue: [ ^ self selectedCategories ifEmpty: [ { object } ] ].
	^ nil! !

!AbstractCategoryWidget methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 10/20/2011 14:05'!
dropMethod: aCollectionOfMethods inARow: aRow

	self model dropMethod: aCollectionOfMethods inARow: aRow! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/20/2011 14:11'!
keyPressedOnCategory: anEvent

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/19/2011 17:50'!
label: aString

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/19/2011 17:52'!
searchedElement: index

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/19/2011 18:04'!
selectedCategories

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/19/2011 17:32'!
selectedCategory

	^ self model selectedCategory! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/19/2011 17:48'!
showInstance

	^ self model showInstance! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/19/2011 17:50'!
takeKeyboardFocus

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 2/7/2012 12:58'!
thereIsNoIconsOnCategories! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 20:04'!
vScrollValue

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 20:05'!
vScrollValue: aNumber

	^ self subclassResponsibility! !

!AbstractCategoryWidget methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 10/20/2011 14:08'!
wantsDroppedMorph: transferMorph event: anEvent inMorph: destinationLM 
	"We are only interested in TransferMorphs as wrappers for             
	informations. If their content is really interesting for us, will             
	determined later in >>acceptDroppingMorph:event:."

	| srcType dstType |

	"only want drops on lists (not, for example, on pluggable texts)"
	(destinationLM isKindOf: PluggableListMorph) ifFalse: [ ^ false ].

	srcType := transferMorph dragTransferType.
	dstType := destinationLM getListSelector.

	^ srcType == #getMethods and: [ dstType == #getCategories]! !

AbstractCategoryWidget subclass: #CategoryWidget
	instanceVariableNames: 'categoriesList categoriesGroup categoriesSelection categories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!CategoryWidget commentStamp: '<historical>' prior: 0!
CategoryWidget is the basic implementation of a wiget managing categories!

!CategoryWidget class methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/20/2012 21:50'!
buildProtocolShortcutsOn: aBuilder
	<keymap>

	(aBuilder shortcut: #fullBrowse)
		category: #NautilusProtocolShortcuts
		default: $b command
		do: [ :target | target fullBrowse ].
		
	(aBuilder shortcut: #findMethod)
		category: #NautilusProtocolShortcuts
		default: $f command
		do: [ :target | target findMethod ].
	
	(aBuilder shortcut: #addCategory)
		category: #NautilusProtocolShortcuts
		default: $n command
		do: [ :target | target addCategory ].
	
	(aBuilder shortcut: #renameCategory)
		category: #NautilusProtocolShortcuts
		default: $r command
		do: [ :target | target enableCategorySingleSelection ifTrue: [target renameCategory ]].
	
	(aBuilder shortcut: #removeCategories)
		category: #NautilusProtocolShortcuts
		default: $x command
		do: [ :target | target removeCategories ].! !

!CategoryWidget class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/21/2012 15:35'!
categoriesMenu: aBuilder target: target
	<nautilusProtocolMenu>
	
	(aBuilder item: #'Find Method... (f)')
		action: [ target findMethod ];
		order: 0;
		help: 'Search for a method by name'.
			
	(aBuilder item: #'Add protocol... (n)')
		action: [ target addCategory ];
		order: 100;
		withSeparatorAfter.
	
	(aBuilder item: #'Browse full (b)')
		action: [ target fullBrowse ];
		order: 200;
		withSeparatorAfter.
		
	(aBuilder item: #'Categorize all uncategorized')
		action: [ target categorizeAllUncategorizedMethods ];
		order: 1100.	
		
	(aBuilder item: #'Remove empty protocols')
		action: [ target removeEmptyCategories ];
		order: 1200;
		withSeparatorAfter.
		
	target selectedCategory ifNil: [ ^ target ].
	
	(aBuilder item: #'Rename... (r)')
		action: [ target renameCategory ];
		order: 1300;
		enabledBlock: [ target enableCategorySingleSelection ].	
		
	(aBuilder item: #'Remove... (x)')
		action: [ target removeCategories ];
		order: 1400;
		icon: (target iconClass iconNamed: #removeIcon);
		withSeparatorAfter.
		
		(aBuilder item: #'File Out')
		action: [ target fileOutCategories ];
		order: 1500.! !

!CategoryWidget methodsFor: 'item creation' stamp: 'BenjaminVanRyseghem 2/20/2012 21:50'!
buildCategoriesList

	categoriesList := PluggableIconListMorph new
							resetListSelector: #resetCategoriesListSelection;
							keystrokeSelector: #keyPressedOnCategory:;
							autoDeselect: true;
							getListSizeSelector: #categoryListSize;
							getListElementSelector: #getCategoryItem:;
							dropItemSelector: #dropMethod:inARow:;
							dragEnabled: true; dropEnabled: true;
							hResizing: #spaceFill;
							vResizing: #spaceFill;
							
							on: self
							list: #getCategories
							primarySelection: #selectedCategoryIndex
							changePrimarySelection: #selectedCategoryIndex:
							listSelection: #categorySelectionAt:
							changeListSelection: #categorySelectionAt:put:
							menu: #categoriesMenu:shifted:
							keystroke: nil;
							
							attachKeymapCategory: #NautilusProtocolShortcuts targetting: self model;
							wrapSelector: #categoryWrapper:.
	
	categoriesGroup := GroupboxMorph new
			addContentMorph: categoriesList;
			label: self categoriesLabel;
			hResizing: #spaceFill;
			vResizing: #spaceFill.
			
	^ categoriesGroup! !

!CategoryWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 10/19/2011 17:47'!
categoriesLabel

	^ self showInstance
		ifTrue: ['Instance protocols:']
		ifFalse: ['Class protocols:']! !

!CategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/19/2011 18:02'!
categoriesSelection

	^ categoriesSelection! !

!CategoryWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 18:41'!
categoryListSize

	^ self getCategories size! !

!CategoryWidget methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 10/19/2011 17:11'!
categorySelectionAt: anIndex

	| elt |
	elt := self getCategories at: anIndex ifAbsent: [ nil ].
	^ categoriesSelection at: elt ifAbsent: [ false ].! !

!CategoryWidget methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 2/18/2012 23:16'!
categorySelectionAt: anIndex put: aBoolean

	| elt |
	elt := self getCategories at: anIndex ifAbsent: [ nil ].
	categoriesSelection at: elt put: aBoolean.
	self model categorySelectionChanged.
	^ aBoolean! !

!CategoryWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/19/2012 14:23'!
categoryWrapper: anItem

	anItem first == $*
		ifTrue: [ ^ anItem asMorph color: self model extensionColor; yourself ].
	^ anItem! !

!CategoryWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/20/2012 17:33'!
deselectProtocol: aString

	categoriesSelection at: aString put: false! !

!CategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 19:09'!
getCategories

	^ categories ifNil: [ categories := self loadCategories ].! !

!CategoryWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 18:41'!
getCategoryItem: anIndex

	^ self getCategories at: anIndex! !

!CategoryWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/22/2012 00:13'!
hasFocus
	
	^ categoriesList hasKeyboardFocus! !

!CategoryWidget methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 10/19/2011 17:22'!
initialize

	super initialize.
	categoriesSelection := Dictionary new.! !

!CategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/20/2012 21:42'!
keyPressedOnCategory: anEvent
	| aCharacter |

	aCharacter := anEvent keyCharacter.

	aCharacter == Character arrowRight ifTrue: [ ^ self model giveFocusTo: self model methodWidget ].
	aCharacter == Character arrowLeft ifTrue: [ ^ self model giveFocusTo: self model classWidget ].
	! !

!CategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/19/2011 18:18'!
label: aString

	categoriesGroup label: aString! !

!CategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 19:02'!
loadCategories
	
	^ self model selectedClass
		ifNil: [ {} ]
		ifNotNil: [:class | class protocols asOrderedCollection sort addFirst: self model allLabel; yourself ]! !

!CategoryWidget methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 2/18/2012 16:51'!
model: aModel
	
	super model: aModel.
	self selectedCategory
		ifNotNil: [:cat | categoriesSelection at: cat put: true ]! !

!CategoryWidget methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 10/19/2011 17:26'!
resetCategoriesListSelection

	categoriesSelection removeAll! !

!CategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 19:02'!
resetCategoryCache

	categories := nil! !

!CategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/19/2011 17:52'!
searchedElement: index

	categoriesList searchedElement: index! !

!CategoryWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/20/2012 17:33'!
selectProtocol: aString

	categoriesSelection at: aString put: true! !

!CategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/24/2012 19:16'!
selectedCategories

	| associations |
	associations := self categoriesSelection associations select: [:assoc | assoc value == true ].
	associations := associations collect: [:assoc | assoc key ].
	^ associations select: [:each | each notNil ]! !

!CategoryWidget methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 10/19/2011 17:29'!
selectedCategoryIndex

	^ self getCategories indexOf: self selectedCategory ifAbsent: [ 0 ]! !

!CategoryWidget methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 2/18/2012 15:46'!
selectedCategoryIndex: anInteger

	| anObject |
	anObject := self getCategories at: anInteger ifAbsent: [ nil ].
	self model selectedCategory: anObject.
	
	self changed: #selectedCategoryIndex.
	self model categorySelectionChanged! !

!CategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/19/2011 17:51'!
takeKeyboardFocus

	categoriesList takeKeyboardFocus! !

!CategoryWidget methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 2/7/2012 12:58'!
thereIsNoIconsOnCategories! !

!CategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 20:04'!
vScrollValue

	^ categoriesList scrollValue y! !

!CategoryWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 20:05'!
vScrollValue: aNumber

	^ categoriesList vScrollValue: aNumber! !

AbstractWidget subclass: #AbstractMethodWidget
	instanceVariableNames: ''
	classVariableNames: 'MethodsIconsCache'
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!AbstractMethodWidget commentStamp: '<historical>' prior: 0!
AbstractMethodWidget is an abstraction describing a widget used to manage methods!

!AbstractMethodWidget class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 2/14/2012 20:31'!
resetMethodsIconsCache

	MethodsIconsCache := IdentityDictionary new! !

!AbstractMethodWidget methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 10/12/2011 14:37'!
buildMethodsList

	^ self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 10/12/2011 15:49'!
buildUpAndDownArrowIcon: aMethod

	| container up down |
	
	container := Morph new.
	container 
		extent: 12@12;
		color: Color transparent.
		
	up := IconicButton new 
				target: self model;
				actionSelector: #arrowUp:;
				arguments: { aMethod };
				labelGraphic: (self iconClass iconNamed: #arrowDoubleUp);
				color: Color transparent;
				extent: 12 @ 6;
				helpText: 'Browse overriden message';
				borderWidth: 0.
				
	down :=  IconicButton new 
				target: self model;
				actionSelector: #arrowDown:;
				arguments: { aMethod };
				labelGraphic: (self iconClass iconNamed: #arrowDoubleDown);
				color: Color transparent;
				extent: 12 @ 6;
				helpText: 'Browse overriding messages';
				borderWidth: 0.
				
	^ container
		changeTableLayout;
		listDirection: #topToBottom;
		addMorph: down;
		addMorph: up;
		yourself! !

!AbstractMethodWidget methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 10/19/2011 17:17'!
dragPassengersFor: item inMorph: dragSource 

	| transferType object |
	(dragSource isKindOf: PluggableListMorph) ifFalse: [^ nil ].
	transferType := self dragTransferTypeForMorph: dragSource.
	transferType == #getMethods ifFalse: [ ^ nil ].
	object := item originalObject.

	^ self selectedMethods
		ifEmpty: [
			 (self getMethods includes: object)
				ifTrue: [ { object } ]
				ifFalse: [ "to test" self halt. ] ]! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/19/2011 17:37'!
elementsMenu: aBuilder

	^ self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/12/2011 18:03'!
elementsMenu: aMenuMorph shifted: aBoolean 
	
	^ self model elementsMenu: aMenuMorph shifted: aBoolean ! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/12/2011 17:56'!
getMethods

	^ self model getMethods! !

!AbstractMethodWidget methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 2/7/2012 17:59'!
initialize

	super initialize.
	MethodsIconsCache ifNil: [ MethodsIconsCache := IdentityDictionary new ]! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/20/2011 14:15'!
keyPressedOnElement: anEvent 

	^ self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/12/2011 14:49'!
label: aString

	^ self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 2/21/2012 01:55'!
methodIconFor: aMethod

	| result |
	MethodsIconsCache
		at: aMethod
		ifPresent: [:icon | 
			
			 icon class == IconicButton ifFalse: [ ^ icon ].
			
			^ IconicButton new 
						target: icon target;
						actionSelector: icon actionSelector;
						arguments: icon arguments;
						labelGraphic: icon labelGraphic;
						color: icon color;
						helpText: icon helpText;
						extent: icon extent;
						borderWidth: icon borderWidth
			
			 ].
	
	result :=  aMethod containsHalt
			ifTrue: [ self iconClass iconNamed: #breakpoint ]
			ifFalse: [
				aMethod isFromTrait
				ifTrue: [ 
					IconicButton new 
							target: [ aMethod retrieveTraitIComeFrom browse ];
							actionSelector: #value;
							labelGraphic: (self iconClass iconNamed: #trait) ;
							color: Color transparent;
							extent: 12 @ 12;
							helpText: 'Browse the trait';
							borderWidth: 0 ]
				ifFalse:[
					aMethod containsFlag
						ifTrue: [ self iconClass iconNamed: #flag ]
						ifFalse: [
							aMethod isTestMethod
								ifTrue: [| icon |
									icon :=  self iconClass iconNamed: #testNotRun.

									aMethod hasPassedTest
										ifTrue: [	icon :=  self iconClass iconNamed: #testGreen ].

									aMethod hasFailedTest
										ifTrue: [	icon :=  self iconClass iconNamed: #testYellow ].

									aMethod hasErrorTest
										ifTrue: [	icon :=  self iconClass iconNamed: #testRed ].
									IconicButton new 
												target: self model;
												actionSelector: #runTestForAMethod:;
												arguments: { aMethod };
												labelGraphic: icon ;
												color: Color transparent;
												helpText: 'Runt the test';
												extent: 12 @ 12;
												borderWidth: 0 ]
								ifFalse: [					
									aMethod correspondingTestMethod
										ifNotNil: [:testMethod || icon |
											icon :=  self iconClass iconNamed: #testNotRun.

											testMethod hasPassedTest
												ifTrue: [	icon :=  self iconClass iconNamed: #testGreen ].

											testMethod hasFailedTest
												ifTrue: [	icon :=  self iconClass iconNamed: #testYellow ].

											testMethod hasErrorTest
												ifTrue: [	icon :=  self iconClass iconNamed: #testRed ].
											IconicButton new 
														target: self model;
														actionSelector: #runTestForAMethod:;
														arguments: { aMethod };
														labelGraphic: icon ;
														color: Color transparent;
														extent: 12 @ 12;
														helpText: 'Run the test';
														borderWidth: 0 ]
										ifNil: [ | isOverriden |
											isOverriden := aMethod isOverriden.
											aMethod isOverride
												ifTrue: [ 
													isOverriden
														ifTrue: [ self buildUpAndDownArrowIcon: aMethod ]
														ifFalse:[  IconicButton new 
																		target: self model;
																		actionSelector: #arrowUp:;
																		arguments: { aMethod };
																		labelGraphic: (self iconClass iconNamed: #arrowUp);
																		color: Color transparent;
																		helpText: 'Browse overriden message';
																		extent: 12 @ 12;
																		borderWidth: 0 ]]
												ifFalse: [
													isOverriden
														ifTrue: [ IconicButton new 
																		target: self model;
																		actionSelector: #arrowDown:;
																		arguments: { aMethod };
																		labelGraphic: (self iconClass iconNamed: #arrowDown);
																		color: Color transparent;
																		helpText: 'Browse overriding messages';
																		extent: 12 @ 12;
																		borderWidth: 0 ]
														ifFalse: [ 
															aMethod isAbstract
															ifTrue: [ self iconClass iconNamed: #abstract ]
															ifFalse: [ self iconClass iconNamed: #blank]]]]]]]].
		result ifNil: [ self halt. ].
		^ MethodsIconsCache at: aMethod put: result! !

!AbstractMethodWidget methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 10/12/2011 17:53'!
methodsIconsCache

	^ MethodsIconsCache! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/12/2011 14:45'!
methodsSelection

	^ self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/19/2011 18:12'!
removeAllFromMethodsIconsCache: aMethod

	^ self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/12/2011 17:56'!
selectedMethod

	^ self model selectedMethod! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/12/2011 17:57'!
selectedMethod: aMethod

	^ self model selectedMethod: aMethod! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/19/2011 17:19'!
selectedMethods

	^ self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/12/2011 17:57'!
showInstance

	^ self model showInstance! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/12/2011 17:55'!
takeKeyboardFocus

	^ self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 20:08'!
vScrollValue

	^ self subclassResponsibility! !

!AbstractMethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 20:08'!
vScrollValue: aNumber

	^ self subclassResponsibility! !

AbstractMethodWidget subclass: #MethodWidget
	instanceVariableNames: 'methodsList methodsGroup methodsSelection methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!MethodWidget commentStamp: '<historical>' prior: 0!
MethodWidget is the basic implementation of a wiget managing methods!

!MethodWidget class methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/20/2012 22:06'!
buildMethodShortcutsOn: aBuilder
	<keymap>	

	(aBuilder shortcut: #fullBrowse)
		category: #NautilusMethodShortcuts
		default: $b command
		do: [ :target | target fullBrowse ].
		
	(aBuilder shortcut: #categorizeMethod)
		category: #NautilusMethodShortcuts
		default: $c command shift
		do: [ :target | target categorizeMethod ].
	
	(aBuilder shortcut: #findMethod)
		category: #NautilusMethodShortcuts
		default: $f command
		do: [ :target | target findMethod ].
	
	(aBuilder shortcut: #methodHierarchy)
		category: #NautilusMethodShortcuts
		default: $i command
		do: [ :target | target enableMethodSingleSelection ifTrue: [ target methodHierarchy ]].
		
	(aBuilder shortcut: #generateTestMethodsAndFocus)
		category: #NautilusMethodShortcuts
		default: $j command
		do: [ :target | target generateTestMethodsAndFocus: true ].
		
	(aBuilder shortcut: #generateTestMethodsAndFocus)
		category: #NautilusMethodShortcuts
		default: $j command shift
		do: [ :target | target generateTestMethodsAndFocus: false ].
		
	(aBuilder shortcut: #browseMessages)
		category: #NautilusMethodShortcuts
		default: $m command
		do: [ :target | target enableMethodSingleSelection ifTrue: [ target browseMessages ]].
	
	(aBuilder shortcut: #browseSendersOfMessages)
		category: #NautilusMethodShortcuts
		default: $n command
		do: [ :target | target enableMethodSingleSelection ifTrue: [ target browseSendersOfMessages ]].
	
	(aBuilder shortcut: #runTestFor)
		category: #NautilusMethodShortcuts
		default: $t command
		do: [ :target | target runTestFor: target selectedMethods ].
		
	(aBuilder shortcut: #browseVersions)
		category: #NautilusMethodShortcuts
		default: $v command
		do: [ :target | target enableMethodSingleSelection ifTrue: [ target browseVersions ]].		
	
	(aBuilder shortcut: #removeMethods)
		category: #NautilusMethodShortcuts
		default: $x command
		do: [ :target | target removeMethods ].! !

!MethodWidget class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/21/2012 15:36'!
elementsMenu: aBuilder target: target
	<nautilusMethodMenu>
	| selectedMethods selectedMethod |
	
	selectedMethods := target selectedMethods.
	selectedMethod := target selectedMethod.
	(aBuilder item: #'Find Method... (f)')
		action: [ target findMethod ];
		order: 0;
		help: 'Search for a method by name'.
	
	target selectedMethod ifNotNil: [ 
		(aBuilder item: #'ToggleBreakPoint')
			action: [ target toggleBreakPoint ];
			order: 199;
			label: (selectedMethod hasBreakpoint
					ifFalse: [ 'Add breakpoint']
					ifTrue: [ 'Remove breakpoint'] )].
		
	(aBuilder item: #'Browse full (b)')
		action: [ target fullBrowse ];
		order: 200;
		withSeparatorAfter.
		
	target selectedMethod ifNil: [ ^ target ].
		
	(target selectedMethods allSatisfy: [:meth | meth isTestMethod ])
		ifTrue: [
			(aBuilder item: #'Run tests (t)')
				action: [ target runTestFor: selectedMethods ];
				order: 1000 ].
	
	(aBuilder item: #'Senders of...(n)')
		action: [ target browseSendersOfMessages ];
		order: 1100;
		enabledBlock: [ target enableMethodSingleSelection ].
		
	(aBuilder item: #'Implementors of... (m)')
		action: [ target browseMessages ];
		order: 1200;
		enabledBlock: [ target enableMethodSingleSelection ].
		
	(aBuilder item: #'Inheritance (i)')
		action: [ target methodHierarchy ];
		order: 1300;
		enabledBlock: [ target enableMethodSingleSelection ].
		
	(aBuilder item: #'Versions (v)')
		action: [ target browseVersions ];
		order: 1400;
		enabledBlock: [ target enableMethodSingleSelection ];
		withSeparatorAfter.
	
	(aBuilder item: #'Categorize method (C)')
		action: [ target categorizeMethod ];
		order: 1500.
		
	(aBuilder item: #'Move to package...')
		action: [ target moveMethodToPackage ];
		order: 1600.
		
	(aBuilder item: #'Remove... (x)')
		action: [ target removeMethods ];
		order: 1700;
		icon: (target iconClass iconNamed: #removeIcon);
		withSeparatorAfter.
		
	(aBuilder item: #'File Out')
		action: [ target fileOutMethods ];
		order: 1800! !

!MethodWidget methodsFor: 'item creation' stamp: 'BenjaminVanRyseghem 2/20/2012 21:58'!
buildMethodsList
	
	methodsList :=  PluggableIconListMorph new
						keystrokeSelector: #keyPressedOnElement:; 
						getIconSelector: #methodIconFor:;
						resetListSelector: #resetMethodsListSelection;
						getListSizeSelector: #methodListSize;
						getListElementSelector: #getMethodItem:; 
						autoDeselect: true;
						dragEnabled: true; 
						hResizing: #spaceFill;
						vResizing: #spaceFill;
						
						on: self
						list: #getMethods
						primarySelection: #selectedMethodIndex
						changePrimarySelection: #selectedMethodIndex:
						listSelection: #methodSelectionAt:
						changeListSelection: #methodSelectionAt:put:
						menu: #elementsMenu:shifted:
						keystroke: nil;
						
						attachKeymapCategory: #NautilusMethodShortcuts targetting: self model;
						wrapSelector: #methodWrapper:.
	
	methodsGroup := GroupboxMorph new
						addContentMorph: methodsList;
						label: self methodsLabel;
						hResizing: #spaceFill;
						vResizing: #spaceFill.
	^ methodsGroup! !

!MethodWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 19:11'!
getMethodItem: anIndex
	
	^ self getMethods at: anIndex! !

!MethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 19:04'!
getMethods

	^ methods ifNil: [ methods := self loadMethods ].! !

!MethodWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/22/2012 00:13'!
hasFocus
	
	^ methodsList hasKeyboardFocus! !

!MethodWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 10/12/2011 14:42'!
initialize

	super initialize.
	methodsSelection := Dictionary new.! !

!MethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/20/2012 21:51'!
keyPressedOnElement: anEvent
	| aCharacter |
	
	aCharacter := anEvent keyCharacter.
	
	aCharacter == Character arrowLeft ifTrue: [ ^ self model categoryWidget takeKeyboardFocus ].
	aCharacter == Character arrowRight ifTrue: [ ^ self model sourceTextArea takeKeyboardFocus ].! !

!MethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/12/2011 15:30'!
label: aString

	methodsGroup label: aString! !

!MethodWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/20/2012 17:27'!
loadMethods

	^ self model selectedCategories
		ifEmpty: [ self model methodsForCategory: self model allLabel ]
		ifNotEmpty: [:cat | self model methodsForCategories: cat ]! !

!MethodWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 19:11'!
methodListSize
	
	^ self getMethods size! !

!MethodWidget methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 10/12/2011 14:40'!
methodSelectionAt: anIndex

	| elt assoc |
	elt := self getMethods at: anIndex ifAbsent: [ ^ false ].
	
	(methodsSelection keys identityIncludes: elt) ifFalse: [ ^ false].
	
	assoc := methodsSelection associationAt: elt ifAbsent: [ ^ false ].
	assoc key selector = elt selector 
		ifTrue: [ ^ assoc value ]
		ifFalse: [ ^ false ]! !

!MethodWidget methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 10/12/2011 17:53'!
methodSelectionAt: anIndex put: aBoolean

	| element |
	element := self getMethods at: anIndex ifAbsent: [ ^ self ].
	methodsSelection at: element put: aBoolean.! !

!MethodWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/19/2012 14:29'!
methodWrapper: anItem

	| result |
	result := anItem selector.
	anItem category first = $*
		ifTrue: [ ^ result asMorph color: self model extensionColor ; yourself ].
	anItem isFromTrait
		ifTrue: [ 
			| trait |
			trait := anItem retrieveTraitIComeFrom.
			result := result, ' (', trait name ,')'.
			^ result asMorph emphasis: 2 ].
	^ result! !

!MethodWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 10/12/2011 15:34'!
methodsLabel

	^ self showInstance
		ifTrue: ['Instance methods']
		ifFalse: ['Class methods']! !

!MethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 10/12/2011 14:41'!
methodsSelection

	^ methodsSelection! !

!MethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 18:00'!
removeAllFromMethodsIconsCache: aMethod

	self methodsIconsCache keys do: [:method | 
		" for overrides "
		method selector = aMethod selector
			ifTrue: [ MethodsIconsCache removeKey: method ifAbsent: [ ]]].! !

!MethodWidget methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 2/7/2012 19:03'!
resetMethodCache

	methods := nil! !

!MethodWidget methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 10/12/2011 14:41'!
resetMethodsListSelection

	methodsSelection removeAll! !

!MethodWidget methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 10/12/2011 15:33'!
selectedMethodIndex

	^ self getMethods identityIndexOf: self selectedMethod ifAbsent: [ 0 ].! !

!MethodWidget methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 10/12/2011 17:57'!
selectedMethodIndex: anInteger

	| aMethod |
	aMethod :=  self getMethods at: anInteger ifAbsent: [ nil ].
	self selectedMethod: aMethod.

	self changed: #selectedMethodIndex.! !

!MethodWidget methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 1/24/2012 19:16'!
selectedMethods

	| associations |
	associations := self methodsSelection associations select: [:assoc | assoc value == true ] thenCollect: [:assoc | assoc key ].
	^ associations reject: [:each | each isNil ]! !

!MethodWidget methodsFor: 'private' stamp: 'BenjaminVanRyseghem 10/12/2011 18:01'!
takeKeyboardFocus

	methodsList takeKeyboardFocus! !

!MethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 20:09'!
vScrollValue

	^ methodsList scrollValue y! !

!MethodWidget methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 20:09'!
vScrollValue: aNumber

	^ methodsList vScrollValue: aNumber! !

AbstractWidget subclass: #AbstractPackageWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!AbstractPackageWidget commentStamp: '<historical>' prior: 0!
AbstractPackageWidget is an abstraction describing a widget used to manage packages!

AbstractPackageWidget subclass: #PackageWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus-Widgets'!

!PackageWidget commentStamp: '<historical>' prior: 0!
PackageWidget is the basic implementation of a wiget managing packages!

!AbstractWidget class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 10/12/2011 14:30'!
model: model

	^ self new
		model: model;
		yourself! !

!AbstractWidget methodsFor: 'drag and drop' stamp: 'BenjaminVanRyseghem 10/19/2011 17:16'!
dragTransferTypeForMorph: dragSource 

	^ (dragSource isKindOf: PluggableListMorph)
		ifTrue: [dragSource getListSelector]! !

!AbstractWidget methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 10/12/2011 17:38'!
iconClass

	^ iconClass ifNil: [ iconClass := NautilusIcons ].! !

!AbstractWidget methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 10/12/2011 15:49'!
iconClass: anObject
	
	iconClass := anObject! !

!AbstractWidget methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 10/12/2011 14:30'!
model

	^ model! !

!AbstractWidget methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 10/12/2011 15:38'!
model: anObject
	
	model := anObject.
	anObject addDependent: self.! !

!AbstractWidget methodsFor: 'update' stamp: 'BenjaminVanRyseghem 10/12/2011 15:37'!
update: aSymbol

	self changed: aSymbol! !

Object subclass: #Nautilus
	instanceVariableNames: 'announcer browsedEnvironment browsingHistory plugins selectedCategory selectedClass selectedGroup selectedMethod selectedPackage showCategories showComment showGroups showHierarchy showInstance showPackages ui uiClass'
	classVariableNames: 'CommentPosition HistoryMaxSize OpenOnGroups PluginClasses RecentClasses ShowAnnotationPane ShowHierarchy SwitchClassesAndPackages WarningLimit'
	poolDictionaries: ''
	category: 'Nautilus'!

Nautilus class
	instanceVariableNames: 'maxSize cachedLastClasses groups'!

!Nautilus commentStamp: '<historical>' prior: 0!
I'm a new browser based on RPackage and Announcements with fancy goodies:

	- groups ( you can create groups with your favorite classes)
	- multi-selections
	- environments
	- iconic buttons
	- hierarchy
	- pragma based menus!

Nautilus class
	instanceVariableNames: 'maxSize cachedLastClasses groups'!

!Nautilus class methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 1/30/2012 16:44'!
addGroupForClasses: aCollection named: aName

	self groupsManager addADynamicGroupSilentlyNamed: aName name block: [ aCollection ].! !

!Nautilus class methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 1/30/2012 16:43'!
addGroupForPackage: aPackage

	self groupsManager addADynamicGroupSilentlyNamed: aPackage name block: [ aPackage orderedClasses ].! !

!Nautilus class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/22/2011 11:37'!
browsedEnvironment: anEnvironment

	^ self new browsedEnvironment: anEnvironment! !

!Nautilus class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/28/2011 17:42'!
buildGroupManager

	| holder |
	holder := GroupsHolder new.
	(holder 
		addADynamicGroupSilentlyNamed: 'Most Viewed Classes' 
		block: [ self recentClassesElements ]) removable: false.
	(holder
		addADynamicGroupSilentlyNamed: 'Last Modified Classes'
		block: [ self lastModifiedClasses ]) removable: false.
		
	holder
		addAStaticGroupSilentlyNamed: 'Work' with: OrderedCollection new.
		
	^ holder
			! !

!Nautilus class methodsFor: 'settings' stamp: 'BenjaminVanRyseghem 2/6/2012 16:37'!
commentPosition

	^ CommentPosition ifNil: [ self defaultCommentPosition ]! !

!Nautilus class methodsFor: 'settings' stamp: 'BenjaminVanRyseghem 2/6/2012 16:37'!
commentPosition: aSymbol

	(self commentPositions includes: aSymbol) ifFalse: [ ^ self ].
	CommentPosition := aSymbol! !

!Nautilus class methodsFor: 'settings' stamp: 'BenjaminVanRyseghem 2/6/2012 16:36'!
commentPositions

	^ { #right. #bottom. #left. #top }! !

!Nautilus class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/2/2011 15:36'!
defaultAnnotationInfo
	"see annotationRequests comment"
	^ #(timeStamp messageCategory sendersCount implementorsCount allChangeSets)! !

!Nautilus class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/23/2012 17:32'!
defaultBrowsedEnvironment

	^ RBBrowserEnvironment new! !

!Nautilus class methodsFor: 'settings' stamp: 'BenjaminVanRyseghem 2/6/2012 16:36'!
defaultCommentPosition

	^ #right! !

!Nautilus class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/19/2011 11:06'!
defaultMaxSize

	^ NavigationHistory defaultMaxSize! !

!Nautilus class methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 2/8/2012 17:03'!
fullOnClass: aClass 

	^ self openOnClass: aClass! !

!Nautilus class methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 1/23/2012 20:11'!
fullOnClass: aClass selector: aSelector 

	^ aSelector
		ifNil: [ self openOnClass: aClass ]
		ifNotNil: [| method |
			method := aClass methodDict at: aSelector ifAbsent: [ nil ].
			method ifNotNil: [ self openOnMethod: method ]]! !

!Nautilus class methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 2/7/2012 10:37'!
fullOnEnvironment: anEnvironment

	self openInEnvironment: anEnvironment! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/2/2011 17:30'!
groupsManager

	^ groups ifNil: [ groups := self buildGroupManager]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/19/2011 11:05'!
historyMaxSize

	^ HistoryMaxSize ifNil: [ HistoryMaxSize := self defaultMaxSize ]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/19/2011 11:07'!
historyMaxSize: anInteger

	(anInteger isKindOf: Integer) ifFalse: [ ^ self ].
	anInteger > 0 ifFalse: [ ^ self ].
	HistoryMaxSize := anInteger! !

!Nautilus class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 8/2/2011 18:47'!
icon 

	^ AbstractNautilusUI icon! !

!Nautilus class methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 3/29/2011 11:25'!
importAGroup: aGroup

	self groupsManager addAGroup: aGroup! !

!Nautilus class methodsFor: 'class initialization' stamp: 'BenjaminVanRyseghem 2/18/2012 17:19'!
initialize

	groups ifNil: [ groups := self buildGroupManager ].
	SystemBrowser default: self! !

!Nautilus class methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 3/18/2011 16:26'!
lastModifiedClasses

	^ cachedLastClasses ifNil: [ cachedLastClasses := RecentMessageList uniqueInstance lastClasses: 10 ]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 15:45'!
maxSize

	^ maxSize ifNil: [ maxSize := 10]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 14:13'!
maxSize: anInteger

	maxSize := anInteger.
	self recentClasses maxSize: anInteger.! !

!Nautilus class methodsFor: 'settings' stamp: 'BenjaminVanRyseghem 2/22/2012 14:29'!
nautilusSettingsOn: aBuilder
	<systemsettings>
	
	(aBuilder group: #Nautilus)
		target: self;
		label: 'Nautilus' translated;
		description: 'Settings related to the browser' translated;
		with: [
			(aBuilder setting: #openOnGroups)
				label: 'Open the browser on groups ?' translated;
				description: 'If true, Nautilus will show groups when opened' translated ];
		with: [
			(aBuilder pickOne: #commentPosition)
				label: 'Position of the comment pane:' translated;
				target: self;
				default: self defaultCommentPosition;
				order: 1;
				domainValues: self commentPositions];
		with: [
			(aBuilder setting: #showHierarchy)
				label: 'Show hierarchy by default ?' translated;
				description: 'If false, Nautilus will show a flat list of classes' translated ];
		with: [
			(aBuilder setting: #historyMaxSize)
				label: 'Set the max size of the navigation history' translated;
				description: ('By default, the value is ', self defaultMaxSize printString) translated ];
		with: [
			(aBuilder setting: #switchClassesAndPackages)
				label: 'Switch lists when opening on a class ?' translated;
				description: 'Default value: false' translated ];
		with: [
			(aBuilder setting: #warningLimit)
				label: 'Set the warning limit of source code pane' translated;
				description: 'By default, the value is 350
Put a negative value to disable' translated ]! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/23/2011 13:06'!
open
	^ self openInEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 9/28/2011 18:09'!
openBrowserView: aNautilus label: aByteString 
	
	aNautilus open.
	aNautilus ui selectedMethod: aNautilus selectedMethod.
	aNautilus ui update! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/23/2011 13:05'!
openInEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance open.
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/26/2011 13:46'!
openOnCategory: aCategory ofClass: aClass

	^ self openOnCategory: aCategory ofClass: aClass inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/26/2011 13:45'!
openOnCategory: aCategory ofClass: aClass inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: aClass isMeta not.
	instance showGroups: false.
	instance package: aClass package class: aClass category: aCategory method: nil.
	instance open.
	
	instance ui methodsTree setSelectedNodeItem: aCategory.
	
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/22/2011 13:49'!
openOnClass: aClass

	^ self openOnClass: aClass inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 2/22/2012 14:25'!
openOnClass: aClass inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: aClass isMeta not.
	instance showGroups: false.
	instance package: aClass package class: aClass category: nil method: nil.
	instance open.
	instance ui showPackages: (self switchClassesAndPackages not).
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/25/2011 14:56'!
openOnClass: aClass onGroup: aGroup
	
	^ self openOnClass: aClass onGroup: aGroup inEnvironment: self defaultBrowsedEnvironment.! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/25/2011 14:55'!
openOnClass: aClass onGroup: aGroup inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: aClass isMeta not.
	instance showGroups: true.
	instance selectedGroup: aGroup.
	instance package: aClass package class: aClass category: nil method: nil.
	instance open.
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/22/2011 13:28'!
openOnGroup: aGroup

	^ self openOnGroup: aGroup inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/22/2011 13:28'!
openOnGroup: aGroup inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showGroups: true.
	instance selectedGroup: aGroup.
	instance open.
	^ instance! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 13:18'!
openOnGroups

	^ OpenOnGroups ifNil: [ OpenOnGroups := false ]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 13:20'!
openOnGroups:aBoolean

	OpenOnGroups := aBoolean! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/26/2011 13:19'!
openOnMethod: aMethod
	
	^ self openOnMethod: aMethod inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 9/16/2011 18:06'!
openOnMethod: aMethod inEnvironment: anEnvironment

	| instance class |
	class := aMethod methodClass.
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: class isMeta not.
	instance showGroups: false.
	instance package: class package class: class category: aMethod protocol asString method: aMethod.
	instance open.
		
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/22/2011 13:43'!
openOnPackage: aPackage

	^ self openOnPackage: aPackage inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/30/2011 16:28'!
openOnPackage: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod group: selectedGroup showGroups: showGroups showHierarchy: showHierarchy showPackages: showPackages showComment: showComment  showInstance: showInstance showCategories: showCategories

	^ self openOnPackage: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod group: selectedGroup showGroups: showGroups showHierarchy: showHierarchy showPackages: showPackages showComment: showComment  showInstance: showInstance showCategories: showCategories inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 5/13/2011 13:32'!
openOnPackage: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod group: selectedGroup showGroups: showGroups showHierarchy: showHierarchy showPackages: showPackages showComment: showComment  showInstance: showInstance showCategories: showCategories inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	
	instance package: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod.
	instance selectedGroup: selectedGroup.	
	instance
		showGroups: showGroups;
		showHierarchy: showHierarchy;
		showComment: showComment;
		showInstance: showInstance;
		showCategories: showCategories.
	
	instance open.
	instance ui showPackages: showPackages.
	instance ui forceSelection: selectedCategory.
	instance ui forceSelection: selectedMethod.

	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/22/2011 13:42'!
openOnPackage: aPackage inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showGroups: false.
	instance selectedPackage: aPackage.
	instance open.
	^ instance! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/25/2011 10:25'!
pluginClasses

	^ PluginClasses ifNil: [ PluginClasses := OrderedCollection new ].! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2011 16:42'!
pluginClasses: aCollection

	PluginClasses := aCollection! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 14:13'!
recentClasses

	^ RecentClasses ifNil: [ RecentClasses := HistoryCollection maxSize: self maxSize ]! !

!Nautilus class methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 3/18/2011 16:50'!
recentClassesElements

	^ self recentClasses mostViewedlements! !

!Nautilus class methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 3/18/2011 16:44'!
resetCachedLastClasses

	^ cachedLastClasses := nil! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/2/2011 14:55'!
showAnnotationPane: aBoolean

	ShowAnnotationPane := aBoolean! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 14:05'!
showHierarchy

	^ ShowHierarchy ifNil: [ ShowHierarchy := true ]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 14:06'!
showHierarchy: aBoolean

	ShowHierarchy := aBoolean! !

!Nautilus class methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/20/2011 06:44'!
stopNotifications
	" self stopNotifications "
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !

!Nautilus class methodsFor: 'settings' stamp: 'BenjaminVanRyseghem 2/8/2012 16:34'!
switchClassesAndPackages

	^ SwitchClassesAndPackages ifNil: [ SwitchClassesAndPackages := true ]! !

!Nautilus class methodsFor: 'settings' stamp: 'BenjaminVanRyseghem 2/8/2012 16:34'!
switchClassesAndPackages: aBoolean

	SwitchClassesAndPackages := aBoolean! !

!Nautilus class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 2/20/2012 22:24'!
taskbarIcon 

	^ AbstractNautilusUI icon! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/27/2011 15:07'!
warningLimit

	^ WarningLimit ifNil: [ WarningLimit := 350 ]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/27/2011 15:08'!
warningLimit: anInteger

	WarningLimit := anInteger! !

!Nautilus methodsFor: 'comparing' stamp: 'BenjaminVanRyseghem 4/11/2011 15:56'!
= aNautilus

	self class = aNautilus class ifFalse: [ ^ false ].
	1 to: self class instVarNames size do: [:index |
		(self instVarAt: index) = (aNautilus instVarAt: index)
			ifFalse: [ ^ false ]].
	^ true! !

!Nautilus methodsFor: 'history' stamp: 'BenjaminVanRyseghem 8/23/2011 21:07'!
adopt: anAssociation

	| nautilusWrapper |
	nautilusWrapper := anAssociation key.
	self ui ifNotNil: [:interface |
		interface resetSelections].
	self
		selectedPackage: nautilusWrapper selectedPackage;
		selectedClass: nautilusWrapper selectedClass;
		selectedCategory: nautilusWrapper selectedCategory.
		nautilusWrapper selectedMethod
			ifNil: [ self selectedMethod: nil ]
			ifNotNil: [:sel | self selectedMethod: ( nautilusWrapper selectedClass>>sel )].

	self
		selectedGroup: nautilusWrapper selectedGroup;
		showPackages: nautilusWrapper showPackages;
		showGroups: nautilusWrapper showGroups;
		showHierarchy: nautilusWrapper showHierarchy;
		showComment: nautilusWrapper showComment;
		showInstance: nautilusWrapper showInstance;
		showCategories: nautilusWrapper showCategories.
		
	self ui ifNotNil: [:interface |
		interface showPackages: self showPackages.
		interface
			selectedPackageWithoutChangingSelectionInternally: nautilusWrapper selectedPackage;
			selectedClassWithoutChangingSelectionInternally: nautilusWrapper selectedClass;
			selectedCategoryInternally: nautilusWrapper selectedCategory.
		nautilusWrapper selectedMethod
			ifNil: [ interface selectedMethodInternally: nil ]
			ifNotNil: [:sel | interface selectedMethodInternally: ( nautilusWrapper selectedClass>>sel )].
		interface updateBothView.
		interface update].! !

!Nautilus methodsFor: 'events-registering' stamp: 'BenjaminVanRyseghem 8/23/2011 21:29'!
announce: anAnnouncement

	self announcer announce: anAnnouncement
! !

!Nautilus methodsFor: 'announcement' stamp: 'BenjaminVanRyseghem 5/10/2011 12:33'!
announcer

	^ announcer ifNil: [ announcer := NautilusAnnouncer new ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/23/2012 19:06'!
browsedEnvironment

	^ browsedEnvironment ifNil: [ browsedEnvironment := RBBrowserEnvironment new ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 11:36'!
browsedEnvironment: anEnvironment

	browsedEnvironment := anEnvironment! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/11/2011 13:39'!
browsingHistory

	^ browsingHistory ifNil: [ browsingHistory := NavigationHistory new ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/1/2011 14:47'!
classes
	
	^ self browsedEnvironment classes! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 12:07'!
classesInTheSelectedPackage

	^ self selectedPackage
		ifNil: [{}]
		ifNotNil: [:package | 
			(package definedClasses asArray sort: [:a :b | a name <= b name]), (package extendedClasses asArray sort: [:a :b | a name <= b name])]! !

!Nautilus methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 1/23/2012 20:14'!
codeTextMorph

	^ self ui codeTextMorph! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/6/2012 16:47'!
commentPosition

	^ self class commentPosition! !

!Nautilus methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 1/23/2012 20:13'!
contents: aText

	self ui sourceCode: aText! !

!Nautilus methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 8/22/2011 13:59'!
defaultUIClass

	^ NautilusUI! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/6/2011 10:17'!
foundExtentionsIn: aClass

	^ aClass extendingPackages.
! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 14:49'!
groupsManager
	
	^ self class groupsManager! !

!Nautilus methodsFor: 'history' stamp: 'BenjaminVanRyseghem 5/12/2011 12:51'!
hasNext
	
	^self browsingHistory hasNext! !

!Nautilus methodsFor: 'history' stamp: 'BenjaminVanRyseghem 5/12/2011 12:51'!
hasPrevious
	
	^self browsingHistory hasPrevious! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/25/2011 12:53'!
initialize

	super initialize.
	plugins := OrderedCollection new.
	self class pluginClasses do: [:each || class position |
		class := each first.
		position := each second.
		plugins add: ((class model: self) position: position; yourself)]! !

!Nautilus methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 4/7/2011 15:41'!
labelString

	^ self ui
		ifNil: [ 'Nautilus' ]
		ifNotNil: [:UI | UI title ]! !

!Nautilus methodsFor: 'history' stamp: 'BenjaminVanRyseghem 5/12/2011 13:06'!
next

	self adopt: self browsingHistory next.
	self triggerEvent: #historyChanged.! !

!Nautilus methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/20/2011 05:49'!
open

	ui := (self uiClass on: self) open! !

!Nautilus methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 4/7/2011 15:42'!
openEditString: aString 

	" Dunno what to do"! !

!Nautilus methodsFor: 'history' stamp: 'BenjaminVanRyseghem 8/23/2011 21:33'!
package: aPackage class: aClass category: aCategory method: aMethod

	self 
		selectedPackage: aPackage;
		selectedClass: aClass;
		selectedCategory: aCategory;
		selectedMethod: aMethod.
		
	"self announce: ( NautilusPackageSelected package: aPackage ).
	self announce: ( NautilusClassSelected class: aClass ).
	self announce: ( NautilusCategorySelected category: aCategory ).
	self announce: ( NautilusMethodSelected method: aMethod ).	"
		
	self registerHistoryNewEntry.! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/19/2011 18:19'!
packages

	^ self browsedEnvironment packages asArray! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 09:59'!
packagesUsedByTheSelectedClass

	| result class |
	result := OrderedCollection new.
	class := self selectedClass.
	
	class ifNil: [^{}].
	result add: class package.
	result addAll: (self foundExtentionsIn: class).
	result := result intersection: self packages.
	^ result select:[:each | each notNil]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2011 14:52'!
plugins

	^ plugins ifNil: [ plugins := OrderedCollection new ]! !

!Nautilus methodsFor: 'history' stamp: 'BenjaminVanRyseghem 5/12/2011 13:06'!
previous

	self adopt: self browsingHistory previous.
	self triggerEvent: #historyChanged.! !

!Nautilus methodsFor: 'accessing' stamp: 'StephaneDucasse 3/17/2011 15:25'!
recentClasses

	^ self class recentClasses! !

!Nautilus methodsFor: 'history' stamp: 'BenjaminVanRyseghem 5/12/2011 13:07'!
registerHistoryNewEntry

	| wrapper |
	wrapper := NautilusWrapper with: self.
	self browsingHistory add: wrapper.
	self triggerEvent: #historyChanged.
	"should take care of ui's"! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedCategory

	^ selectedCategory! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/21/2011 13:31'!
selectedCategory: anObject

	selectedCategory := anObject.
	self selectedMethod: nil.
	self announcer announce: ( NautilusCategorySelected category: anObject )! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedClass

	^ selectedClass! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 8/21/2011 13:31'!
selectedClass: aClass

	selectedClass := aClass.
	self selectedCategory: nil.
	aClass ifNotNil: [ self recentClasses add: aClass theNonMetaClass ].
	self announcer announce: ( NautilusClassSelected class: aClass )! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 13:55'!
selectedGroup

	^ selectedGroup! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2011 17:15'!
selectedGroup: anObject

	selectedGroup := anObject.
	self announcer announce: ( NautilusGroupSelected group: anObject )! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedMethod

	^ selectedMethod! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2011 17:15'!
selectedMethod: anObject

	selectedMethod := anObject.
	self announcer announce: ( NautilusMethodSelected method: anObject )! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedPackage

	^ selectedPackage! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2011 12:29'!
selectedPackage: anObject

	selectedPackage := anObject.
	self announcer announce: ( NautilusPackageSelected package: anObject )! !

!Nautilus methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 5/12/2011 11:31'!
setClass: aClass selector: aSelector 
	
	| method protocol |
	method := aClass methodDict at: aSelector ifAbsent: [ nil ].
	protocol := method 
					ifNil: [ nil ]
					ifNotNil: [ method protocol ].
	self 
		showGroups: false;
		selectedPackage: aClass package;
		selectedClass: aClass;
		showInstance: aClass isMeta not;
		selectedCategory: protocol;
		selectedMethod: method
	! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 6/2/2011 17:36'!
shouldOpenOnGroups

	^ self class openOnGroups and: [ self class groupsManager isEmpty not ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:55'!
showCategories

	^ showCategories ifNil: [ showCategories := true ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/12/2011 11:24'!
showCategories: aBoolean

	showCategories := aBoolean.
	self announcer announce: ( NautilusShowCategoriesChanged boolean: aBoolean )! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:54'!
showComment

	^ showComment ifNil: [ showComment := false ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/12/2011 11:23'!
showComment: aBoolean

	showComment := aBoolean.
	self announcer announce: ( NautilusShowCommentChanged boolean: aBoolean )! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/2/2011 17:34'!
showGroups

	^ showGroups ifNil: [ showGroups := self shouldOpenOnGroups ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/12/2011 11:23'!
showGroups: aBoolean

	showGroups := aBoolean.
	self announcer announce: ( NautilusShowGroupsChanged boolean: aBoolean )! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 14:07'!
showHierarchy

	^ showHierarchy ifNil: [ showHierarchy := self class showHierarchy ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/12/2011 11:23'!
showHierarchy: aBoolean

	showHierarchy := aBoolean.
	self announcer announce: ( NautilusShowHierarchyChanged boolean: aBoolean )! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:55'!
showInstance

	^ showInstance ifNil: [ showInstance := true ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/12/2011 11:23'!
showInstance: aBoolean

	showInstance := aBoolean.
	self announcer announce: ( NautilusShowInstanceChanged boolean: aBoolean )! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:55'!
showPackages

	^ showPackages ifNil: [ showPackages := true ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/12/2011 11:23'!
showPackages: aBoolean

	showPackages := aBoolean.
	self announcer announce: ( NautilusShowPackagesChanged boolean: aBoolean )! !

!Nautilus methodsFor: 'browser compatibility' stamp: 'BenjaminVanRyseghem 4/7/2011 16:33'!
spawnHierarchy

	self 
		showHierarchy:true;
		open.
	self ui showPackages: false! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/8/2012 16:35'!
switchClassesAndPackages

	^ self class switchClassesAndPackages! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/25/2011 17:15'!
ui

	^ ui! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/2/2011 17:03'!
uiClass

	^ uiClass ifNil: [ self defaultUIClass ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/5/2011 11:45'!
uiClass: aClass

	uiClass := aClass! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/27/2011 15:42'!
warningLimit

	^ self class warningLimit! !
AbstractNautilusUI initialize!
Nautilus initialize!
